/**************************************************
    Entorno de Desarrollo Modular y Abierto
    EDMA 0.2r1
    (c) David Martnez Oliveira
    File generated by : EDMA IDF WIzard Tcl/Tk 0.1
------------------------------------------------------
    Module Type : CLASS IMPLEMENTATION
    Class List  : EDMAIDF_PARSER
    Description : Parser for EDMAIDF Files
    Author      : David Martnez Oliveira
    Date        : July 27th 1999
-----------------------------------------------------
  REVISIONS :
***************************************************/
 
 
#include <stdio.h>
#include <string.h>
#include "portable.h"
#include <edma.h>

/* Data structs for class EDMAIDF_PARSER*/
  
typedef struct
  {
    EPChar	FileName;
    PINIFILE	h;
  } DtEDMAIDF_PARSER;
 
EUint32  EDMAPROC EDMAIDF_PARSERGetNPropsU32(OBJID IdObj,EPUint32 n)
{
  DtEDMAIDF_PARSER	*m;
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  /* Put your code here */
  *n=GetINIInt(m->h,"Definition","PropertiesNum",0);
  ECoutObj(IdObj,"[Definition]PropertiesNum=%d",*n);
  return 0;
}

EUint32  EDMAPROC EDMAIDF_PARSERGetNMetsU32(OBJID IdObj,EPUint32 n)
{
  DtEDMAIDF_PARSER	*m;
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  *n=GetINIInt(m->h,"Definition","MethodsNum",0); 
  ECoutObj(IdObj,"[Definition]MethodsNum=%d",*n);
  return 0;
}
 
EUint32  EDMAPROC EDMAIDF_PARSERGetClassNamesZ(OBJID IdObj,EPChar buf)
{
  DtEDMAIDF_PARSER	*m;
  EUint32                 r;
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  r=GetINIString(m->h,"General","Name",NULL,buf,200);
  ECoutObj(IdObj,"[General]Name=%s",buf);
  return 0;
}

EUint32  EDMAPROC EDMAIDF_PARSERGetModuleNamesZ(OBJID IdObj,EPChar buf)
{
  DtEDMAIDF_PARSER	*m;
  EUint32                 r;
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  r=GetINIString(m->h,"SYS_DEF","ModuleName",NULL,buf,200);
  ECoutObj(IdObj,"[SYS_DEF]ModuleName=%s",buf);
  return 0;
}

EUint32  EDMAPROC EDMAIDF_PARSERGetSCListsZ(OBJID IdObj,EPChar buf)
{
  DtEDMAIDF_PARSER	*m;
  EUint32                 r;
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  r=GetINIString(m->h,"Definition","SCList",NULL,buf,200);
  ECoutObj(IdObj,"[Definition]SCList=%s",buf); 
  return 0;
}

EUint32  EDMAPROC EDMAIDF_PARSERGetPropNameU32sZ(OBJID IdObj,EUint32 n,EPChar buf)
{
  DtEDMAIDF_PARSER	*m;
  EChar                   Sec[80];
  EUint32                 r;
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
 
  sprintf (Sec,"Prop%ld",n);
  r=GetINIString(m->h,Sec,"Name",NULL,buf,200);
  ECoutObj(IdObj,"[%s]Name=%s",Sec,buf);
  
  return 0;
}

EUint32  EDMAPROC EDMAIDF_PARSERGetPropTypeU32sZ(OBJID IdObj,EUint32 n,EPChar buf)
{
  DtEDMAIDF_PARSER	*m;
  EChar                   Sec[80];
  EUint32                 r;
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  sprintf (Sec,"Prop%ld",n);
  r=GetINIString(m->h,Sec,"Type",NULL,buf,200);
  ECoutObj(IdObj,"[%s]Type=%s",Sec,buf); 
  return 0;
}

EUint32  EDMAPROC EDMAIDF_PARSERGetPropAccessU32sZ(OBJID IdObj,EUint32 n,EPChar buf)
{
  DtEDMAIDF_PARSER	*m;
  EChar                   Sec[80];
  EUint32                 r;
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  sprintf (Sec,"Prop%ld",n);
  r=GetINIString(m->h,Sec,"Access",NULL,buf,200);
  ECoutObj(IdObj,"[%s]Access=%s",Sec,buf);  
  return 0;
}

EUint32  EDMAPROC EDMAIDF_PARSERGetPropNElemsU32sU32(OBJID IdObj,EUint32 n,EPUint32 ne)
{
  DtEDMAIDF_PARSER	*m;
  EChar                   Sec[80];
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  sprintf (Sec,"Prop%ld",n);
  *ne=GetINIInt(m->h,Sec,"ArrayElems",0);
  ECoutObj(IdObj,"[%s]ArrayElems=%d",Sec,*ne); 
  return 0;
}

EUint32  EDMAPROC EDMAIDF_PARSERGetMetNameU32sZ(OBJID IdObj,EUint32 n,EPChar buf)
{
  DtEDMAIDF_PARSER	*m;
  EChar                   Sec[80];
  EUint32                 r;
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  sprintf (Sec,"Met%ld",n);
  r=GetINIString(m->h,Sec,"Name",NULL,buf,200);
  ECoutObj(IdObj,"[%s]Name=%s",Sec,buf);  
  
  return 0;
}

EUint32  EDMAPROC EDMAIDF_PARSERGetMetSignatureU32sZ(OBJID IdObj,EUint32 n,EPChar buf)
{
  DtEDMAIDF_PARSER	*m;
  EChar                   Sec[80];
  EUint32                 r;
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  sprintf (Sec,"Met%ld",n);
  r=GetINIString(m->h,Sec,"Signature",NULL,buf,200);
  ECoutObj(IdObj,"[%s]Signature=%s",Sec,buf);  
  return 0;
}

EUint32  EDMAPROC EDMAIDF_PARSERIsMetVirtualU32sU32(OBJID IdObj,EUint32 n,EPUint32 ne)
{
  DtEDMAIDF_PARSER	*m;
  EChar                   Sec[80];
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  sprintf (Sec,"Met%ld",n);
  *ne=GetINIInt(m->h,Sec,"Virtual",0);
  ECoutObj(IdObj,"[%s]Virtual=%d",Sec,*ne);  
  return 0;
}

EUint32  EDMAPROC EDMAIDF_PARSERIsMetAbstractU32sU32(OBJID IdObj,EUint32 n,EPUint32 ne)
{
  DtEDMAIDF_PARSER	*m;
  EChar                   Sec[80];
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  sprintf (Sec,"Met%ld",n);
  *ne=GetINIInt(m->h,Sec,"Abstract",0);
  ECoutObj(IdObj,"[%s]Abstract=%d",Sec,*ne);  
  return 0;
}

EUint32  EDMAPROC EDMAIDF_PARSERIsMetStaticU32sU32(OBJID IdObj,EUint32 n,EPUint32 ne)
{
  DtEDMAIDF_PARSER	*m;
  EChar                   Sec[80];
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  sprintf (Sec,"Met%ld",n);
  *ne=GetINIInt(m->h,Sec,"Static",0);
  ECoutObj(IdObj,"[%s]Static=%d",Sec,*ne);  
  return 0;
}

EUint32  EDMAPROC EDMAIDF_PARSEROpenZ(OBJID IdObj,EPChar name)
{
  DtEDMAIDF_PARSER	*m;
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  m->h=OpenINI(name); 
  return 0;
}
 
EUint32  EDMAPROC EDMAIDF_PARSERClose(OBJID IdObj)
{
  DtEDMAIDF_PARSER	*m;
  
  m=(DtEDMAIDF_PARSER*)GetRef3(IdObj);
  
  CloseINI(m->h);
  return 0;
}
 

