
/*
  EDMA Advanced Class EDMA_DOC_BUILDER
  Copyright (C) 1998-2000 David Martnez Oliveira

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.
*/

/*
**************************************************
    Entorno de Desarrollo Modular y Abierto (EDMA)
    EDMA 0.5.1r1
    (c) David Martnez Oliveira
    File generated by : EDMA IDF Wizard Gnomized 0.1
------------------------------------------------------
    Module Type : CLASS IMPLEMENTATION
    Class List  : EDMA_DOC_BUILDER
    Description : Build SGML DOC file for classes defined by CLASS_METADATA
    Author      : David Martnez Oliviera
    Date        : 26/02/2000
-----------------------------------------------------
  REVISIONS :
  * November, 17th, 2001
  * Changed to work with new CLASS_METADATA class
  * Generate info about static and abstract methods
***************************************************
*/
 
/*
***************************************************
  General Header Files
***************************************************
*/
 
#include <stdio.h>
#include <string.h>

/*
***************************************************
  EDMA Header Files
***************************************************
*/
 

/*
*******************************************************
Support Types
******************************************************
 */

#include <portable.h>
//#include <cdlink.h>
#include <edma.h>

#define NTYPES 16

EPChar   type[NTYPES]={ "EUint32","ESint32",
			"EUint16","ESint16",
			"EUint8","ESint8",
			"EByte","EWord","EDWord",
			"EChar","EBool",
			"EReal32","EReal64",
			"EPchar","EDMAT_BUFFER","OBJID"};
EPChar   typeid[NTYPES]={ "EUINT32","ESINT32",
			  "EUINT16","ESINT16",
			  "EUINT8","ESINT8",
			  "EBYTE","EWORD","EDWORD",
			  "ECHAR","EBOOL",
			  "EREAL32","EREAL64",
			  "EZSTRING","EBUFFER","EOBJECT"};


/*
***************************************************
  Method Declaration for class 
***************************************************
*/
 
ESint32 EDMAPROC EDMA_DOC_BUILDERbuildU32Z(OBJID IdObj,OBJID id,EPChar fname)
{
  FILE     *f;
  int      i,j,k,n;
  EChar    temp[256],temp1[256],temp2[256];
  ESint32  m_virtual,m_abstract,m_static;

  f=fopen(fname,"wt");
  if (f==NULL)
    {
      ECoutObj(IdObj,"Can't open file %s for writting",fname);
      return 1;
    }

  RProp3 (id,"ClassName" ,temp);
  fprintf (f,"\n<!doctype linuxdoc system>");
  fprintf (f,"\n<article>");
  fprintf (f,"\n<title>%s",temp);
  fprintf (f,"\n<author>Author Name <tt /name@host.domain/");
  fprintf (f,"\n<date>v major.minor.release Moth Year");
  fprintf (f,"\n<abstract>Brief description about what this class does");
  fprintf (f,"\n</abstract>");
  fprintf (f,"\n<!toc>");
  fprintf (f,"\n<sect>Description</sect>");
  fprintf (f,"\nHere comes the main class description and objectives");
  fprintf (f,"\n<sect>Dependences</sect>");
  fprintf (f,"\nList for class dependences on other classes and libraries.<p>");
  fprintf (f,"\nPossibly this section will include web references and cross reference.<p>");
  fprintf (f,"\n<sect>Class Diagram</sect>");
  fprintf (f,"\nClass diagram for this class. Maybe including some EPS figure.<p>");
  fprintf (f,"\nSuperclass list:<p>");
  fprintf (f,"\n<enum>");
  RProp3 (id,"nSC",&n);
  for (i=0;i<n;i++)
    {
      Met3(id,"GetSC",i,temp1);
      fprintf (f,"\n<item>%s:",temp1);
    }
  fprintf (f,"\n</enum>");
      
  fprintf (f,"\n<sect>Interface</sect>");
  fprintf (f,"\n<sect1>Properties</sect1>");
  fprintf (f,"\nProperties for this class.<p>");
  fprintf (f,"\n<enum>");
  RProp3 (id,"nProp",&n);
  for (i=0;i<n;i++)
    {
      fprintf (f,"\n<item>");
      Met3 (id,"GetProp",i,temp,temp1,temp2,&k);
      fprintf (f,"  %s",temp);
      if (k)
	fprintf (f,"[%d]",k);

      for (j=0;j<NTYPES;j++)
	if (strcmp(temp1,typeid[j])==0)
	  break;
      if (j==NTYPES)
	fprintf (f,"(<b>UNKNOW</b>)");
      else
	fprintf (f,"(<b>%s</b>:%s)",type[j],temp2);
      fprintf (f,": Description for this property");
    }
  fprintf (f,"\n</enum>");
  fprintf (f,"\n<sect1>Methods</sect1>");
  fprintf (f,"\nMethod list for this class.<p>");
  fprintf (f,"\n<enum>");  
  RProp3 (id,"nMet",&n);
  for (i=0;i<n;i++)
    {
      fprintf (f,"\n<item>");
      Met3 (id,"GetMet",i,temp,temp1,&m_virtual,&m_static,&m_abstract);

      if (m_virtual)
	fprintf (f,"<i>VIRTUAL</i>");
      if (m_abstract)
	fprintf (f,"<i>ABSTRACT</i>");
      if (m_static)
	fprintf (f,"<i>STATIC</i>");

      fprintf (f,"%s (Signature :%s): Description for this method",temp,temp1);	
    }
  fprintf (f,"\n</enum>");
  fprintf (f,"\n");
  fprintf (f,"\n</article>");
  fprintf (f,"\n");

  fclose (f);
  return 0;

}



/********** END C IMPLEMENTATION SKELETON ******************/
