
/*
  EDMA Advanced Class NFILE1
  Copyright (C) 1998-2000 David Martnez Oliveira

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.
*/

/*
**************************************************
    Entorno de Desarrollo Modular y Abierto (EDMA)
    EDMA 0.5.1r1
    (c) David Martnez Oliveira
    File generated by : EDMA IDF Wizard Gnomized 0.1
------------------------------------------------------
    Module Type : CLASS IMPLEMENTATION
    Class List  : GZFILE
    Description : Gzipped Files. Inherints from STREAM1
                  We'll use this class for testing dynamic
		  inheritance new features in GNU EDMA
    Author      : David Martnez Oliveira
    Date        : December, 6th, 2001
-----------------------------------------------------
  REVISIONS :
***************************************************
*/
 
/*
***************************************************
  General Header Files
***************************************************
*/
 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <zlib.h>

/*
***************************************************
  EDMA Header Files
***************************************************
*/
 
#include <edma.h>

/*
***************************************************
  Private Data Struct for class GZFILE
***************************************************
*/
 
typedef struct
  {
    /*ESint32		handler;*/
    gzFile                handler;
    EDMAT_BUFFER	buffer;
}DtGZFILE;
/*
***************************************************
  Method Declaration for class buffer
***************************************************
*/
 
ESint32 EDMAPROC GZFILEopenZZrS32(OBJID IdObj,EPChar name, EPChar mode)
{
  DtGZFILE	*m;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  if ((m->handler=gzopen (name,mode))==NULL) {
    ECoutObj (IdObj,"Can't open file %s:",name);
    return -1;
  }
  
  return 0;
}


ESint32 EDMAPROC GZFILEcloserS32(OBJID IdObj)
{
  DtGZFILE	*m;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  
  return gzclose (m->handler);
}


ESint32 EDMAPROC GZFILEreadsAsS32rS32(OBJID IdObj,EDMAT_BUFFER *buf,EPSint32 len)
{
  DtGZFILE	*m;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  if (buf)
    if (buf->Size<*len) {
      ECoutObj (IdObj,"Not enough allocated space to read data.");
      ECoutObj (IdObj,"Using Buffer size: %ld",buf->Size);
      *len=buf->Size;
    }
  *len=gzread (m->handler,buf->dat,*len);

  return *len;
}


ESint32 EDMAPROC GZFILEwriteAsS32rS32(OBJID IdObj,EDMAT_BUFFER buf, EPSint32 len)
{
  DtGZFILE	*m;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  *len = gzwrite (m->handler,buf.dat,*len);
  return *len;
}


ESint32 EDMAPROC GZFILEputsZS32rS32(OBJID IdObj,EPChar s,ESint32 len)
{
  DtGZFILE	*m;
  EPChar        s1;
  ESint32       l;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  s1=strdup(s);
  l=len;
  if (l > strlen (s1))
    l=strlen(s1);
  else
    s1[l]=0;
  gzputs (m->handler,s1);
  free (s1);
  return l;
}


ESint32 EDMAPROC GZFILEputcCS32rS32(OBJID IdObj,EChar c)
{
  DtGZFILE	*m;

  m=(DtGZFILE*)GetRef3(IdObj);
  return gzputc (m->handler,c);
}


/*ESint32 EDMAPROC GZFILEgetssZsS32rS32(OBJID IdObj,EPChar s, EPSint32 len)*/
EPChar EDMAPROC GZFILEgetssZsS32rS32(OBJID IdObj,EPChar s, EPSint32 len)
{
  DtGZFILE	*m;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  return gzgets(m->handler,s,*len);

}


ESint32 EDMAPROC GZFILEgetcsCrS32(OBJID IdObj,EPChar c)
{
  DtGZFILE	*m;
  int           r;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  r=gzgetc(m->handler);
  *c=(char)r;
  return r;
}


ESint32 EDMAPROC GZFILEflushrS32(OBJID IdObj)
{
  DtGZFILE	*m;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  /* FIXME: zlib allows various types of flushing*/
  return gzflush (m->handler,Z_SYNC_FLUSH);

}


ESint32 EDMAPROC GZFILEseekS32ZrS32(OBJID IdObj,ESint32 off,EPChar where)
{
  DtGZFILE	*m;
  int           w;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  if (strcmp (where,"SEEK_SET")==0)
    w=SEEK_SET;
  else { 
    if (strcmp (where,"SEEK_END")==0) {
      /*w=SEEK_END;*/
      ECoutObj (IdObj,"SEEK_END nor supported by zlib");
      return -1;
    }
    else
      w=SEEK_CUR;
  }
  return gzseek (m->handler,off,w);
	
}


ESint32 EDMAPROC GZFILEtellsS32rS32(OBJID IdObj,EPSint32 off)
{
  DtGZFILE	*m;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  *off = gztell(m->handler);
  return *off;
}


ESint32 EDMAPROC GZFILErewindrS32(OBJID IdObj)
{
  DtGZFILE	*m;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  /*fseek (m->handler,0,SEEK_SET);*/
  gztell(m->handler);
  return 0;
}


ESint32 EDMAPROC GZFILEeofrS32(OBJID IdObj)
{
  DtGZFILE	*m;
 
  m=(DtGZFILE*)GetRef3(IdObj);
  return gzeof (m->handler);
}


ESint32 EDMAPROC GZFILEerrorrS32(OBJID IdObj)
{
  DtGZFILE	*m;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  ECoutObj (IdObj,"Method still not implemented");
  return 0;
}


ESint32 EDMAPROC GZFILELoadZsArS32(OBJID IdObj,EPChar Name,EDMAT_BUFFER *buf)
{
  DtGZFILE	*m;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  ECoutObj (IdObj,"Method still not implemented");
  return 0;
}


ESint32 EDMAPROC GZFILESaveZArS32(OBJID IdObj)
{
  DtGZFILE	*m;
  
  m=(DtGZFILE*)GetRef3(IdObj);
  ECoutObj (IdObj,"Method still not implemented");
  return 0;
}



/********** END C IMPLEMENTATION SKELETON ******************/
