
/*
  EDMA Advanced Class NFILE1
  Copyright (C) 1998-2000 David Martnez Oliveira

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.
*/

/*
**************************************************
    Entorno de Desarrollo Modular y Abierto (EDMA)
    EDMA 0.5.1r1
    (c) David Martnez Oliveira
    File generated by : EDMA IDF Wizard Gnomized 0.1
------------------------------------------------------
    Module Type : CLASS IMPLEMENTATION
    Class List  : NFILE1
    Description : Native File. Inherints from STREAM1
                  We'll use this class for testing dynamic
		  inheritance new features in GNU EDMA
    Author      : David Martnez Oliveira
    Date        : December, 6th, 2001
-----------------------------------------------------
  REVISIONS :
***************************************************
*/
 
/*
***************************************************
  General Header Files
***************************************************
*/
 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
/*
***************************************************
  EDMA Header Files
***************************************************
*/
 
#include <edma.h>

/*
***************************************************
  Private Data Struct for class NFILE1
***************************************************
*/
 
typedef struct
  {
    /*ESint32		handler;*/
    FILE                *handler;
     EDMAT_BUFFER	buffer;
}DtNFILE1;
/*
***************************************************
  Method Declaration for class buffer
***************************************************
*/
 
ESint32 EDMAPROC NFILE1openZZrS32(OBJID IdObj,EPChar name, EPChar mode)
{
  DtNFILE1	*m;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  if ((m->handler=fopen (name,mode))==NULL) {
    ECoutObj (IdObj,"Can't open file %s:",name);
    return -1;
  }
  
  return 0;
}


ESint32 EDMAPROC NFILE1closerS32(OBJID IdObj)
{
  DtNFILE1	*m;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  
  return fclose (m->handler);
}


ESint32 EDMAPROC NFILE1readsAsS32rS32(OBJID IdObj,EDMAT_BUFFER *buf,EPSint32 len)
{
  DtNFILE1	*m;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  if (buf)
    if (buf->Size<*len) {
      ECoutObj (IdObj,"Not enough allocated space to read data.");
      ECoutObj (IdObj,"Using Buffer size: %ld",buf->Size);
      *len=buf->Size;
    }
  *len=(size_t)fread (buf->dat,1,*len,m->handler);

  return *len;
}


ESint32 EDMAPROC NFILE1writeAsS32rS32(OBJID IdObj,EDMAT_BUFFER buf, EPSint32 len)
{
  DtNFILE1	*m;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  *len = fwrite (buf.dat,1,*len,m->handler);
  return *len;
}


ESint32 EDMAPROC NFILE1putsZS32rS32(OBJID IdObj,EPChar s,ESint32 len)
{
  DtNFILE1	*m;
  EPChar        s1;
  ESint32       l;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  s1=strdup(s);
  l=len;
  if (l > strlen (s1))
    l=strlen(s1);
  else
    s1[l]=0;
  fputs (s1,m->handler);
  free (s1);
  return l;
}


ESint32 EDMAPROC NFILE1putcCS32rS32(OBJID IdObj,EChar c)
{
  DtNFILE1	*m;

  m=(DtNFILE1*)GetRef3(IdObj);
  return putc (c,m->handler);
}


/*ESint32 EDMAPROC NFILE1getssZsS32rS32(OBJID IdObj,EPChar s, EPSint32 len)*/
EPChar EDMAPROC NFILE1getssZsS32rS32(OBJID IdObj,EPChar s, EPSint32 len)
{
  DtNFILE1	*m;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  return fgets(s,*len,m->handler);

}


ESint32 EDMAPROC NFILE1getcsCrS32(OBJID IdObj,EPChar c)
{
  DtNFILE1	*m;
  int           r;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  r=fgetc(m->handler);
  *c=(char)r;
  return r;
}


ESint32 EDMAPROC NFILE1flushrS32(OBJID IdObj)
{
  DtNFILE1	*m;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  return fflush (m->handler);

}


ESint32 EDMAPROC NFILE1seekS32ZrS32(OBJID IdObj,ESint32 off,EPChar where)
{
  DtNFILE1	*m;
  int           w;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  if (strcmp (where,"SEEK_SET")==0)
    w=SEEK_SET;
  else { 
    if (strcmp (where,"SEEK_END")==0)
      w=SEEK_END;
    else
      w=SEEK_CUR;
  }
  return fseek (m->handler,off,w);
	
}


ESint32 EDMAPROC NFILE1tellsS32rS32(OBJID IdObj,EPSint32 off)
{
  DtNFILE1	*m;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  *off = ftell(m->handler);
  return *off;
}


ESint32 EDMAPROC NFILE1rewindrS32(OBJID IdObj)
{
  DtNFILE1	*m;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  fseek (m->handler,0,SEEK_SET);
  return 0;
}


ESint32 EDMAPROC NFILE1eofrS32(OBJID IdObj)
{
  DtNFILE1	*m;
 
  m=(DtNFILE1*)GetRef3(IdObj);
  return feof (m->handler);
}


ESint32 EDMAPROC NFILE1errorrS32(OBJID IdObj)
{
  DtNFILE1	*m;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  ECoutObj (IdObj,"Method still not implemented");
  return 0;
}


ESint32 EDMAPROC NFILE1LoadZsArS32(OBJID IdObj,EPChar Name,EDMAT_BUFFER *buf)
{
  DtNFILE1	*m;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  ECoutObj (IdObj,"Method still not implemented");
  return 0;
}


ESint32 EDMAPROC NFILE1SaveZArS32(OBJID IdObj)
{
  DtNFILE1	*m;
  
  m=(DtNFILE1*)GetRef3(IdObj);
  ECoutObj (IdObj,"Method still not implemented");
  return 0;
}



/********** END C IMPLEMENTATION SKELETON ******************/
