/*
 * EDMA CLASS: NFILE
 * (Basic Class)
 * Version: 0.0
 * Copyright (C) 1998  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/**************************************************
    Entorno de Desarrollo Modular y Abierto
    EDMA 0.2r1
    (c) David Martnez Oliveira
    File generated by : EDMA IDF WIzard Tcl/Tk 0.1
------------------------------------------------------
    Module Type : CLASS IMPLEMENTATION
    Class List  : NFILE
    Description : Native File CLass
    Author      : David Martinez Oliveira
    Date        : 19/11/1997
-----------------------------------------------------
  REVISIONS :
--------------------------------------------------
04/03/2000: Finishing method implementation
  Fix: Open mode for Open Method
  Fix: Operation on "FILE EXIST" for Save Method
***************************************************/
 
 
#include <stdio.h>
#include <string.h>
#include <edma.h>

//#include "portable.h"
//#include "cdlink.h"
// Data structs for class NFILE
 
 
typedef struct
  {
    FILE	*f;
  } DtNFILE;
 
// Method Implementation for class $gnc
 
 
EUint32  EDMAPROC NFILEOpenZ(OBJID IdObj,EPChar Name)
{
   DtNFILE	*m;
 
   m=(DtNFILE*)GetRef3(IdObj);
 
   // Put your code here
   m->f=fopen(Name,"rb");
   if (m->f==NULL)
     {
	ECoutObj(IdObj,"Can't open file %s",Name);
	return 1;
     }
   
return 0;
}
 
EUint32  EDMAPROC NFILEClose(OBJID IdObj)
{
   DtNFILE	*m;
 
   m=(DtNFILE*)GetRef3(IdObj);
 
   // Put your code here
   fclose (m->f);
   m->f=NULL;
 
return 0;
}
 
EUint32  EDMAPROC NFILEWriteAU32(OBJID IdObj,EDMAT_BUFFER Buf,EUint32 i)
{
  DtNFILE	*m;
  ESint32       n;
  
  m=(DtNFILE*)GetRef3(IdObj);
  
  // Put your code here
  n=fwrite (Buf.dat,sizeof(char),i,m->f);
  
  return n;
}
 

/*
  Caller must allocate buffer
 */

EUint32  EDMAPROC NFILEReadAsU32(OBJID IdObj,EDMAT_BUFFER Buf,EPUint32 i)
{
  DtNFILE	*m;
  ESint32       n;
  
  m=(DtNFILE*)GetRef3(IdObj);

  ECoutObj(IdObj,"[read] Running");
  // Put your code here
  if (*i>Buf.Size)
    {
      ECoutObj(IdObj,"Buffer is small. Only %d byte of %d requested",Buf.Size,i);
      return -1;
    }
  // Cleanup buffer
  memset (Buf.dat,0,Buf.Size);
  n=fread (Buf.dat,sizeof(char),*i,m->f);
  /*If no error, return bytes read*/
  if (n!=-1)
    *i=n;
  return n;
}
 
EUint32  EDMAPROC NFILELoadZsA(OBJID IdObj,EPChar Name,EDMAT_BUFFER *Buf)
{
   DtNFILE	*m;
   EUint32      tam;
 
   m=(DtNFILE*)GetRef3(IdObj);
 
   // Put your code here
   Met3(IdObj,"Open",Name);
   fseek(m->f,0,SEEK_END);
   tam=ftell(m->f);
   ECoutObj(IdObj,"Load : File size %d bytes",tam);
/*   
   Buf->Size=tam;
   Buf->h=PAlloc(tam);
   if (Buf->h==0)
     {
	ECoutObj(IdObj,"(ERROR) Can't alloc memory for load file");
	Met3(IdObj,"Close");
	return 1;
      }
   Buf->dat=PGet(Buf->h);
 */
   Buf->Size=0;
   EBufferAlloc(Buf,tam);
   if (Buf->Size==0)
     {
	ECoutObj(IdObj,"(ERROR) Can't alloc memory for load file");
	Met3(IdObj,"Close");
	return 1;
      }     
   fseek(m->f,0,SEEK_SET);
   fread(Buf->dat,1,tam,m->f);
   Met3(IdObj,"Close");

return 0;
}
 
EUint32  EDMAPROC NFILESaveZA(OBJID IdObj,EPChar Name,EDMAT_BUFFER Buf)
{
  DtNFILE	*m;
  
  m=(DtNFILE*)GetRef3(IdObj);
  
  // Put your code here
  m->f=fopen(Name,"wb");
  if (m->f==NULL)
    {
      printf ("\nCan't open file %s for writting",Name);
      return -1;
    }
  fwrite(Buf.dat,1,Buf.Size,m->f);
  fclose(m->f);
  
  return 0;
}
 
