/*
 * EDMA Advanced Class ID
 * Copyright (C) 1998-2000  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/**************************************************
    Entorno de Desarrollo Modular y Abierto
    EDMA 0.5.1r1
    (c) David Martnez Oliveira
    File generated by : EDMA IDF WIzard Tcl/Tk 0.1
------------------------------------------------------
    Module Type : CLASS IMPLEMENTATION
    Class List  : ID
    Description : Class Identifier
    Author      : David Martnez Oliveira
    Date        : 18 de Noviembre de 1997
-----------------------------------------------------
  REVISIONS :
 * 18/11/1997
    First Implementation
 * 27/02/2000
   Added to EDMA 0.5.1 and revised. A description field will be
   added to the class database.
***************************************************/
 
 
#include <stdio.h>
#include <string.h>
#include <edma.h>
 
typedef struct
  {
    EUint32	  nElems;
    EDMAT_BUFFER  List;
  } DtID;

/* Type for class list*/
#define MAX_ID    64
typedef struct
{
  EChar   ClassName[50];    /* Class Name  */
  EChar   StringId[50];     /* Class's string identifier */
  EChar   ByteId[50];       /* Class's byte string identifier */
  EChar   Description[80];  /* Class's description */
  EUint32 Offset;           /* Offset for byte string identifier */
} ID_LIST;
 
EUint32  EDMAPROC IDborn(OBJID IdObj)
{
DtID	*m;
 
m=(DtID*)GetRef3(IdObj);
return 0;
}
 
EUint32  EDMAPROC IDrip(OBJID IdObj)
{
  DtID	*m;
  
  m=(DtID*)GetRef3(IdObj);
  
  EBufferFree (&m->List);

  return 0;
}
 
EUint32  EDMAPROC IDGetClassZsZ(OBJID IdObj,EPChar Id,EPChar *Result)
{
  DtID	     *m;
  EUint32   i;
  ID_LIST   *Aux;
  
  m=(DtID*)GetRef3(IdObj);
  
  Aux=(ID_LIST*)(m->List.dat);
  for (i=0;i<m->nElems;i++) {
      if (strcmp(Aux[i].StringId,Id)==0)
	break;
    }
  if (i!=m->nElems)
    *Result=Aux[i].ClassName;
  else {
	*Result=NULL;
	ECoutObj(IdObj,"No class matches %s",Id);
    }
  
  return 0;
}

EUint32  EDMAPROC IDGetClassExZZsZ(OBJID IdObj,EPChar Id,EPChar Id1,EPChar *Result)
{
  DtID	*m;
  
  m=(DtID*)GetRef3(IdObj);
  
  ECoutObj(IdObj,"GetClassEx not implemented");
  
  return 0;
}

EUint32  EDMAPROC IDSetDBZ(OBJID IdObj,EPChar Name)
{
  DtID	    *m;
  FILE     *f;
  EUint32  i,n;
  ID_LIST  *Aux;
  EChar    temp[128];
  
  m=(DtID*)GetRef3(IdObj);
  
  EBufferAlloc(&m->List,sizeof(ID_LIST)*MAX_ID);
  if (m->List.h==0) {
      ECoutObj(IdObj,"Can't create shared memory block");
      return 1;
    }
  f=fopen(Name,"rt");
  if (f==NULL) {
      ECoutObj(IdObj,"Can't open config file %s",Name);
      EBufferFree(&m->List);
      return 1;
    }
  /* Read n clases from file */
  fscanf (f,"%ld\n",&n);
  ECoutObj(IdObj,"DB File has %d class identifiers",n);
  m->nElems=n;
  Aux=(ID_LIST*)(m->List.dat);
  for (i=0;i<n;i++)
    {
      fgets (temp,128,f);
      strcpy (Aux[i].ClassName,strtok(temp,":"));
      strcpy (Aux[i].StringId,strtok(NULL,":"));
      strcpy (Aux[i].Description,strtok(NULL,":"));
      Aux[i].Description[strlen(Aux[i].Description)-1]=0;
    }
  fclose (f);
  return 0;
}


EUint32 EDMAPROC IDGetItemU32sZsZsZ (OBJID IdObj,EUint32 i,EPChar cn,EPChar sid,EPChar des)
{
  DtID	*m;
  ID_LIST  *Aux;
  
  m=(DtID*)GetRef3(IdObj); 
  Aux=(ID_LIST*)(m->List.dat);
  strcpy (cn,Aux[i].ClassName);
  strcpy (sid,Aux[i].StringId);
  strcpy (des,Aux[i].Description);

  return 0;
}

EUint32  EDMAPROC IDAddItemZZZ(OBJID IdObj)
{
  DtID	*m;
  
  m=(DtID*)GetRef3(IdObj);
  
  ECoutObj(IdObj,"AddItem not implemented");
  
  return 0;
}

EUint32  EDMAPROC IDDeleteItemZZ(OBJID IdObj)
{
  DtID	*m;
  
  m=(DtID*)GetRef3(IdObj);
  
  ECoutObj(IdObj,"DeleteItem not implemented");
  
  return 0;
}







