#include <stdio.h>
#include <string.h>
#include <edma.h>

#include <fconfig.h>

ESint32 EDMAPROC EDMA_SIMPLEIDFParseU32(OBJID id, CLASSID idc) {
  EChar     fn[2048];
  EChar     path[1024];
  EChar     aux[50];
  EChar    name[50],type[50],sig[50],access[50];
  ESint32   m_virtual,m_static,m_abstract;
  ESint32   i, n_elems,nProp,nMet;
  //int   i,j, n_elem,nProp,nMet,nSC;
  PFCONFIG  cfg;

  /* Get IDF directory*/
  GetSystemPath(path);
  GetClaseName(idc,aux);
  sprintf (fn,"%s/share/edma/idf/%s.sidf",path,aux);

  ECoutObj (id,"Using IDF file : %s",fn);
  /* Open file to parse*/
  if ((cfg=fconfig_new(fn,',',1))==NULL) {
    ECoutErr ("Can't open configuration file: %s",fn);
    return 1;
  }
  
  /* Get General information. Porperty, Method and Superclass Number*/
  fconfig_get_long (cfg,"Properties",&nProp);
  fconfig_get_long (cfg,"Methods",&nMet);

  IDFSetDef (idc,nProp,nMet,0);

  /* Set properties*/
  for (i=0;i<nProp;i++) {
    memset (name,0,50);
    memset (type,0,50);
    memset (sig,0,50);
    memset (access,0,50);
    sprintf (aux,"Prop.%ld.Name",i);
    fconfig_get_string (cfg,aux,&name);
    /*fconfig_get_string (cfg,aux,name);*/
    sprintf (aux,"Prop.%ld.Type",i);
    fconfig_get_string (cfg,aux,&type);
    /*fconfig_get_string (cfg,aux,type);*/
    sprintf (aux,"Prop.%ld.Access",i);
    fconfig_get_string (cfg,aux,&access);
    /*fconfig_get_string (cfg,aux,access);*/
    sprintf (aux,"Prop.%ld.ArrayElems",i);
    fconfig_get_long (cfg,aux,&n_elems);
    ECoutObj  (id,"%s %s %s %d",name, type,access,n_elems);
    IDFSetProp (idc,i,name,type,access,n_elems);
  }
  /* Set Methods */
  for (i=0;i<nMet;i++) {
    memset (name,0,50);
    memset (type,0,50);
    memset (sig,0,50);

    sprintf (aux,"Met.%ld.Name",i);
    fconfig_get_string (cfg,aux,&name);
    /*fconfig_get_string (cfg,aux,name);*/
    sprintf (aux,"Met.%ld.Signature",i);
    fconfig_get_string (cfg,aux,&sig);
    /*fconfig_get_string (cfg,aux,sig);*/
    sprintf (aux,"Met.%ld.Virtual",i);
    fconfig_get_long (cfg,aux,&m_virtual);
    sprintf (aux,"Met.%ld.Abstract",i);
    fconfig_get_long (cfg,aux,&m_abstract);
    sprintf (aux,"Met.%ld.Static",i);
    fconfig_get_long (cfg,aux,&m_static);
    IDFSetMet (idc,i,name,sig,m_virtual,m_abstract,m_static); 
  }
  /* Set Superclasses*/
  //if ((fconfig_get_string (cfg,"Superclasses",&aux))!=-1)
  /*
  if ((fconfig_get_string (cfg,"Superclasses",aux))!=-1)
    IDFSetSCList(idc,aux);
  */
  IDFSetClassID(idc);

  return 0;
}
