
/*
  EDMA Advanced Class RUNABLE
  Copyright (C) 1998-2000 David Martnez Oliveira

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.
*/

/*
**************************************************
    Entorno de Desarrollo Modular y Abierto (EDMA)
    EDMA 0.5.1r1
    (c) David Martnez Oliveira
    File generated by : EDMA IDF Wizard Gnomized 0.1
------------------------------------------------------
    Module Type : CLASS IMPLEMENTATION
    Class List  : RUNABLE
    Description :
    Author      :
    Date        :
-----------------------------------------------------
  REVISIONS :
***************************************************
*/
 
/*
***************************************************
  General Header Files
***************************************************
*/
 
#include <stdio.h>
#include <string.h>

#include <pthread.h>

/*
***************************************************
  EDMA Header Files
***************************************************
*/
 
#include <edma.h>

/*
***************************************************
  Private Data Struct for class RUNABLE
***************************************************
*/
 
typedef struct
  {
     EUint32		thread;
     OBJID		id;
}DtRUNABLE;

typedef struct s_par {
  OBJID     idProxy;
  OBJID     id;
  EPChar    name;
  EPVoid    pars;
} TH_PAR;


int threaded_func (void *pars);
/*
***************************************************
  Method Declaration for class id
***************************************************
*/
 
ESint32 EDMAPROC RUNABLENewObj(OBJID IdObj,EPChar name)
{
  DtRUNABLE	*m;

  m=(DtRUNABLE*)GetRef3(IdObj);
  m->id=NewObj (name,NULL);

  return 0;
}


ESint32 EDMAPROC RUNABLEFreeObj(OBJID IdObj)
{
  DtRUNABLE	*m;

  m=(DtRUNABLE*)GetRef3(IdObj);
  FreeObj (m->id);
  return 0;
}


ESint32 EDMAPROC RUNABLEWProp3(OBJID IdObj,CLASSID id,EPChar name,EPVoid par)
{
  DtRUNABLE	*m;

  m=(DtRUNABLE*)GetRef3(IdObj);
  
  return EDMAWProp3(m->id,name,par);
}


ESint32 EDMAPROC RUNABLERProp3(OBJID IdObj,CLASSID id,EPChar name,EPVoid par)
{
  DtRUNABLE	*m;
  
  m=(DtRUNABLE*)GetRef3(IdObj);
  return EDMARProp3 (m->id,name,par);
}


ESint32 EDMAPROC RUNABLEMet3(OBJID IdObj,CLASSID id,EPChar name,EPVoid par)
{
  DtRUNABLE	*m;
  TH_PAR        pars;
  
  m=(DtRUNABLE*)GetRef3(IdObj);
  pars.idProxy=IdObj;
  pars.id=m->id;
  pars.name=name;
  pars.pars=par;
  /* Run method in new thread*/
  ptread_create (&m->thread,NULL,threaded_func,&pars);
  return 0;

}


ESint32 EDMAPROC RUNABLEMet3S(OBJID IdObj,CLASSID id,EPChar name,EPChar sig, EPVoid par)
{
  DtRUNABLE	*m;
  
  m=(DtRUNABLE*)GetRef3(IdObj);

  return EDMAMet3S(m->id,name,sig,par);
}

int threaded_func (void *pars) {
  TH_PAR     *p;

  p=(TH_PAR*)pars;
  EDMAMet3 (p->id,p->name,p->pars);

  return 0;
}


/********** END C IMPLEMENTATION SKELETON ******************/
