/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998-2001  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
*********************************************************
 Entorno de Desarrollo Modular y Abierto
 (c) David Martnez Oliveira
 Vigo 18 de Octubre de 1996

 Versin 0.3r1
 ---------------------------------------------------------
 
 Constantes EDMA
 --------------------------------------------------------------
 3 de Enero de 1999
 Aadimos la constante CLASS_ILOADED
 ------------------------------------------------------------
 14 de Mayo de 1999
 Aadimos nuevas constantes de estado de clase, para llevar control
 del estado de la clase en cada proceso.
 * -------------------------------------------------------------
 * Febraury, 20th, 2001
 * Code cleanup and comment translation
 *********************************************************
*/

#ifndef CONST_H
#define CONST_H

#ifdef __cplusplus
extern "C"{
#endif

#define VERSION_MA 0
#define VERSION_MI 7
#define VERSION_BUG 1
#define VERSION_STATUS "Beta"

#define TMPDIR "/tmp/EDMAtmp"
#define IDFDIR "/share/edma/idf/"

/** Maximum size for system tables ****************************/

#define MAX_PRIM	200
#define	MAX_OBJ		8192
#define MAX_APP		100
#define MAX_CLASE	256

#define MAX_IDF_PARSERS	64
#define MAX_SIU_PROXYS	64
#define MAX_EMI_COMP	16

  /** Class Status constants */
#define	CLASS_FREE	0	/* Free Entry */
#define CLASS_DEF	1	/* Class defined but not memory-mapped */
#define CLASS_ILOADED   2       /* Interface loaded, but implementation not*/
#define CLASS_IMAPPED   3       /* Interface mapped for this process */
#define CLASS_LOADED	4	/* Class full loaded */
#define CLASS_TEMP	10	/* Temporal Class. For dynamic class definition */

  /** Object Status Constants */
#define OBJ_FREE	0
#define OBJ_EXIST	1
#define VIRTUAL_OBJECT	2

  /** Machine Types **************************************/
  /* Mantained for compatibility. Now, EDMA loads machine types from a file*/
#define MAQ_NUM		32				

#define I386		0
#define	I386_4		1
#define	I386_8		2
#define	I486		4
#define	I486_8		5
#define	I486_16		6
#define	I486_32		7
#define PENT		8
#define	PENT_8		9
#define	PENT_16		10
#define	PENT_32		11
#define	PENT_64		12

#define	VIRTUAL		13
#define	JAVA		14

/** Operating System Types **********************************/
#define	SO_NUM		8

#define	WINDOWS		0
#define	WIN311		1
#define	WIN95		2
#define	WIN_NT		3

/** Object Status ********************************************/

#ifdef __cplusplus
}
#endif
#endif
