/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998-2001  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

/*
 Entorno de Desarrollo Modular y Abierto
 Versin Beta 0.3r1
 (c) David Martnez Oliveira


 Modulo para gestin Extensiones EMI (Extension Management Interface)
 Revisiones: ---------------------------------------------------------
 2 de Octubre
 Adimos funciones para la gestin EMI.
 Inicialmente solo excepcin CLASS_NOT_FOUND

 Aadimos en este mdulo las funciones para actualizar el fichero
 EDMA32.CFG
--------------------------------------------------------------------
19 de Febrero de 2000
 Hacemos que se modifique el registro real de clases, para poder utilizar las funciones de soporte de instalacin dinmica de clases.
 *-------------------------------------------------------------------
 * Revisions:
 * November, 18th, 2001
 * Fixed ActualizeCFG which didn't write the correct IDF parser
 * for classes using an IngrIDF parser
 */

#include <stdio.h>
#include "portable.h"
#include "multiidf.h"
#include "vglobal.h"
#include "classq.h"
#include "misc.h"
#include "inh.h"


/* XXXXXXX: What's that... Check it out, it seems it's an error*/
ESint32 EDMAPROC GetEMIComp (EPChar Name)
{
  EUint32		i;
  
  for (i=0;i<GVar->nSIU;i++)
    if (strcmp(GVar->SIUProxy[i].Id,Name)==0)
      break;
  if (i==GVar->nIdf)
    return -1;
  else
    return i;
}

EUint32 EDMAPROC AddEMIComp (EPChar Name,EPChar ClassName)
{
  ESint32		IdParser;
  CLASSID		IdClass;
  EChar		error[80];
  /* We check if it already exists */
  if (GetEMIComp(Name)!=-1) {
    sprintf (error,"SIU Proxy %s already exists",Name);
    ECout (error);
    return 0;
  }
  /* if it doesn't exist, we add it*/
  IdClass=GetClassId(ClassName);
  IdParser=GVar->nEMI;
  strcpy (GVar->EMIComp[IdParser].Id,Name);
  GVar->EMIComp[IdParser].IdClass=IdClass;
  GVar->nEMI++;
  return 0;
}

EUint32 EDMAPROC HookGetClass(CLASSID IdClass)
{
  GVar->GetClassEMI=IdClass;
  return 0;
}

ESint32 EDMAPROC GetNEMIHandlers (void) {
  return GVar->nEMI;
}

CLASSID EDMAPROC GetEMIHandlerClass (ESint32 i) {
  if ((i<0) || (i> GVar->nEMI))
    return -1;
  return GVar->EMIComp[i].IdClass;
}


EUint32 EDMAPROC ActualizeCFG()
{
  FILE		*fich;
  EChar		Cadena[1024],Buffer[256];
  EUint32	i,j,index;
  EPChar	Aux;
  
  
  strcpy(Cadena,GVar->SystemPath);
  /* FIXME: This should be precalculated and it depends on OS*/
  strcat (Cadena,"/etc/edma32.cfg");
  
  ECout1("[ActualizeCFG] Output File : %s",Cadena);
  
  fich = fopen (Cadena,"wt");
  if (fich==NULL) {
    ECoutErr("[ActualizeCFG] Cant open EDMA32.CFG for update");
    return 0;
  }
  fprintf(fich,"[General]\n");
  fprintf (fich,"nClasses=%d\n",GVar->nClases);
  j=0;
  for (i=0;j<GVar->nClases;i++) {
    if (gClase[i].Status!=CLASS_FREE) {
      fprintf(fich,"[CLASS%d]\n",j);
      fprintf(fich,"ClassName=%s\n",gClase[i].ClassName);
      fprintf(fich,"Machine=%s\n",GVar->SysMaq[gClase[i].MaqId].Nombre);
      fprintf(fich,"OperatingSystem=%s\n",GVar->SysSO[gClase[i].SOId].Nombre);
      /* What the hell is this???... 
	 Why does I extract filename from ModuleName?..???
      */
      /*
	Aux=gClase[i].SysClass.ModuleName+strlen(gClase[i].SysClass.ModuleName);
	
	#ifdef WINAPI_32		   
	while ((*Aux!='\\')&&(Aux>gClase[i].SysClass.ModuleName))
	Aux--;
	#endif	
	#ifdef LINUX		   
	while ((*Aux!='/')&&(Aux>gClase[i].SysClass.ModuleName))
	Aux--;
	#endif		
	Aux++;
      */
      Aux=gClase[i].SysClass.ModuleName;
      fprintf(fich,"Implementation=%s\n",Aux);
      
      if (gClase[i].IDFParser==0)
	fprintf(fich,"IDFParser=EDMAIDF\n");
      else {
	index=gClase[i].IDFParser;
	fprintf(fich,"IDFParser=%s\n",
		gClase[GVar->IDFParser[index].IdClass].ClassName);
      }
      if (gClase[i].IsIDF)
	fprintf(fich,"IsIDFParser=1\n");
      if (gClase[i].IsSIU)
	fprintf(fich,"IsSIUProxy=1\n");
      if (gClase[i].IsEMI)
	fprintf(fich,"IsEMI=1\n");
	  if (gClase[i].SIUProxy!=0)
	    fprintf(fich,"SIUProxy=%s\n",gClase[gClase[i].SIUProxy].ClassName);
	  j++;
    }
    
  }
  fprintf (fich,"[]");
  fclose(fich);
  ECout1("[ActualizeCFG] Exit");
  return 0;
}
