/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
 Entorno de Desarrollo Modular y Abierto
 (c) David Martnez Oliveira
 Versin Beta 0.3r1
 8 de Agosto de 1997

 Funciones de parssing de paths de propiedades y mtodos

 REVISIONES:-------------------------------------------------------------
 8 de Agosto de 1997
 Modificacin para aadir herencia bajo demanda
 -----------------------------
 21 de Agosto de 1997
 Modificacin para poder utilizar el smbolo "../" en los identificadores
 Hemos realizado la gestin del error, pero la primitiva mostrar un mensaje de error
 incorrecto.
 ----------------------------------------
 31 de Agosoto de 1997
 Intento de modificacin para integracin de subsistema SIU
 -----------------------------
 * 4/05/1998
 *    Aadimos soporte para .. a GetSubObj
 * 
 -------------------------------------------------------
 10 Mayo de 1999
 Comenzamos las modificaciones para soporte de navegacin bidireccional
 por la jerarqua de clases.
 * ---------------------------------------------------------------------
 * October, 14th,2001
 * Cleanup code
*/

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "portable.h"
#include "vglobal.h"
#include "pri1.h"
#include "pri3.h"
#include "misc.h"
#include "classq.h"
#include "inh.h"

#define GO_UP   1
#define GO_DOWN 2


POBJ EDMAPROC GetSubObj (POBJ Obj,EPChar Id2,EPChar LocalId,EPChar TitleError)
{
  EUint32	nId,i,l,pos;
  EUint32	n,j;
  EByte         dir;
  EChar		*PosStr;
  EChar		Error[80];
  EPfChar	Id1;
  POBJ		pObj,pObj1;
  EChar		Temp[255];
  EPfChar	Id;
  EPChar	c[2]={NULL,NULL};
  EPChar	cId[2]={NULL,NULL};
  /*EPChar	SIUFlag;*/
  EChar         SIUFlag;
  POBJ		SIUObj;
  
  SIUFlag=0;
  SIUObj=0;
  memset (Temp,0,255);
  strncpy(Temp,Id2,strlen(Id2));   
  Id=Temp;
  pObj=Obj;
  Id1=Id;
  l=strlen(Id);
  /* We coiunt separators in identifier
     Modification to allow use charactes < and > as separators*/
  nId=0;
  for (i=0;i<l;i++)
    if (Id[i]=='/') nId++;
    else
      if (Id[i]=='>') nId++;
      else
	if (Id[i]=='<') nId++;
  /* Modification ends here*/
  
  /* Locate object*/
  pos=0;
  for (i=0;i<nId;i++)
    {
      Id+=pos;
      PosStr=strchr(Id,'/');
      dir=GO_UP;
      /* What separator have we get? */
      if (PosStr==NULL) /* No slash (/) */
	{
	  PosStr=strchr(Id,'>');
	  if (PosStr==NULL) /* No > */
	    {
	      PosStr=strchr(Id,'<');
	      if (PosStr!=NULL)
		dir=GO_DOWN;
	    }
	}
      strncpy (LocalId,Id,PosStr-Id);
      pos=PosStr-Id;
      LocalId[pos]=0;
      
      pos++;
      if (strcmp(LocalId,"..")==0)
	{
	  pObj1=pObj;
	  pObj=pObj->Padre;
	  if (pObj==NULL)
	    {
	      ECoutErr("[GetSubObj] Object %d haven't father",pObj1->IdObj);
	      LocalId[0]=0;
	      return 0;
	    }
	}
      else
	{
	  if (dir==GO_UP)
	    {
	      /* Look for identifier in current object*/
	      n=pObj->nTabla;
	      for (j=0;j<n;j++)
		if (strcmp (pObj->Tabla[j].Id,LocalId)==0)
		  break;
	      if (j==n)
		{
		  /* if identifier doen't exist, we check if it's a valid class name */
		  if (GetClassId(LocalId)==GVar->nMaxClases)	/* if it is*/
		    {
		      sprintf (Error,"Symbol %s undefined in Class Path %s",LocalId,Id1);
		      ECout (Error);
		      return 0;
		    }
		  else
		    {
		      c[0]=LocalId;
		      cId[0]=LocalId;
		      MutateObj(pObj,c,cId);
		      /*
			Modification for SIU 2, September 96
			If it's on-demand inheritance we go on parsing
			We'd repeat this for final objects
		      */
		      SIUFlag=0;
		      /* Modification Ends*/
		    }
		}
	      
	      pObj=pObj->Tabla[j].Obj;
	    }
	  if (dir==GO_DOWN)
	    {
	      /* look for identifier in current object*/
	      n=pObj->nTabla1;
	      for (j=0;j<n;j++)
		if (strcmp (pObj->Tabla1[j].Id,LocalId)==0)
		  break;
	      if (j==n)
		{
		  /* If class identifier doesn't exist, we check if it's a valid class name*/
		  if (GetClassId(LocalId)==GVar->nMaxClases)	/* if it isn't*/
		    {
		      sprintf (Error,"Symbol %s undefined in Class Path %s",LocalId,Id1);
		      ECout (Error);
		      return 0;
		    }
		  else
		    {
		      c[0]=LocalId;
		      cId[0]=LocalId;
		      MutateObj1(pObj,c,cId);
		      /*
			Modification for SIU 2, September 96
			If it's on-demand inheritance we go on parsing
			We'd repeat this for final objects
		      */
		      SIUFlag=0;
		      /* Modification ends*/
		    }
		}
	      
	      pObj=pObj->Tabla1[j].Obj;
	    }
	  
	}
      /* New Modificatrion SIU 2 Sept. 1997*/
      if (pObj->IdSIU!=-1)
	{
	  SIUFlag=1;
	  SIUObj=pObj;
	}
      if (SIUFlag==1)
	{
	  strcpy(LocalId,Id);
	  return pObj;
        }
      /* Modification ends*/
      
    }
  /* The latest identifier is the final property or method*/
  Id+=pos;
  PosStr=strchr(Id,0);	/* We look for the end*/
  pos=PosStr-Id;
  strncpy (LocalId,Id,pos+1);
  LocalId[pos]=0;
  
  return pObj;
}



/*
** Igual a GetSubObj pero devolviendo informacin sobre los datos
** virtuales si el objeto es virtual.
*/

POBJ EDMAPROC GetSubObj1 (POBJ Obj,EPChar Id2,EPChar LocalId,PVIR_DATA *VirData,EByte tFlag,EPChar TitleError)
{
  EUint32		nId,i,l,pos;
  EUint32		n,j;
  EUint32		Tipo;
  EChar			*PosStr,*PosStr1,*PosStr2;
  EChar			Error[80];
  EPChar		Id1;
  POBJ			pObj,pObj1;
  EChar			Temp[255];
  EPChar		Id;
  EByte			Flag,Atajo,dir;
  PVIR_DATA		pVirData;
  EPChar		c[2]={NULL,NULL};
  EPChar		cId[2]={NULL,NULL};
  EPChar                Aux2;
  EChar                 ClassName[50],pap[50];

  pObj=Obj;
  Flag=0;
  pos=0;
  if (Obj->Flag==VIRTUAL_OBJECT) {
    pVirData=GetVirtualData(Obj,Id2,VirData,&Atajo);
    if (pVirData!=0) {
      if (Atajo==0) {
	*VirData=pVirData;
	strncpy (LocalId,Id2,strlen(Id2));
	LocalId[strlen(Id2)]=0;
	
	return Obj;
      } else {
	strncpy (LocalId,(EPChar)(&pVirData->Id),strlen((EPChar)(&pVirData->Id)));
	LocalId[strlen((EPChar)(&pVirData->Id))]=0;
	
	*VirData=pVirData;
	return pObj;
      }
    }
  }
  
  memset (Temp,0,255);
  strncpy(Temp,Id2,strlen(Id2));   
  Id=Temp;
  
  Id1=Id;
  l=strlen(Id);
  /* We count separator in identifier.
     Modification to manage new separator > and < */
  nId=0;
  for (i=0;i<l;i++)
    if (Id[i]=='/') nId++;
    else
      if (Id[i]=='>') nId++;
      else
	if (Id[i]=='<') nId++;
  /* Ends new separator extension */
  /* Locate the Object */
  pos=0;
  dir=GO_UP;
  for (i=0;i<nId;i++) {
    Id+=pos;
    dir=GO_UP;
    PosStr=strchr(Id,'/');
    PosStr1=strchr(Id,'>');
    if ((((PosStr1!=NULL)&& (PosStr1<PosStr))|| (PosStr==NULL)))
      PosStr=PosStr1;
    
    PosStr2=strchr(Id,'<');
    if (((PosStr2!=NULL)&&(PosStr!=NULL)&&(PosStr2<PosStr))|| (PosStr==NULL)) {
      PosStr=PosStr2;
      dir=GO_DOWN;
    }

    strncpy (LocalId,Id,(EPByte)PosStr-(EPByte)Id);

    pos=(EPByte)PosStr-(EPByte)Id;
    LocalId[pos]=0;
    /*ECout1 ("[GetObj1] Processing %s",LocalId);    */
    pos++;
    /* Locate identifier in current object */
    if (strcmp(LocalId,"..")==0) {
      pObj1=pObj;
      pObj=pObj->Padre;
      if (pObj==NULL) {
	ECoutErr("[GetSubObj1] Object %d haven't father",pObj1->IdObj);
	LocalId[0]=0;
	return 0;
      }
    } else {
      if (dir==GO_UP) {
	Tipo=pObj->IdClase;
	n=pObj->nTabla;
	/*ECout1 ("[GetSubObj1] Looking for: %s in %d superclasses",LocalId,n);*/
	for (j=0;j<n;j++) {
	  /*ECout1 ("[GetSubObj1] Testing against: %s",pObj->Tabla[j].Id);*/
	  if (strcmp (pObj->Tabla[j].Id,LocalId)==0)
	    break;
	}
	if (j==n) {
	  /* If class identifier doen't exist, we check if it's a valid class */
	  //	  if (GetClassId(LocalId)==GVar->nMaxClases)	{ // si no es un nombre de clase
	  if (GetClassId(LocalId)==-1)	{ // si no es un nombre de clase
	    sprintf (Error,"Symbol %s undefined in Class Path %s",LocalId,Id1);
	    ECout (Error);
	    return 0;
	  } else
	    if (pObj->Final==0) {
	      c[0]=LocalId;
	      cId[0]=LocalId;
	      MutateObj(pObj,c,cId);
	    } else {
	      ECoutErr("[GetSubObj1] Object %d is final. Cant inherit from class %s",pObj->IdObj,LocalId);
	      return 0;
	    }
	}
	
	/* Modificacin 18 de Septiembre para SIU */
	
	if (pObj->Tabla[j].Obj==0) { /* If we're in a proxy object*/
	  /*ECout1("[GetSubObj1] Found Object NULL in SCList");*/
	  /*
	    //                   	  	Id+=pos;
	    //                    	strcpy(LocalId,Id);
	    //                        ECout1("Proxy found at %s",Id);
	    //                        return pObj;
	  */
	}
	pObj=pObj->Tabla[j].Obj;
      }
      if (pObj->Flag==VIRTUAL_OBJECT) {
	if (tFlag==V_PROP)
	  *VirData=pObj->VirData.vProp;
	if (tFlag==V_MET)
	  *VirData=pObj->VirData.vMet;
	pVirData=GetVirtualData(Obj,Id+pos,VirData,&Atajo);
	if (pVirData!=0) {
	  if (Atajo==0) {
	    strncpy (LocalId,Id+pos,strlen(Id+pos));
	    LocalId[strlen(Id+pos)]=0;
	    
	    *VirData=pVirData;
	    return pObj;
	  } else {
	    strncpy (LocalId,(EPChar)(&pVirData->Id),strlen((EPChar)(&pVirData->Id)));
	    LocalId[strlen((EPChar)(&pVirData->Id))]=0;
	    
	    *VirData=pVirData;
	    return pObj;
	  }  
	}
      }
      if (dir==GO_DOWN) {
	Tipo=pObj->IdClase;
	n=pObj->nTabla1;

	/*ECout1 ("[GetSubObj1] Testin on object %d [%s]",pObj->IdObj, gClase[pObj->IdClase].ClassName);*/
	pap[0]=0;
	/******/ strcpy (pap,LocalId);
	strcpy (ClassName,LocalId);
	if ((Aux2=strchr (ClassName,'@'))!=NULL) {
	  *Aux2=0;
	  strcpy (pap,Aux2+1);
	  //strcpy (ClassName,Aux+1);
	  cId[i]=Aux2+1;
	  c[i]=ClassName;

	}
	/*ECout1 ("[GetObj1] PAP specified: %s %s-%s %s|... %d superobjects to test",pap,ClassName,cId[i],c[i],n);*/
	for (j=0;j<n;j++) {
	  /*ECout1 ("[GetObj] Testing superobject %d: %s",j, pObj->Tabla1[j].Id);*/
	  //if (strcmp (pObj->Tabla1[j].Id,LocalId)==0)
	  if (strcmp (pObj->Tabla1[j].Id,pap)==0) {
	    /*ECout1 ("[GetObj1] %d/%d Testing %s against %s",j,n,pObj->Tabla1[j].Id,pap);*/
	    break;
	  }
	}

	if ((j==n) || ((pObj->Tabla1[j].IdClase!=GetClassId(ClassName)))) {
	  /* If class identifier doewn't exist, we check if it's a valid class*/
	  //if (GetClassId(LocalId)==GVar->nMaxClases)	{ /* if it isn't*/
	  if ((GetClassId(ClassName)==-1))	{ /* if it isn't*/
	    if (j==n) {
	      sprintf (Error,"Symbol %s undefined in Class Path %s",LocalId,Id1);
	      ECout (Error);
	      return 0;
	    }
	  } else
	    if (pObj->Final==0) {
	      /*
	      c[0]=LocalId;
	      cId[0]=LocalId;
	      */
	      c[0]=ClassName;
	      cId[0]=pap;
	      MutateObj1(pObj,c,cId);
	      strcpy (LocalId,pap);
	      /*ECout1 ("[GetObj1] Object Mutated... continuing: %s",LocalId);*/
	    } else {
	      ECoutErr("[GetSubObj1] Object %d is final. Cant inherit from class %s",pObj->IdObj,LocalId);
	      return 0;
	    }  
	}
	      
	/* Modificacin 18 de Septiembre para SIU */      
	if (pObj->Tabla1[j].Obj==0) { /* If we reach a proxy objcet*/
	  /*ECout1("[GetSubObj1] Found Object NULL in SCList");*/
	  /*
	    //                   	  	Id+=pos;
	    //                    	strcpy(LocalId,Id);
	    //                        ECout1("Proxy found at %s",Id);
	    //                        return pObj;
	  */
	}
	pObj=pObj->Tabla1[j].Obj;
      }
      if (pObj->Flag==VIRTUAL_OBJECT) {
	if (tFlag==V_PROP)
	  *VirData=pObj->VirData.vProp;
	if (tFlag==V_MET)
	  *VirData=pObj->VirData.vMet;
	pVirData=GetVirtualData(Obj,Id+pos,VirData,&Atajo);
	if (pVirData!=0) {
	  if (Atajo==0) {
	    strncpy (LocalId,Id+pos,strlen(Id+pos));
	    LocalId[strlen(Id+pos)]=0;
	    
	    *VirData=pVirData;
	    return pObj;
	  } else {
	    strncpy (LocalId,(EPChar)(&pVirData->Id),strlen((EPChar)(&pVirData->Id)));
	    LocalId[strlen((EPChar)(&pVirData->Id))]=0;
	    
	    *VirData=pVirData;
	    return pObj;
	  }
	}
      } 
    }  
  }
  /*ECout1 ("[GetSubObj1] Getting las identifier : %s",LocalId);*/
  /* The last identifier is the final property or method*/
  Id+=pos;
  PosStr=strchr(Id,0);	/* Look for the end*/
  pos=(EPByte)PosStr-(EPByte)Id;
  strncpy (LocalId,Id,pos+1);
  LocalId[pos]=0;
  *VirData=NULL;
  /*
  ECout1 ("[GetSubObj1] Getting las identifier : %s. %d [%s]",LocalId,
  pObj->IdObj,gClase[pObj->IdClase].ClassName);*/
  
  return pObj;
}



/*
**********************************************************************
** GetVirtualData
**********************************************************************
**	INPUT:
**		pObj	-> Points to virtual subobject
**		Id	-> Virtual data identifier we're looking for
**		ini	-> Points to initial virtual data we're looking for
**		Atajo	-> Indicates if we've found a shortcut
**********************************************************************
**	OUTPUT:
**		ini	-> Contains the latest item located
**		return	-> Virtual Data found
**			   0 if virtual data wasn't found
***********************************************************************
*/
PVIR_DATA	EDMAPROC	GetVirtualData (POBJ pObj,EPChar Id,PVIR_DATA *ini,EByte *Atajo)
{
  PVIR_DATA		temp,temp1;
  
  *Atajo=0;
  temp=*ini;
  while (*ini!=0)
    {
      if (strcmp((*ini)->LocalId,Id)==0)
	{
	  *Atajo=1;
	  break;
	}
      if (strcmp((EPChar)(&(*ini)->Id),Id)==0)
     	break;
      else
	{
	  temp=*ini;
	  *ini=(*ini)->Next;
	}
    }
  temp1=*ini;
  *ini=temp;
  return temp1;
}


