/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

/*
*********************************************************
 Entorno de Desarrollo Modular y Abierto
 (c) David Martnez Oliveira
 Versin Beta 0.3r1
 Vigo 22 de Junio de 1997

 ---------------------------------------------------------

 Mdulo de funciones para herencia

 REVISIONES:------------------------------------------------
 2 de Julio de 1997
 Intentamos aadir herencia dinmica...
 Parece que va
 -----------------------------------
 19 de Julio de 1997
 Aadimos soporte para el mapeo de implementaciones de clases para
 cada proceso utilizando las.
 -----------------------------------------------------
 22 de Agosoto de 1997
 Reincorporamos las funciones MergeObj y FreeObj. Vamos a testearlas con la
 clase CONTAINER.
 ------------------------------
 18 de Septiembre de 1997
 Vamos a intentar aadir el soporte para SIU a las funciones de herencia dinmica
 (...)
 Sigo con la modificacin, y acabo de hacer un churro a ver que sale.
 * 
 * ------------------------------------------------------------
 * January, 5th, 2001
 * Source cleanup
 * ---------------------------------------------------------------------
 * November, 17th, 2001
 * More code cleanup and compile warnning removal
 * ------------------------------------------------------------------------
 * November, 28th,2001
 * DeriveClass Modfication. Now we must pass a string array with the
 * prefered anchor points for each superclass in a static inheritance
 * relationship
 * --------------------------------------------------------------------------
 * December, 3rd, 2001
 * Finished The preferer anchor point patch 
 */

#include <stdio.h>
#include <string.h>
#include "portable.h"
#include "classq.h"
#include "shmem.h"
#include "vglobal.h"
#include "clas.h"
#include "obj.h"
#include "misc.h"

/**************************************************************
** Static inheritance function
** it uses dynamic data structures anyway
************************************************************/

EUint32 EDMAPROC DeriveClass (EPChar nombre,EPChar *c,EPChar *ilist)
{
  EUint32	Id,IdSC;
  EUint32	i;	        /* General counter for loops */
  EUint32	nSC;		/* SuperClass count */
  EPfChar	*cTemp;
  EChar		error[80];
  HMEM		h;
  
  ECoutDbg(12,-1,"[DeriveClass] Build inheritance information for class %s",nombre);
  Id = GetClassId (nombre);
  if (Id==GVar->nMaxClases) {
    ECoutErr ("[DeriveClass] Class %s not found",nombre);
    return 0;
  }
  
  /* We create the superclass table for this derived class */
  nSC=gClase[Id].Derived;
  sprintf (error,"%dSCLIST",Id);
  h=SAlloc (sizeof(CLASSID)*nSC,error);
  if (h==(HMEM)0) {
    ECoutErr ("[DeriveClass] Cant allocate SuperClass Table");
    return 0;
  }
  pClase[Id].SysClass.hSCList=h;
  pClase[Id].SCList=SGet(h);

  /* Now we create the preferer anchor point list*/
  sprintf (error,"%dIDSCLIST",Id);
  /*ECout1 ("[DeriveClass] Reserving %s [ %d bytes]",error,sizeof(ID)*nSC);*/
  if ((h=SAlloc(sizeof (ID)*nSC,error))==(HMEM)0) {
    ECoutErr ("[DeriveClass] Can't allocate SuperClass Preferer Anchotr porint table");
    return 0;
  }
  pClase[Id].SysClass.hSCIdList=h;
  pClase[Id].SCIdList=SGet(h);
  /* ... and fullfill it */
  ECoutDbg(12,-1,"[DeriveClass] Getting Inheritence information for %d classes",nSC);
  for (i=0;i<nSC;i++) {
    ECoutDbg(12,-1,"[DeriveClass] Getting identifier for class : %s",c[i]);
    IdSC = GetClassId(c[i]);
    /*if (Id==GVar->nMaxClases) {*/
    if (IdSC == -1) {
      ECoutErr ("[DeriveClass] Class %s not found",nombre);
      SFree (pClase[Id].SysClass.hSCList ,pClase[Id].SCList);
      SFree (pClase[Id].SysClass.hSCIdList ,pClase[Id].SCIdList);
      return 0;
    }

    if ((ilist) && (ilist[i])) {
      /*ECout1 ("[DeriveClass] Preferrer Anchor point : %s",ilist[i]);*/
      strncpy (pClase[Id].SCIdList[i],ilist[i],sizeof(ID));
    }
    else
      strcpy (pClase[Id].SCIdList[i],c[i]);

    ECoutDbg(12,-1,"(DeriveClass)    Identifier : %d",IdSC);
    /*ECout1 ("Anchor point for class %s -> %s",c[i],pClase[Id].SCIdList[i]);*/
    /* if the superclass isn mapped... we mapped it */
    if (ProcMapTable[IdSC]>=CLASS_IMAPPED)
      LoadClassInt(IdSC);
    pClase[Id].SCList[i]=IdSC;
  }
  return 0;
}

/****************************************************************
** Dynamic Inheritance Functions
*******************************************************************/

/*
** Add super classes to an OBJECT
*/

EUint32 EDMAPROC AddSCObj (POBJ pObj,EPChar *c,EPChar *cId)
{
  EUint32	Id,IdSC,tam;
  EUint32	i,j;		/* General Counters for loops */
  EUint32	nSC;		/* Superclass Count */
  EUint32	nSCOld;		/* Old Superclass Count */
  EPChar	*cTemp;
  SC_ID		*NTabla;	/* For table clonation */
  EChar		error[80];
  HMEM		hNTabla;
  EChar		ClassName[50];
  EChar		SubSys[32];
  EPChar	Aux,Aux1;
  EChar		isSIU;
  OBJID         new_obj;

  Id=pObj->IdClase;
  /* If the class isn't in memory we load it first */
  if (ProcMapTable[Id]!=CLASS_LOADED)
    LoadClassImp (Id);
  
  /* We count the superclasses to add */
  nSC=0;
  cTemp=c;
  while (cTemp[nSC]!=NULL)
    nSC++;
  
  /* We update superclass table and we clone the table */
  nSCOld=pObj->nTabla;
  tam=sizeof(SC_ID)*(nSC+nSCOld);
  hNTabla=PAlloc(tam);
  if (hNTabla==0) {
    ECoutErr ("Dynamical inheritance memory alloc errror");
    return -1;
  }
  
  NTabla=PGet(hNTabla);
  if (nSCOld)	/* if there some old superclase we copy it */
    memcpy (NTabla,pObj->Tabla,nSCOld*sizeof(SC_ID));
  /* We delete the old one */
  PFree (pObj->SysObj.hTabla,pObj->Tabla);
  pObj->Tabla=NTabla;
  pObj->SysObj.hTabla=hNTabla;
  pObj->nTabla+=nSC;
  /* ... and fullfill it */
  for (i=0;i<nSC;i++) {
    /* We get the class' name */
    Aux=strchr(c[i],')');
    if (Aux!=NULL) {
      strncpy(SubSys,&c[i][0]+1,Aux-&c[i][0]-1);
      SubSys[Aux-&c[i][0]]=0;
      strcpy(ClassName,Aux+1);
      Aux++;
    } else { /* by default, subsystem is EDMA */
      strcpy(SubSys,"EDMA");
      strcpy(ClassName,c[i]);
      Aux=c[i];
    }
    ECoutDbg(4,-1,"(AddSC) Adding class %s in subsystem : %s",ClassName,SubSys);
    if (strcmp(SubSys,"EDMA")==0) {
      isSIU=0;
      Aux1=strchr(c[i],':');
      if (Aux1!=NULL) {
	Aux1++;
	isSIU=1;
      } else 
	Aux1=Aux;
	  
      IdSC = GetClassId(Aux);
      if ((IdSC==GVar->nMaxClases)&&(isSIU==0)) {
	ECoutErr ("Class %s not found",c[i]);
	/* FIXME: !!! Here, we should rollback transaction */
	return 0;
      }
      
      if ((ProcMapTable[IdSC]!=CLASS_LOADED)&&(isSIU==0))
	LoadClassImp (IdSC);
      
      if (isSIU==0)
	j=IdSC;
      else
	j=-1;
      pObj->Tabla[nSCOld+i].IdClase=j;	/* Class Identifier */
      
      strcpy (pObj->Tabla[nSCOld+i].Id,cId[i]); /* User Identifier */ 
      /* Modification building a new subobject. XXX: FIXME: Check for errors*/
      /* FIXME: This'd be moved to a new function*/
      /*
      new_obj=NewObj_BasicStage (ClassName,NULL);
      NewObj_VMStage(new_obj);
      ECout1 ("[AddSC] Adding Inheritance information for new Obj with father information");
      NewObj_InhStage(new_obj, pObj->IdObj,NULL);
      NewObj_FinalStage (new_obj,NULL);
      */
      pObj->Tabla[nSCOld+i].Obj = &gObj[NewObj(ClassName,NULL)];
      /*----------------------*/
      gObj[((POBJ)pObj->Tabla[nSCOld+i].Obj)->IdObj].Padre=pObj;
      
      gObj[((POBJ)pObj->Tabla[nSCOld+i].Obj)->IdObj].PseudiPadre=pObj;
    } else { /* if it's SIU, superclass identifier is setted to -1*/
      IdSC=-1;
      if (pObj->IdSIU==-1) {	/* else we haven a SIU Proxy*/ 
	ECoutErr("Cant inherit on SIU subsystem. Object %d isnt a SIU PROXY",pObj->IdObj);
	continue;
      }
      if (isSIU==0)
	j=IdSC;
      else
	j=-1;
      pObj->Tabla[nSCOld+i].IdClase=j;	/*Class Identifier*/
      strcpy (pObj->Tabla[nSCOld+i].Id,cId[i]); /* User Identifier*/
      pObj->Tabla[nSCOld+i].Obj=pObj;
      Met3(pObj->IdObj,"AddSC",ClassName,cId[i]);	/* The subobject'll be created by the SIU proxy */
    }
  }
  return 0;
}

/*
** Changes a class in an object
** This function changes superclasses alredy defined in the object
*/

EUint32 EDMAPROC OverSCObj (POBJ pObj,EUint32 i,EPChar c,EPChar cId)
{
  EUint32	nSC;
  EUint32	Id,IdSC;
  EUint32	j;		/*General counters for loops*/
  EUint32	nSCOld;		/* Old superclass count*/
  EPChar	*cTemp;
  SC_ID		*NTabla;	/* for table clonation*/
  HMEM		hNTabla;
  EChar		error[80];
  POBJ		OldObj,NObj;
  EChar		ClassName[50];
  EChar		SubSys[32];
  EPChar	Aux,Aux1;
  EChar		isSIU;

  Aux=strchr(c,')');
  if (Aux!=NULL) {
    strncpy(SubSys,c,Aux-c-1);
    SubSys[Aux-c]=0;
    strcpy(ClassName,Aux+1);
  }
  else { /* by default, EDMA is assumed */
    strcpy(SubSys,"EDMA");
    strcpy(ClassName,c);
  }
  ECoutDbg(4,-1,"(OverSC) Adding class %s in subsystem : %s",ClassName,SubSys);
  
  if (strcmp(SubSys,"EDMA")==0) {
    isSIU=0;
    Aux1=strchr(c,':');
    if (Aux1!=NULL) {
      Aux1++;
      isSIU=1;
    } else 
      Aux1=Aux;
    IdSC = GetClassId(ClassName);
    if ((IdSC==GVar->nMaxClases)&&(isSIU==0)) {
      ECoutErr ("Class %s not found",c);
      return 0;
    }
    if ((IdSC==pObj->Tabla[i].IdClase)&&(isSIU==0))
      return 1;
    OldObj = pObj->Tabla[i].Obj;
    
    if ((ProcMapTable[IdSC]!=CLASS_LOADED)&&(isSIU==0))
      LoadClassImp (IdSC);
    
    j=IdSC;
    NObj= &gObj[NewObj (gClase[IdSC].ClassName,NULL)];
    if (NObj==NULL) {
      ECoutErr("(OverSC)Cant create subobject","Override SuperClass Error",0);
      return -1;
    }
    
    FreeObj (((POBJ)pObj->Tabla[i].Obj)->IdObj);
    pObj->Tabla[i].IdClase=j;		/* Class Identifier */
    strcpy (pObj->Tabla[i].Id,cId); /* User IDentifier*/ 
    pObj->Tabla[i].Obj = NObj;
    ((POBJ)pObj->Tabla[i].Obj)->Padre=pObj;
    
    ((POBJ)pObj->Tabla[i].Obj)->PseudiPadre=pObj;
  } else { /* if we override in a SIU object*/
    Met3(pObj->IdObj,"OverSC",i,c,cId);
  }
  return 0;
}

/*
** General function for dynamic inheritance
*/

EUint32 EDMAPROC MutateObj (POBJ pObj,EPChar *c,EPChar *cId)
{
  EUint32	nSC;	/* Superclasses counter*/
  EUint32	nOldSC;	/* Old superclasses counter*/
  EUint32	nNewSC;	/* New superclasses counter*/
  EUint32	i,j;	/* General counters for loops*/
  EUint32	nTabla;	/* Entries counter in object class table*/
  EPChar	*cTemp;
  EPChar	*NewTabla;
  HMEM		hNewTala;
  EPChar	*NewIdTabla;
  HMEM		hNewIdTabla;
  EPUint32	IndTabla;
  HMEM		hIndTabla;
  POBJ		Obj;
  
  /* We count superclasses */
  nSC=0;
  cTemp=c;
  while (cTemp[nSC]!=NULL)
    nSC++;
  nTabla=pObj->nTabla;
  hIndTabla=PAlloc(sizeof(EUint32)*nSC);
  if (hIndTabla==(HMEM)0) {
    ECoutErr("(MutateObj) Can't create SuperClass table for object %d",pObj->IdObj);
    return 0;
  }
  IndTabla=PGet(hIndTabla);
  /* FIXME: Check error on memory allocation */
  /* We locate old classes first of all */
  nOldSC=0;
  
  for (i=0;i<nSC;i++) {
    IndTabla[i]=-1;
    
    for (j=0;j<nTabla;j++) {
      if (strcmp(pObj->Tabla[j].Id,cId[i])==0) {
	IndTabla[i]=j;
	nOldSC++;
	break;
      }
    }
  }
  /* We update the old ones */
  for (i=0;i<nSC;i++) {
    j=IndTabla[i];
    if (j!=-1)
      OverSCObj (pObj,j,c[i],cId[i]);
  }
  /* We build the table for the new ones */
  nNewSC=nSC-nOldSC;
  if (nNewSC)	{ /* If there is someone new*/
    j=0;
    for (i=0;i<nSC;i++)
      if (IndTabla[i]==-1) {
	c[j]=c[i];
	cId[j]=cId[i];
	j++;
      }
    
    PFree(hIndTabla,IndTabla);
    c[j]=NULL;
    cId[j]=NULL;
    AddSCObj (pObj,c,cId);
  }
  return 0;
}

/************************************************************************
** Object Merging functions *********************************************
**************************************************************************/

EUint32 EDMAPROC MergeObj (OBJID IdObj,EPChar Id,OBJID IdObj1)
{
  POBJ		        pObj,pObj1;
  EUint32		nId,i,l,pos;
  EUint32		n,j;
  EUint32		Tipo;
  EChar			LocalId[50];
  EChar			*PosStr;
  EChar			Error[80];
  EPChar		Id1;
  VIR_MET_PARAMS	VMParams;
  POBJ			ObjIni;
  PPROC                 Func;   
  PMetVir		vMet;
  EUint32		tam;

  if ((IdObj<0)||(IdObj>GVar->nMaxObj)) {
    ECoutErr("(MergeObj) Object %d doesnt exist",IdObj);
    return 0;
  }
  if (gObj[IdObj].Flag==OBJ_FREE) {
    ECoutErr("(MergeObj) Object %d doesnt exist",IdObj);
    return 0;
  }
  
  if ((IdObj1<0)||(IdObj1>GVar->nMaxObj)) {
    ECoutErr("(MergeObj) Object %d doesnt exist",IdObj1);
    return 0;
  }
  if (gObj[IdObj1].Flag==OBJ_FREE) {
    ECoutErr("(MergeObj) Object %d doesnt exist",IdObj1);
    return 0;
  }
  if (IdObj1==0)
    ECout1("(MergeObj) Merging object 0 in object %d. Id %s",IdObj,Id);
  pObj=&gObj[IdObj];
  pObj1=&gObj[IdObj1];
  ObjIni=pObj;
  for (i=0;i<pObj->nTabla;i++)
    if (strcmp(pObj->Tabla[i].Id,Id)==0) break;
  ObjIni=pObj->Tabla[i].Obj;
  
  if (i==pObj->nTabla)	{ /* if there is no anchor point*/
    ECoutErr("(MergeObj) Anchor point %s doesn't exist",Id);
    return 0;
  }
  ECoutDbg(4,-1,"Meging Object %d of class %s in table entry %d, Id %s",pObj1->IdObj,gClase[pObj1->IdClase].ClassName,i,Id);
  /* Test */
  ObjIni->Padre=NULL;
  /* End test */
  pObj->Tabla[i].Obj=pObj1;
  pObj->Tabla[i].IdClase=pObj1->IdClase;
  pObj1->Padre=pObj;
  pObj1->PseudiPadre=pObj;
  
  return 0;
}

/* Free entries in the superclass table */
EUint32 EDMAPROC FreeSC (OBJID IdObj,EPChar Id)
{
  POBJ		Obj;
  EUint32	i,j;
  
  Obj=&gObj[IdObj];
  /* We locate the superclass*/
  for (i=0;i<Obj->nTabla;i++)
    if (strcmp(Obj->Tabla[i].Id,Id)==0) break;
  if (i==Obj->nTabla) {
    ECoutErr ("Anchor point %d doesn't exist",Id);
    return 1;
  }
  /* if it exists, we remove it */
  for (j=i;j<Obj->nTabla-1;j++)
    memcpy (&Obj->Tabla[j],&Obj->Tabla[j+1],sizeof(SC_ID));
  
  Obj->nTabla--;
  
  if (Obj->nTabla<=0) {
    PFree (Obj->SysObj.hTabla,Obj->Tabla);
    Obj->nTabla=0;
  }
  
  return 0;
}


