/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998,2001  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
 Entorno de Desarrollo Modular y Abierto
 Versin Beta 0.3r1
 (c) David Martnez Oliveira

 ini.C
 Modulo de inicializacin
 Revisiones: ---------------------------------------------------------
 28 de Abril de 1997
 12 de Junio de 1997
 Aadimos las funciones de lectura de interface sencillas (idf.C)
 -----------------------
 19 de Julio de 1997
 Aadimos la construccin de la tabla de mapeo para cada proceso
 que carga la DLL. Esta tabla indica si una clase determinada (su implementacion)
 est mapeada en el espacio de direccionamiento del proceso.
 -------------------------------------------
 18 de Julio de 1997
 Vamos a modificar el fichero EDMA32.CFG para soportar el almacenamiento de
 informacin sobre clases del sistema IDF,SIU.
 ---------------------------
 8 de Agosto de 1997
 Modificacin para soporte de informacin de mapeo de cdigo por proceso
 -----------------------------
 24 de Agosto de 1997
 Modificacin para soporte de mltiples parsers de interface
 ------------------------
 31 de Agosto de 1997
 Estoy intentando aadir SIU y me parece que me lo he cargado todo
 * ------------------------------
 * 17/11/1997
 *   Modificaciones para la versin 0.3r1
 *   Soporte de nuevos campos IDF
 * --------------------------------
 * 25/11/1997
 *    Modificaion para corregir bug de mapeo de estructuras compartidas
 * -----------------------------
 * 31/98/1998
 *    There is a problem freeing memory when all process unload EDMA.
 *    We clena a bit source
 *    We will try some probes:
 *      First, we make on-demand interface load for using less memory
 * 
 *---------------------------------------------------
 *2 de Enero de 1999
 * Soporte para variable de entorno EDMADIR
 --------------------------------------------------------------
 3 de Enero de 1999
 Modificacin para carga dinmica de interfaces. Los interfaces
 ya no se cargan durante el proceso de inicialziacin del sistema
 ------------------------------------------------------------------
 19 de Febrero de 2000
 El registro de clases se localiza, pero no se carga si ya hay procesos
 ejecutndose (las zonas de memoria compartida ya est mapeadas en el
 espacio de direccionamiento del nuevo proceso en EDMA).
 * ---------------------------------------------------
 * Febraury, 7th, 2001
 * Clean up code and comments translation
 * ------------------------------------------------------------
 * July, 6th, 2001
 * Modification to manage classes with no implementation as pure abstract
 * clases
 * ----------------------------------------------------------------
 * November, 10th, 2001
 * We change the configuration files location. Now, by default, edma32.cfg
 * is at SYSTEMPATH/etc
 *
 * The edma32.ini configuration file no longer is used
 * --------------------------------------------------------------------------
 * November, 18th,2001
 * Compile warnnings removal
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "portable.h"
#include "const.h"
#include "shmem.h"
#include "sys31.h"
#include "ini1.h"
#include "idf.h"
#include "tobj.h"
#include "tclass.h"	
#include "ttypes.h"
#include "vglobal.h"
#include "error.h"
#include "clas.h"
#include "misc.h"
#include "obj.h"
#include "procmap.h"
#include "iniman.h"


/* Local Prototypes */
Flag	WinSysData(PINIFILE,EUint32,CLASE*);

/*
******* Global Vars
*/
SYS_GLOBAL_VAR	*GVar;
TIPOS	tipo[MAX_TIPOS]=
{
     {"EUINT8",DT_EUINT8,sizeof(EUint8),"U8"},
     {"EUINT16",DT_EUINT16,sizeof(EUint16),"U16"},
     {"EUINT32",DT_EUINT32,sizeof(EUint32),"U32"},
     {"ESINT8",DT_ESINT8,sizeof(ESint8),"S8"},
     {"ESINT16",DT_ESINT16,sizeof(ESint16),"S16"},
     {"ESINT32",DT_ESINT32,sizeof(ESint32),"S32"},
     {"EBYTE",DT_EBYTE,sizeof(EByte),"B"},
     {"EWORD",DT_EWORD,sizeof(EWord),"W"},
     {"EDWORD",DT_EDWORD,sizeof(EDWord),"D"},
     {"ECHAR",DT_ECHAR,sizeof(EChar),"C"},
     {"EBOOL",DT_EBOOL,sizeof(EByte),"B"},
     {"EREAL32",DT_EREAL32,sizeof(EReal32),"R32"},
     {"EREAL64",DT_EREAL64,sizeof(EReal64),"R64"},
     {"EZSTRING",DT_EZSTRING,sizeof(EPChar),"Z"},
     {"EBUFFER",DT_EBUFFER,sizeof(EDMAT_BUFFER),"A"},
     {"EOBJECT",DT_EOBJECT,sizeof(OBJID),"O"},
     {"EUSER",DT_EUSER,sizeof(OBJID),"U"},

};
/* Mapped classes table for this process */
HMEM	hProcMapTable;
EPByte	ProcMapTable;

HMEM	hpClase;
PCLASE	*pClase;
HMEM    hfClase;
FCLASE  *fClase;

HMEM    hSObj;
HMEM    hSClase;
OBJ     *SObjeto;
CLASE   *SClase;

EUint32	AppId;
EChar	AppName[80];
PPROC	ProcEPTable[MAX_PRIM];

EUint32 EDMAPROC EDMAIni (void)
{
   HMEM		h;
   FILE        *fich;
   CLASE	*Clase;
   EChar	Cadena[256],Maquina[80],SysOp[80],msg[80];
   EChar	Name[200],*EDMADir;
   EUint32	i,n_pabstract;
   Flag		ini;
   OBJID	idParser,idEMI;
   PINIFILE	pi;

   /* We build the per-process mapping table */
   ECout1 ("New Process Joining EDMA System");
   ECout1 ("AppId (%d) assigned...",AppId);
   ECout1 ("  Initiating Process Mapping Table and System Tables...");
   BuildProcMap();
   hProcMapTable=PAlloc(MAX_CLASE*sizeof(EByte));
   ProcMapTable=PGet(hProcMapTable);

   /* We build the table which will store method's pointers and dynamic
      libraries handlers */
   hfClase=PAlloc(MAX_CLASE*sizeof(FCLASE));
   if (hfClase==(HMEM)0) {
     ECoutErr ("Can't Alloc Process Method Mapping Table");
     /* FIXME: This should abort startup. Check the other allocations bellow
      * for ordered shutdown, that is free shared memory on abort*/
     return -1;
   }
   fClase=PGet(hfClase);
   /* We build table for indirect references to shared memory blocks 
      per-process */
   hpClase=PAlloc(MAX_CLASE*sizeof(PCLASE));
   if (hpClase==(HMEM)0) {
     ECoutErr ("Can't Alloc Process Shared Structs Mapping Table");
     return -1;
   }
   pClase=PGet(hpClase);
   
   for (i=0;i<MAX_CLASE;i++) {
     ProcMapTable[i]=CLASS_FREE;
     pClase[i].hLib=0;
   }
   ini=0;
   if (GVar->Running<=1) {
     GVar->nMaxClases=MAX_CLASE;
     GVar->nMaxObj=MAX_OBJ;
     GVar->nMaxIdf=MAX_IDF_PARSERS;
     GVar->nMaxSIU=MAX_SIU_PROXYS;
     
     GVar->nIdf=1;
     GVar->nSIU=1;
     GVar->nEMI=1;
     
     GVar->GetClassEMI=0;
     
     /* Default IDF parser init */
     strcpy(GVar->IDFParser[0].Id,"EDMAIDF");
     GVar->IDFParser[0].IdClass=-1;
     
     GVar->SIUProxy[0].IdClass=-1;
     
     ECout1 ("Max Classes in system :%d",GVar->nMaxClases);
     ECout1 ("Max Objects in system :%d",GVar->nMaxObj);
     ECout1 ("Max IDF formats in system :%d",GVar->nMaxIdf);
     ECout1 ("Max SIU Proxys in system :%d",GVar->nMaxSIU);
   }
   
   /* We init class tables */
   hSClase=SAlloc (GVar->nMaxClases*sizeof(CLASE),"CLASSES");   
   if (hSClase==(HMEM)0) {
     ECoutErr ("Cant create class table");
     return -1;
   }
   Clase=SClase=SGet(hSClase);   
   if (Clase==NULL) {
     ECoutErr("Cant create class table");
     return -1;
   }
   /* We inicialize class tables */
   if (GVar->Running<=1) {
     ECout1 ("Initiating shared class table");
     for (i=0;i<GVar->nMaxClases;i++) {
       memset (&Clase[i],sizeof(CLASE),0);
       ini=1;
     }
   }
   
   /* We inicialize object table */
   hSObj=PAlloc(GVar->nMaxObj*sizeof(OBJ));  
   if (hSObj==(HMEM)0) {
     ECoutErr("Cant create object table");
     return FALSE;
   }
   SObjeto=PGet(hSObj);
   if (GVar->Running<=1) {
     ECout1("Initiating shared object table (%d)",GVar->Running);
     for (i=0;i<GVar->nMaxObj;i++)
       memset (&SObjeto[i],sizeof(OBJ),0);
   }
   
   /* We locate the System directory */
   /* get it from EDMADIR environment var */
   /* FIXME: This env should disappear in final version */
   i=0;
   EDMADir=getenv("EDMADIR");
   if (EDMADir!=NULL) {
     i=1;
     strcpy(GVar->SystemPath,EDMADir);
   }
   /* For winsows we look at c:\windows for default .ini files*/
#ifdef WINAPI_32
   pi=OpenINI("edma32.ini");
   i=GetINIString (pi,"General","Dir",NULL,GVar->SystemPath,255);
   CloseINI(pi);
#endif
   /* If we can't locate default .ini file we look for it in current dir */
   if (i==0)  {
#ifdef WINAPI_32
     GetCurrentDirectory(80,Name);
     strcat(Name,"\\EDMA32.INI");
#endif
#ifdef LINUX
     strcpy (Name,"/etc/edma32");
#endif
     ECout1("EDMA not instaled. Trying local configuration");
   }
   strcpy (GVar->SystemPath,"/usr/local/");
   /* FIXME: We need to set diferent default system path for diferent OSes*/
   
   /* We init system tables */
   ECout1("  EDMA System Path is : %s",GVar->SystemPath);
   IniSysTable(GVar->SystemPath);
   /* We open class definition file and update data structs */
   strcpy(Cadena,GVar->SystemPath);
   strcat(Cadena,"/etc/edma32.cfg");
   ECout1("  EDMA Configuration File is : %s",Cadena);
   fich = fopen (Cadena,"rt");
   if (fich==NULL) {
     ECoutErr("FATAL: Can't open <edma32.cfg>.Aborting");
     return -1;
   }
   if (GVar->Running>1) { /* Global var block already in memory?*/
     ECout1("  Shared Data already in-memory");
     ECout1("  %d Classes",GVar->nClases);
     return 0;
   }
   fclose(fich);
   pi=OpenINI(Cadena);
   GVar->nClases=GetINIInt(pi,"General","nClasses",0);
   ECout1 ("  Reading %d Registred Clasess...",GVar->nClases);
   
   n_pabstract=0;
   for (i=0;i<GVar->nClases;i++) {
     /* We get class pointer with general information */
     WinSysData(pi,i,Clase+i);
     Clase[i].Status=CLASS_DEF;
     n_pabstract+=Clase[i].PureAbstract;
     if (Clase[i].IsIDF==1) {
       AddParser(Clase[i].ClassName,Clase[i].ClassName);
       ECout1 ("        %s is an IDF Parser ...",Clase[i].ClassName);
     }
     Clase[i].Derived=0;
     if (Clase[i].IsSIU==1) {
       AddProxy(Clase[i].ClassName,Clase[i].ClassName);
       ECout1 ("        %s is a SIU Proxy ...",Clase[i].ClassName);	     
     }	
     if (Clase[i].IsEMI==1) {
       AddEMIComp(Clase[i].ClassName,Clase[i].ClassName);
       ECout1 ("        %s is an EMI Extension ...",Clase[i].ClassName);
       idEMI=NewObj(Clase[i].ClassName,NULL);
       Met3(idEMI,"Init");
       FreeObj(idEMI);
     }
   }
   
   CloseINI(pi);    
   ECout1("%d Pure Abstract Classes or Interfaces defined",n_pabstract);
   ECout1("EDMA Startup process... OK\n");
   
   return 0;
}

EUint32 EDMAPROC EDMAFree (void)
{
  int	i;
  EChar	msg[80];
  
  for (i=0;i<GVar->nClases;i++) {
    /*We free class implementations */
    FreeClassImp(i);
    /* We free class-related memory */
    SFree (pClase[i].SysClass.hMet,pClase[i].Met);
    SFree (pClase[i].SysClass.hProp,pClase[i].Prop);
    SFree (pClase[i].SysClass.hNot,pClase[i].Not);
  }
  SFree (hSObj,SObjeto);
  SFree (hSClase,SClase);
  return 0;
}

EUint32 EDMAPROC EDMAAppGC (void)
{
  int	i;
  EChar	msg[80];

  sprintf (msg,"(%s) is going down ...%d,%d",AppName,GVar->nObj,GVar->nMaxObj);
  ECout1(msg);
  for (i=0;i<GVar->nMaxObj;i++)
    if ((gObj[i].IdApp==AppId)&&(gObj[i].Flag==OBJ_EXIST)&&(gObj[i].Padre==NULL))
      FreeObj(i);
}

Flag	WinSysData (PINIFILE pi,EUint32 i,CLASE *Clase)
{
  EUint32		n,r,l;
  EChar			Cadena[255];
  EChar			Maquina[80];
  EChar			SysOp[80];

  /* We build section string */
  sprintf(Cadena,"CLASS%d",i);
  /* We read dll name */
  GetINIString(pi,Cadena,"ClassName",NULL,Clase->ClassName,80);
  /*We add maker and version information to memory structs*/
  GetINIString(pi,Cadena,"Maker",NULL,Clase->Maker,80);
  Clase->MajorVer=GetINIInt(pi,Cadena,"MajorVer",0);
  Clase->MinorVer=GetINIInt(pi,Cadena,"MinorVer",0);   
  GetINIString(pi,Cadena,"Machine",NULL,Maquina,80);
  GetINIString(pi,Cadena,"OperatingSystem",NULL,SysOp,80);
  Clase->MaqId=GetMaqId(Maquina);
  Clase->SOId=GetSOId(SysOp);
  Maquina[0]=0;
  GetINIString(pi,Cadena,"Implementation",NULL,Maquina,80);
  /* if no implementation is defined... this is a PureAbstract/Interface definition*/ 
  if ((Maquina==NULL)|| (strlen(Maquina)==0)) 
    Clase->PureAbstract=1;
  else {
    Clase->PureAbstract=0;
    /*strcpy (Clase->SysClass.ModuleName,GVar->SystemPath);*/
    /* Now, classes are loadables directly from their names, so we
       don't need the system path anymore.

       Maybe some absolute path should be used with namespaces. Anyway,
       it's highly probable this should be defined in other place (IDF loading)
     */
    strcpy (Clase->SysClass.ModuleName,Maquina);
  }
  
  Maquina[0]=0;
  r=GetINIString(pi,Cadena,"IDFParser",NULL,Maquina,80);
  /* Initially, we use the default parser*/
  Clase->IDFParser=0;		
   
  strcpy(SysOp,"EDMAIDF");
  l=0;
  for(i=0;i<strlen(SysOp);i++)
    if (SysOp[i]!=Maquina[i]) l++;
  if (l!=0)   {
    /*ECout1("        Class %s using IDF Parser (%s) %d",Clase->ClassName,Maquina,l); */
    Clase->IDFParser=GetParser(Maquina);
    /*printf ("IDF Parser Id : %d\n",Clase->IDFParser); */
    ECoutDbg (40,-1,"        Class %s using IDF parser %d,%s",Clase->ClassName,Clase->IDFParser,GVar->IDFParser[Clase->IDFParser].Id);
  }
  
  r=GetINIString(pi,Cadena,"SIUProxy",NULL,Maquina,80);
  /*Initially, we consider the class as EDMA-native*/
  Clase->SIUProxy=0;	
  if (r!=0) {
    Clase->SIUProxy=GetProxy(Maquina);
    ECoutDbg (40,-1,"        Class %s in system %d,%s",Clase->ClassName,Clase->IDFParser,GVar->SIUProxy[Clase->SIUProxy].Id);
  }
  
  Clase->IsIDF=GetINIInt(pi,Cadena,"IsIDFParser",0);
  Clase->IsSIU=GetINIInt(pi,Cadena,"IsSIUProxy",0);
  Clase->IsEMI=GetINIInt(pi,Cadena,"IsEMI",0);
  
  return -1;
}

