/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998-2001  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
 * Febraury, 7th, 2001
 * Code cleanup and comment tranlation
 *-------------------------------------------------
 * July, 4th,2001
 * We drop the lines showing error messages in GetProcAddress
 */

#include <dlfcn.h>
#include <stdio.h>
#include <errno.h>
#include "portable.h"

HMEM EDMAPROC LoadLib (EPChar n)
{
  EPVoid      a;
  
  a=dlopen(n,RTLD_NOW|RTLD_GLOBAL);
  if (!a)
    {
      printf (dlerror());
      return 0;
    }
  return ((HMEM)a);
}

EPVoid EDMAPROC GetAddress (HMEM a,EPChar n)
{
  EPVoid     p=0;
  EPChar     error;
  
  p=NULL;
  p=(EPVoid)dlsym((EPVoid)a,n);
  if (p==NULL) {
    error=dlerror();
    if (error!=NULL)
      {
	/* Now, we don't show error messages. This'll be done in an upper level*/
	printf (error);
	return 0;
      }
  }
  return p;
}

EUint32 EDMAPROC UnloadLib (HMEM i)
{
  return dlclose((EPVoid)i);
}

