/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998-2001  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
 Entorno de Desarrollo Modular y ABierto
 (c) Favid Martnez Oliveira
 Versin Beta 0.3r1
 15 de Junio de 1997

 REVISIONES:-------------------------------------------------------
 * Febraury, 24th, 2001
 * Code cleanup and comment translation
 * September, 12th, 2001
 * Added new primitives to manage static methods, casting and clonning
 * ---------------------------------------------------------------------
 * December, 6th, 2001
 * NewObj splitted to allow correct dynamic inheritance management
*/
#ifndef OBJ_H
#define OBJ_H
#include "portable.h"
#include "tobj.h"

#ifdef __cplusplus
extern "C"{
#endif
  OBJID   EDMAPROC NewObj (EPChar,EPVoid);

  OBJID EDMAPROC NewObj_BasicStage (EPChar, EPVoid);
  OBJID EDMAPROC NewObj_VMStage (OBJID);
  OBJID EDMAPROC NewObj_InhStage (OBJID , OBJID,EPVoid);
  OBJID EDMAPROC NewObj_FinalStage (OBJID,EPVoid);

  EUint32 EDMAPROC FreeObj (OBJID);
  EUint32 EDMAPROC FreeOneObj (OBJID);
  EDWord  EDMAPROC MakeVirtual (OBJID );
  EUint32 EDMAPROC SetFinal (OBJID,EUint32);

  OBJID EDMAPROC UpCastObj(OBJID, EPChar);
  OBJID EDMAPROC DownCastObj(OBJID, EPChar);
  OBJID EDMAPROC CastObj(OBJID, EPChar);

  OBJID EDMAPROC CloneObj(OBJID);
  OBJID EDMAPROC ShallowCloneObj(OBJID);
#ifdef __cplusplus
}
#endif


#endif
