/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998-2001  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
 Entorno de Desarrollo Modular y Abierto
 Versin Beta 0.3r1
 (c) David Martnez Oliveira

 Modulo de Query de oOnjetos
 Revisiones: ---------------------------------------------------------
 14 de Agosto de 1997
 ---------------------
 22 de Septiembre de 1997
 Aadimos funciones para el Object INspector
 -----------------------------------
 4 de Enero de 1998
 Eliminamos las funciones de objetos nombrados
 ------------------------------------------
 10 de Mayo de 1999
 Modificamos ObjReport para que muestre informacin de subobjetos y superobjetos
 *------------------------------------------
 * Febraury, 7th, 2001
 * Code cleanup and comment translation
 * ------------------------------------------------
 * November, 17th, 2001
 * Compile warnnings removal
 * --------------------------------------------------------------
 * December, 8th, 2001
 * Minor bug fixed in ObjReport about virtual method information showed
 */

#include <string.h>
#include "portable.h"
#include "vglobal.h"
#include "tobj.h"
#include "obj.h"
#include "sys31.h"

POBJ EDMAPROC GetPObj(OBJID IdObj)
{
  return (&gObj[IdObj]);
}

OBJID EDMAPROC GetParentId (OBJID IdObj)
{
  if (gObj[IdObj].Padre==NULL)
    return -1;
  else    
    return (gObj[IdObj].Padre->IdObj);
}

OBJID EDMAPROC GetPseudoParentId (OBJID IdObj)
{
  if (gObj[IdObj].PseudiPadre==NULL)
    return -1;
  else
    return (gObj[IdObj].PseudiPadre->IdObj);
}

void EDMAPROC SetObjName(OBJID IdObj,EPChar name)
{
  /*
    EChar	iname[64];
    
    strcpy (iname,AppName);
    strcat (iname,name);
    strcpy (gObj[IdObj].Name,iname);
  */
}

EPChar EDMAPROC GetObjName(OBJID IdObj,EPChar *name)
{
  /*
    strcpy (name,gObj[IdObj].Name);
    return name;
  */
}

OBJID EDMAPROC GetIdObjbyName (EPChar name)
{
  /*
    OBJID		i;
    EChar	iname[64];
    EChar	msg[80];
    
    strcpy (iname,AppName);
    strcat (iname,name);
    
    for (i=0;i<GVar->nMaxObj;i++)
    if (strcmp(gObj[i].Name,iname)==0)
    break;
    if (i==GVar->nMaxObj)
    {
    sprintf (msg,"(ERROR) Object Name %s doesn't exist",name);
    ECout (msg);
    i=-1;
    }
    return ((OBJID)(i));
  */
}

EPChar EDMAPROC GetObjClassName(OBJID IdObj,EPChar *name)
{
  strcpy (*name,gClase[gObj[IdObj].IdClase].ClassName);
  return *name;
}

CLASSID EDMAPROC GetObjClassId(OBJID IdObj)
{
  return gObj[IdObj].IdClase;
}

EByte EDMAPROC GetObjStatus(OBJID Id)
{
  return gObj[Id].Flag;
}
EUint32 EDMAPROC GetNObj(void)
{
  return GVar->nObj;
}

EUint32 EDMAPROC GetObjNumSC(OBJID Id)
{
  return gObj[Id].nTabla;
}

OBJID EDMAPROC GetObjSC(OBJID Id,EUint32 i)
{
  return ((POBJ)gObj[Id].Tabla[i].Obj)->IdObj;
}

OBJID EDMAPROC GetObjApp(OBJID Id)
{
  return gObj[Id].IdApp;
}

EUint32 EDMAPROC GetAppId (void)
{
  return AppId;
}

EUint32 EDMAPROC ObjReport(OBJID IdObj)
{
  EUint32	i;
  POBJ		Padre;
  
  ECout1("==OBJECT REPORT==================================================");
  if (gObj[IdObj].Flag==OBJ_FREE) {
    ECout1("Object is free");
    ECout1("==END OBJECT REPORT==========================================");
    return 0;
  }
  
  if (gObj[IdObj].Flag==VIRTUAL_OBJECT)
    ECout1("Object is virtual");
  
  ECout1("Object (%d) of class (%s)",IdObj,gClase[gObj[IdObj].IdClase].ClassName);
  Padre=gObj[IdObj].Padre;
  if (Padre==NULL)
    ECout1("Top Level Object. Object haven't father");
  else
    ECout1("Object Father (%d) of class (%s)",Padre->IdObj
	   ,gClase[Padre->IdClase].ClassName);
  
  Padre=gObj[IdObj].PseudiPadre;
  if (Padre==NULL)
    ECout1("No PseudoFather information");
  else
    ECout1("Object PseudoFather (%d) of class (%s)",Padre->IdObj
	   ,gClase[Padre->IdClase].ClassName);
  
  ECout1("Object has %d superobjects",gObj[IdObj].nTabla);
  for (i=0;i<gObj[IdObj].nTabla;i++)
    ECout1("    Id : (%s) Class : (%s) Class attached Object: (%s)"
	   ,gObj[IdObj].Tabla[i].Id
	   ,gClase[gObj[IdObj].Tabla[i].IdClase].ClassName
	   ,gClase[((POBJ)gObj[IdObj].Tabla[i].Obj)->IdClase].ClassName);
  
  ECout1("Object has %d subobjects",gObj[IdObj].nTabla1);
  for (i=0;i<gObj[IdObj].nTabla1;i++)
    ECout1("    Id : (%s) Class : (%s) Class attached Object: (%s)"
	   ,gObj[IdObj].Tabla1[i].Id
	   ,gClase[gObj[IdObj].Tabla1[i].IdClase].ClassName
	   ,gClase[((POBJ)gObj[IdObj].Tabla1[i].Obj)->IdClase].ClassName);
  
  ECout1("Virtual Methods in object");
  for (i=0;i<gClase[gObj[IdObj].IdClase].nMetVir;i++)
    if (gObj[IdObj].vTabla[i].Flag) {
      if (gObj[IdObj].vTabla[i].Flag==1)
	ECout1 ("    Object [%03d] of Class [%s] overrides Method [%s]",((POBJ)gObj[IdObj].vTabla[i].Obj)->IdObj
		,gClase[((POBJ)gObj[IdObj].vTabla[i].Obj)->IdClase].ClassName
		,gObj[IdObj].vTabla[i].Id);
      else
	ECout1 ("    Main Application overrides Method [%s]",gObj[IdObj].vTabla[i].Id);
    }else
      ECout1 ("    Nobody overrides Method [%s]",gObj[IdObj].vTabla[i].Id);     
  
  ECout1("==END OBJECT REPORT==========================================");
  return 0;
}

