/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998-2001  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
*********************************************************
 Entorno de Desarrollo Modular y Abierto
 (c) David Martnez Oliveira
 Versin Beta 0.3r1

 Vigo 3 de Julio de 1997

 Mdulo para implementacin sobrecarga de mtodos

 REVISIONES:--------------------------------------------------
 3 de Julio de 1997

 Comenzamos la conversin a WIN32
 -------------------------
 21 de Julio de 1997
 Modificamos el interface para que acepte un OBJID en lugar de
 un POBJ.
 Testeamos y corregimos las funciones de manejo de mtodos virtuales
 Todava no vamos a implementar el tema de las signaturas    
 *********************************************************
 * Febraury, 7th, 2001
 * Code cleanup and comment tranlation
 * ------------------------------------------------------------
 * November, 17th, 2001
 * Compile warnning removal
*/

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "portable.h"
#include "classq.h"
#include "shmem.h"
#include "vglobal.h"
#include "clas.h"
#include "obj.h"
#include "pri3.h"
#include "poli.h"

EUint32 EDMAPROC OverMet (OBJID IdObj,EPChar Id,POBJ pObj1,PPROC Func)
{
  POBJ		pObj;
  EUint32	nId,i,l,pos,Ind;
  EUint32	n,j;
  EUint32	Tipo;
  EChar		LocalId[50];
  EChar		*PosStr;
  EChar		Error[80];
  EPfChar	Id1;
  POBJ		OverObj;
  EByte		Flag;
  
  pObj=&gObj[IdObj];
  OverObj=pObj;
  pObj=GetSubObj (pObj,Id,LocalId,"EDMA Override Method Primitive ERROR");
  if (pObj==NULL) {
    ECoutErr("Overriding Method %s aborted.Path Error",Id);
    return 0;
  }
  Tipo=pObj->IdClase;
  for (i=0;i<gClase[Tipo].nMet;i++)
    if (strcmp (pClase[Tipo].Met[i].IdMet,LocalId)==0) break;
  
  Ind=i;
  if (i==gClase[Tipo].nMet) {
    ECoutErr ("Method %s Not Defined in Class %s"
	      ,Id,gClase[Tipo].ClassName);
  } else {
    if ((pClase[Tipo].Met[i].Virtual)) {
      for (i=0;i<gClase[Tipo].nMetVir;i++)
	if (pObj->vTabla[i].Ind==Ind) break;
      if (i==gClase[Tipo].nMetVir) {
	ECoutErr ("Method %s in Class %s isn't Virtual"
		  ,Id,gClase[Tipo].ClassName);
	return 0;
      } else {
	pObj->vTabla[i].Flag=2;
	pObj->vTabla[i].Func=Func;
	if(pObj1==0)
	  pObj->vTabla[i].Obj=OverObj;
	else
	  pObj->vTabla[i].Obj=pObj1;
      }
    }
  }
}

EUint32 EDMAPROC OverMet1 (OBJID IdObj,EPChar Id,POBJ pObj1,PPROC Func,EPChar OverId)
{
  POBJ		pObj;
  EUint32	nId,i,l,pos,Ind;
  EUint32	n,j;
  EUint32	Tipo;
  EChar		LocalId[50];
  EChar		*PosStr;
  EChar		Error[80];
  EPfChar	Id1;
  POBJ		OverObj;
  EByte		Flag;
  
  pObj=&gObj[IdObj];
  OverObj=pObj;
  pObj=GetSubObj (pObj,Id,LocalId,"EDMA Override Method Primitive ERROR");
  if (pObj==NULL) {
    ECoutErr("Overriding Method %s aborted.Path Error",Id);
    return 0;
  }
  Tipo=pObj->IdClase;
  for (i=0;i<gClase[Tipo].nMet;i++)
    if (strcmp (pClase[Tipo].Met[i].IdMet,LocalId)==0) break;
  
  Ind=i;
  if (i==gClase[Tipo].nMet) {
    ECoutErr ("Method %s Not Defined in Class %s",Id,gClase[Tipo].ClassName);
  } else {
    if ((pClase[Tipo].Met[i].Virtual)) {
      for (i=0;i<gClase[Tipo].nMetVir;i++) {
	if (pObj->vTabla[i].Ind==Ind) break;
      }
      if (i==gClase[Tipo].nMetVir) {
	ECoutErr ("Method %s in Class %s isn't Virtual",Id,gClase[Tipo].ClassName);
	return 0;
      } else {
	pObj->vTabla[i].Flag=1;
	strcpy ((EPChar)pObj->vTabla[i].Id,OverId);
	pObj->vTabla[i].Func=Func;
	if(pObj1==0)
	  pObj->vTabla[i].Obj=OverObj;
	else
	  pObj->vTabla[i].Obj=pObj1;
      }
    }
  }
}

EUint32 EDMAPROC OverMet3 (OBJID IdObj,EPChar Id,EPChar Id1)
{
  POBJ		pObj;
  EUint32	nId,i,l,pos,Ind;
  EUint32	n,j;
  EUint32	Tipo;
  EChar		LocalId[50];
  EChar		*PosStr;
  EChar		Error[80];
  POBJ		OverObj,Obj1;
  PPROC		Func;
  
  pObj=&gObj[IdObj];
  Obj1=pObj;
  Obj1=GetSubObj (Obj1,Id1,LocalId,"EDMA Override Method Primitive ERROR");
  if (Obj1==NULL) {
    ECoutErr("Overriding Method %s aborted.Path error",Id);
    return 0;
  }
  Tipo=Obj1->IdClase;
  for (i=0;i<gClase[Tipo].nMet;i++)
    if (strcmp (pClase[Tipo].Met[i].IdMet,LocalId)==0) break;
  
  Ind=i;
  if (i==gClase[Tipo].nMet) {
    ECoutErr ("Method %s Not Defined in Class %s",Id,gClase[Tipo].ClassName);
  } else {
    Func=(PPROC)fClase[Tipo].Met[Ind].Func;
    OverMet1(pObj->IdObj,Id,Obj1,Func,LocalId);
  }
}

EUint32 EDMAPROC RestMet (OBJID IdObj,EPChar Id)
{
  POBJ          pObj;
  EUint32	nId,i,l,pos,Ind;
  EUint32	n,j;
  EUint32	Tipo;
  EChar		LocalId[50];
  EChar		*PosStr;
  EChar		Error[80];
  EPChar	Id1;
  
  pObj=&gObj[IdObj];
  pObj=GetSubObj (pObj,Id,LocalId,"EDMA Restore Method Primitive ERROR");
  if (pObj==NULL) {
    ECoutErr("Restoring Method %s aborted.Incorrect Path",Id);
    return 0;
  }
  Tipo=pObj->IdClase;
  for (i=0;i<gClase[Tipo].nMet;i++)
    if (strcmp (pClase[Tipo].Met[i].IdMet,LocalId)==0) break;
  
  Ind=i;
  if (gClase[Tipo].nMet==i) {
    ECoutErr ("Method %s Not Defined in Class %s"
	      ,Id,gClase[Tipo].ClassName);
  } else {
    if ((pClase[Tipo].Met[i].Virtual)) {
      for (i=0;i<gClase[Tipo].nMetVir;i++)
	if (pObj->vTabla[i].Ind==Ind) break;
      if (i==gClase[Tipo].nMetVir) {
	ECoutErr ("Method %s in Class %s isn't Virtual"
		  ,Id,gClase[Tipo].ClassName);
	return 0;
      } else {
	pObj->vTabla[i].Func=(PPROC)fClase[Tipo].Met[Ind].Func;
	pObj->vTabla[i].Obj=pObj;
      }
    }
  }
}

EUint32	EDMAPROC	OldMet3 (OBJID IdObj,EPChar Id,...)
{
  EUint32	 i;
  POBJ		 pObj;
  EUint32	 Tipo,Ind;
  EChar		 LocalId[50];
  EChar		 Error[80];
  VIR_MET_PARAMS VMParams;
  VIR_DATA	 *VirData;
  PPROC          Func;   
  va_list	 p;
  
  va_start(p,Id);
  pObj=&gObj[IdObj];
  
  if (IdObj>GVar->nMaxObj)
    return -1;
  if (pObj->Flag==0)
    return -1;
  
  if (pObj->Flag==VIRTUAL_OBJECT)
    VirData=pObj->VirData.vMet;
  else
    VirData=0;
  
  pObj=GetSubObj1 (pObj,Id,LocalId,&VirData,V_MET,
		   "EDMA Method Run Primitive ERROR");
  if (pObj==NULL) {
    ECoutErr("Path %s isn't corret for object %d",Id,IdObj);
    return 0;
  }
  if (VirData==0) {
    Tipo=pObj->IdClase;
    for (i=0;i<gClase[Tipo].nMet;i++)
      if (strcmp (pClase[Tipo].Met[i].IdMet,LocalId)==0) break;
    
    if (gClase[Tipo].nMet==i) {
      ECoutErr ("Method %s Not Defined in Class %s"
		,Id,gClase[Tipo].ClassName);
    } else {
      Ind=i;
      Func=(PPROC)fClase[Tipo].Met[Ind].Func;
      
      return Func (pObj->IdObj,*(EPUint32)p
		   ,*((EPUint32)p+1)
		   ,*((EPUint32)p+2)
		   ,*((EPUint32)p+3)
		   ,*((EPUint32)p+4)
		   ,*((EPUint32)p+5)
		   ,*((EPUint32)p+6)
		   ,*((EPUint32)p+7)
		   ,*((EPUint32)p+8)
		   ,*((EPUint32)p+9));
    }
  } else {
    /* We build parameters for virtual method if the object is virtual*/
    {
      Func=VirData->Func[0];
      VMParams.a=p;
      VMParams.Id=LocalId;
      VMParams.IdPrim=RUN_MET;
      VMParams.IdObj=pObj->IdObj;
      VMParams.Ind=i;
      return Func(pObj,(VIR_MET_PARAMS*)&VMParams);
    }
  }
  return 0;
}

