/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1997-2000  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
 Entorno de Desarrollo Modular y Abierto
 (c) David Martnez Oliveira
 Versin Beta 0.3r1
 15 de Junio de 1997

 Primitivas de Objeto de nivel1

 REVISIONES:-------------------------------------------------------------
 15 de Junio de 1997
 Primitivas de nivel 1. Por ahora solo vamos a implementar las de propiedades
 * Tenemos problemas con los tipos reales y la comprobacin de tipos
 del Builder
 * Los tipos enteros funcionan perfectamente
---------------------------------------------------------------
 12 de Julio de 1997
 Vamos a modificar las primitivas para poner en formato
 de nmero de parmetros variable
-------------------------------------------------------
19 de Julio de 1997
 Aadimos el tipo STRING
---------------------------------------------------
24 de Julio de 1997
 Intentamos aadir soporte para matrices
 Mandamos los errores a la consola
--------------------------------
7 de Agosto de 1997
 Aadimos soporte para paso de multiples parmetros desde primitivas
 de nivel 3
--------------------------------------
8 de Agosto de 1997
 Modificacion para mapeo de cdigo por proceso
 Leemos el puntero a la funcin de pClase en lugar de la estructura global
---------------------------------------------
 * 14 de Noviembre de 1997
 *   Aadimos la nueva gestin de tipos a las primitivas de acceso 
 * a propiedades
 *
 * -------------------------
 * 18 de Noviembre de 1997
 *   Aadimos soporte para tipos definidos por usuario
 * 
 * -------------------------------
 * January, 30, 2001
 * Version number changing -> 0.5.1
 * pri1.c : Level 1 EDMA primitives
 *
 * Code don't compile with RH7, due to type promotion in va_args macros.
 * We'll try to fix it. We'll begin code clean up
 * --------------------------------------------------------------------------
 * October, 23th, 2001
 * Finally we check for access modifiers in read and write operations.
 *
 * This feature isn't fully tested, but it seems to work right
 * -----------------------------------------------------------------
 * November, 18th, 2001
 * Compile warnnings removal
*/

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "portable.h"
#include "tobj.h"
#include "vglobal.h"
#include "classq.h"
#include "shmem.h"
#include "ptypes.h"
#include "ttypes.h"
#include "const.h"
#include "tclass.h"
#include "misc.h"

EPVoid EDMAPROC	WProp1 (OBJID IdObj,EUint32 Ind,...)
{
  EChar		Cadena[80];
  EUint32	Tipo;
  EUint32	Off;
  EPVoid	Punt;
  va_list	p;
  EPChar	c,c1;
  HMEM		h;
  EUint32	tam;
  ESint16       kk;
  
  /* Check Object Reference */
  if (IdObj<MAX_OBJ) {
    if (gObj[IdObj].Flag==0) {
      ECoutErr ("Object %d doesnt exist",IdObj);
      return (EPVoid)-1;
    }
  } else {
    ECoutErr ("Object %d doesnt exist",IdObj);
    return (EPVoid)-1;
  }
  /* Check for write permission*/
  if (pClase[gObj[IdObj].IdClase].Prop[Ind].ioTipo==L) {
    ECoutErr("[ERROR] Property %s is read only",pClase[gObj[IdObj].IdClase].Prop[Ind].IdProp);
    return (EPVoid)-1;
  }
  Off=pClase[gObj[IdObj].IdClase].Prop[Ind].Off;
  if (Off>gClase[gObj[IdObj].IdClase].TamDatos)
    ECoutErr("(WProp1) Offset out of ranger for property %d of object %d",Ind,IdObj);
  Tipo=pClase[gObj[IdObj].IdClase].Prop[Ind].Tipo;
  Punt=(EPByte)(gObj[IdObj].Datos)+Off;
  
  /* p points to first parameter */
  va_start(p,Ind);
  /* Special processing for User Defined Types */
  if (Tipo==DT_EUSER) {
    if (pClase[gObj[IdObj].IdClase].Prop[Ind].UserInfo!=-1)
      Met3(*((OBJID*)Punt),"Write",p);
    else {
      ECoutErr ("(WProp1) User type not defined for property");
      return (EPVoid)-1;
    }
  }
  /* Check array flag */
  if ((tam=pClase[gObj[IdObj].IdClase].Prop[Ind].nElem)!=0) {
    tam*=tipo[Tipo].tam;
    strncpy (Punt,va_arg(p,EPVoid),tam);
  }
  switch (Tipo)
    {
    case DT_EOBJECT:
    case DT_EUINT32:
      *((EPUint32)Punt)=va_arg(p,EUint32);
      break;
    case DT_ESINT32:
      *((EPSint32)Punt)=va_arg(p,ESint32);
      break;
    case DT_ESINT8:
    case DT_ECHAR:
      *((EPChar)Punt)=va_arg(p,int);
      break;
    case DT_EZSTRING:
      c=va_arg(p,EPChar);
      tam=strlen(c);
      PFree (*((HMEM*)Punt),(EPVoid)*((HMEM*)Punt));
      h=PAlloc (sizeof(EByte)*(tam+1));
      c1=PGet(h);
      strncpy(c1,c,tam);
      c1[tam]=0;
      *((HMEM*)Punt)=h;
      break;
    case DT_ESINT16:
      *((EPSint16)Punt)=(ESint16)va_arg(p,int);
      break;
    case DT_EUINT16:
      *((EPUint16)Punt)=va_arg(p,int);
      break;
    case DT_EUINT8:
    case DT_EBYTE:
      *((EPByte)Punt)=va_arg(p,int);
      break;
    case DT_EWORD:
      *((EPWord)Punt)=va_arg(p,int);;
      break;
    case DT_EDWORD:
      *((EPDWord)Punt)=va_arg(p,EDWord);;
      break;
    case DT_EREAL32:
      *((EPReal32)Punt)=va_arg(p,double);;
      break;
    case DT_EREAL64:
      *((EPReal64)Punt)=va_arg(p,EReal64);
      break;
    }
  
  return Punt;
}

EPVoid EDMAPROC	RProp1 (OBJID IdObj,EUint32 Ind,...)
{
  EChar		Cadena[80];
  EUint32	Tipo;
  EUint32	Off,tam;
  EPVoid	Punt;
  va_list	p;
  EPChar	c,c1;

  /* Check Object Reference */
  if (IdObj<MAX_OBJ) {
    if (gObj[IdObj].Flag==0) {
      ECoutErr ("[RProp1] Object %d doesn't exist",IdObj);
      return (EPVoid)-1;
    }
  } else {
    ECoutErr ("[RProp1] Object %d doesn't exist",IdObj);
    return (EPVoid)-1;
  }
  /* Check for write permission*/
  if (pClase[gObj[IdObj].IdClase].Prop[Ind].ioTipo==E) {
    ECoutErr("[ERROR] Property %s is write only... whatever means that!"
	     ,pClase[gObj[IdObj].IdClase].Prop[Ind].IdProp);
    return (EPVoid)-1;
  }
  Off=pClase[gObj[IdObj].IdClase].Prop[Ind].Off;
  Tipo=pClase[gObj[IdObj].IdClase].Prop[Ind].Tipo;
  Punt=(EPByte)(gObj[IdObj].Datos)+Off;
  
  va_start(p,Ind);
  /* Special Processing for User Defined Data Types */
  if (Tipo==DT_EUSER) {
    if (pClase[gObj[IdObj].IdClase].Prop[Ind].UserInfo!=-1)
      Met3(*((OBJID*)Punt),"Read",p);
    else {
      ECoutErr ("[RProp1] User type not defined for property");
      return (EPVoid)-1;
    }
  }   
  /* If it's an array we returns a reference */
  if (pClase[gObj[IdObj].IdClase].Prop[Ind].nElem!=0) {
    *(va_arg(p,EPByte*))=(EPByte)Punt;
    return Punt;
  }    
  switch (Tipo)
    {
    case DT_EOBJECT:
    case DT_EUINT32:
      *(va_arg(p,EPUint32))=*((EPUint32)Punt);
      break;
    case DT_ESINT32:
      *(va_arg(p,EPSint32))=*((EPSint32)Punt);
      break;
    case DT_ESINT8:
    case DT_ECHAR:
      *(va_arg(p,EPChar))=*((EPChar)Punt);
      break;
    case DT_EZSTRING:
      c=(va_arg(p,EPChar));
      c1=PGet(*((HMEM*)Punt));
      strcpy(c,c1);
      break;
    case DT_EUINT16:
      *(va_arg(p,EPUint16))=*((EPUint16)Punt);
      break;
    case DT_ESINT16:
      *(va_arg(p,EPSint16))=*((EPSint16)Punt);
      break;
    case DT_EUINT8:
    case DT_EBYTE:
      *(va_arg(p,EPByte))=*((EPByte)Punt);
      break;
    case DT_EWORD:
      *(va_arg(p,EPWord))=*((EPWord)Punt);
      break;
    case DT_EDWORD:
      *(va_arg(p,EPDWord))=*((EPDWord)Punt);
      break;
    case DT_EREAL32:
      *(va_arg(p,EPReal32))=*((EPReal32)Punt);
      break;
    case DT_EREAL64:
      *(va_arg(p,EPReal64))=*((EPReal64)Punt);
      break;
    }
}

EUint32 EDMAPROC Met1 (OBJID IdObj,EUint32 Ind,EByte Old,EPVoid Val)
{
  PPROC	        Func;
  EUint32	Tipo,i;
  EPVoid	Punt;
  EChar		Cadena[80];
  POBJ		Obj;
  
  /* Check Object Reference */
  if (IdObj<MAX_OBJ) {
    if (gObj[IdObj].Flag==0) {
      ECoutErr ("[Met1] Object %d doesnt exist",IdObj);
      return -1;
    }
  } else {
    ECoutErr ("[Met1]Object %d doesnt exist",IdObj);
    return -1;
  }
  
  Obj=&gObj[IdObj];
  Tipo=Obj->IdClase;
  if ((pClase[Tipo].Met[Ind].Virtual)&&Old==0) {
    for (i=0;i<gClase[Tipo].nMetVir;i++)
      if (Obj->vTabla[i].Ind==Ind)
	break;
    Func=Obj->vTabla[i].Func;
    IdObj=((POBJ)Obj->vTabla[i].Obj)->IdObj;
  } else
    Func=(PPROC)fClase[Tipo].Met[Ind].Func;
  
  Tipo=Func (IdObj,Val);
  return (Tipo);
}

EPVoid EDMAPROC	EDMAWProp1 (OBJID IdObj,EUint32 Ind,EPVoid p)
{
  EChar		Cadena[80];
  EUint32	Tipo;
  EUint32	Off;
  EPVoid	Punt;
  EPChar	c,c1;
  HMEM		h;
  EUint32	tam;
  EDMAT_BUFFER  Buf;

  /* Checks object reference */
  if (IdObj<MAX_OBJ) {
    if (gObj[IdObj].Flag==0) {
      ECoutErr ("[EDMAWProp1]Object %d doesnt exist",IdObj);
      return (EPVoid)-1;
    }
  } else {
    ECoutErr ("[EDMAWProp1]Object %d doesnt exist",IdObj);
    return (EPVoid)-1;
  }
  /* Check for write permission*/
  if (pClase[gObj[IdObj].IdClase].Prop[Ind].ioTipo==L) {
    ECoutErr("[ERROR] Property %s is read only",pClase[gObj[IdObj].IdClase].Prop[Ind].IdProp);
    return (EPVoid)-1;
  }
  Off=pClase[gObj[IdObj].IdClase].Prop[Ind].Off;
  if (Off>gClase[gObj[IdObj].IdClase].TamDatos)
    ECoutErr("[EDMAWProp1] Offset out of ranger for property %d of object %d",Ind,IdObj);
  
  Tipo=pClase[gObj[IdObj].IdClase].Prop[Ind].Tipo;
  Punt=(EPByte)(gObj[IdObj].Datos)+Off;
  
  /* Special processing for user datatypes */
  if (Tipo==DT_EUSER) {
    if (pClase[gObj[IdObj].IdClase].Prop[Ind].UserInfo!=-1)
      Met3(*((OBJID*)Punt),"Write",p);
    else {
      ECoutErr ("[EDMAWProp1] User type not defined for property");
      return (EPVoid)-1;
    }
  }   
  
  /* If it's an array... */
  if ((tam=pClase[gObj[IdObj].IdClase].Prop[Ind].nElem)!=0) {
    tam*=tipo[Tipo].tam;
    memcpy (Punt,va_arg(p,EPVoid),tam);
    return p;
  }
  switch (Tipo)
    {
    case DT_EBUFFER:
      Buf=va_arg(p,EDMAT_BUFFER);
      memcpy(Punt,&Buf,sizeof(EDMAT_BUFFER));
      break;	   
    case DT_EOBJECT:
    case DT_EUINT32:
      *((EPUint32)Punt)=va_arg(p,EUint32);
      break;
    case DT_ESINT32:
      *((EPSint32)Punt)=va_arg(p,ESint32);
      break;
    case DT_ESINT8:
    case DT_ECHAR:
      *((EPChar)Punt)=va_arg(p,int);
      break;
    case DT_EZSTRING:
      c=va_arg(p,EPChar);
      tam=strlen(c);
      PFree (*((HMEM*)Punt),(EPVoid)*((HMEM*)Punt));
      h=PAlloc (sizeof(EByte)*(tam+1));
      c1=PGet(h);
      strncpy(c1,c,tam);
      c1[tam]=0;
      *((HMEM*)Punt)=h;
      break;
    case DT_ESINT16:
      *((EPSint16)Punt)=va_arg(p,int);;
      break;
    case DT_EUINT16:
      *((EPUint16)Punt)=va_arg(p,int);;
      break;
    case DT_EUINT8:
    case DT_EBYTE:
      *((EPByte)Punt)=va_arg(p,int);;
      break;
    case DT_EWORD:
      *((EPWord)Punt)=va_arg(p,int);;
      break;
    case DT_EDWORD:
      *((EPDWord)Punt)=va_arg(p,EDWord);;
      break;
    case DT_EREAL32:
      *((EPReal32)Punt)=va_arg(p,EReal64);
      break;
    case DT_EREAL64:
      *((EPReal64)Punt)=va_arg(p,EReal64);
      break;
    }
  return Punt;
}

EPVoid EDMAPROC	EDMARProp1 (OBJID IdObj,EUint32 Ind,EPVoid p)
{
  EChar		Cadena[80];
  EUint32	Tipo;
  EUint32	Off,tam;
  EPVoid	Punt;
  EPChar	*c,c1,c2;
  EDMAT_BUFFER  *Buf;

  /* Checks Object Reference */
  if (IdObj<MAX_OBJ) {
    if (gObj[IdObj].Flag==0) {
      ECoutErr ("[EDMARProp1] Object %d doesnt exist",IdObj);
      return (EPVoid)-1;
    }
  } else {
    ECoutErr ("[EDMARProp1] Object %d doesnt exist",IdObj);
    return (EPVoid)-1;
  }
  if (pClase[gObj[IdObj].IdClase].Prop[Ind].ioTipo==E) {
    ECoutErr("[ERROR] Property %s is write only... whatever means that!",pClase[gObj[IdObj].IdClase].Prop[Ind].IdProp);
    return (EPVoid)-1;
  }
  Off=pClase[gObj[IdObj].IdClase].Prop[Ind].Off;
  Tipo=pClase[gObj[IdObj].IdClase].Prop[Ind].Tipo;
  Punt=(EPByte)(gObj[IdObj].Datos)+Off;
  
  /* Special processing for user datatypes */
  if (Tipo==DT_EUSER) {
    if (pClase[gObj[IdObj].IdClase].Prop[Ind].UserInfo!=-1)
      Met3(*((OBJID*)Punt),"Read",p);
    else {
      ECoutErr ("[EDMARProp1] User type not defined for property");
      return (EPVoid)-1;
    }
  }   
  /* Get array reference */
  if (pClase[gObj[IdObj].IdClase].Prop[Ind].nElem!=0) {
    *(va_arg(p,EPByte*))=Punt;
    return Punt;
  }
  switch (Tipo)
    {
    case DT_EBUFFER:
      Buf=va_arg(p,EDMAT_BUFFER*);
      memcpy(Buf,Punt,sizeof(EDMAT_BUFFER));
      break;
    case DT_EOBJECT:
    case DT_EUINT32:
      *(va_arg(p,EPUint32))=*((EPUint32)Punt);
      return (EPVoid)(*((EPUint32)Punt));
      break;
    case DT_ESINT32:
      *(va_arg(p,EPSint32))=*((EPSint32)Punt);
      return (EPVoid)(*((EPSint32)Punt));
      break;
    case DT_ESINT8:
    case DT_ECHAR:
      *(va_arg(p,EPChar))=*((EPChar)Punt);
      return (EPVoid)(*((EPChar*)Punt));
      break;
    case DT_EZSTRING:
      /* Old code... new code is been tested*/
      /*
      c=(EPChar*)(va_arg(p,EPChar));
      c1=PGet(*((HMEM*)Punt));
      strcpy(c,c1);
      break;
      */
      c2=(EPChar)(va_arg(p,EPChar));
      c1=PGet(*((HMEM*)Punt));
      strcpy(c2,c1);
      break;
    case DT_ESINT16:
      *(va_arg(p,EPSint16))=*((EPSint16)Punt);
      /* XXXXXXXXXXX: Check if this expression is correct.*/
      return (EPVoid)*((EPSint16*)Punt);
      break;
    case DT_EUINT16:
      *(va_arg(p,EPUint16))=*((EPUint16)Punt);
      /* XXXXXXXXXXX: Check if this expression is correct.*/
      return (EPVoid)*((EPUint16*)Punt);
      break;
    case DT_EUINT8:
    case DT_EBYTE:
      *(va_arg(p,EPByte))=*((EPByte)Punt);
      /* XXXXXXXXXXX: Check if this expression is correct.*/
      return (EPVoid)*((EPByte*)Punt);
      break;
    case DT_EWORD:
      *(va_arg(p,EPWord))=*((EPWord)Punt);
      /* XXXXXXXXXXX: Check if this expression is correct.*/
      return (EPVoid)*((EPWord*)Punt);
      break;
    case DT_EDWORD:
      *(va_arg(p,EPDWord))=*((EPDWord)Punt);
      return (EPVoid)*((EPDWord)Punt);
      break;
    case DT_EREAL32:
      *(va_arg(p,EPReal32))=*((EPReal32)Punt);
      break;
    case DT_EREAL64:
      *(va_arg(p,EPReal64))=*((EPReal64)Punt);
      break;
    }
}


EUint32 EDMAPROC EDMAMet1 (OBJID IdObj,EUint32 Ind,EByte Old,EPVoid p)
{
  EUint32	Tipo,i;
  EPVoid	Punt;
  EChar		Cadena[80];
  POBJ		Obj;
  /*int		(EDMAPROC *Func)(OBJID,...);*/
  PPROC         Func;
  EPUint32	para[10];	/*Ten parameters maximum*/
  
  /* Checks Object reference*/
  if (IdObj<MAX_OBJ) {
    if (gObj[IdObj].Flag==0) {
      ECoutErr ("[EDMAMet1] Object %d doesnt exist",IdObj);
      return -1;
    }
  } else {
    ECoutErr ("[EDMAMet1] Object %d doesnt exist",IdObj);
    return -1;
  }
  
  Obj=&gObj[IdObj];
  Tipo=Obj->IdClase;
  if ((pClase[Tipo].Met[Ind].Virtual)&&Old==0) {
    for (i=0;i<gClase[Tipo].nMetVir;i++)
      if (Obj->vTabla[i].Ind==Ind)
	break;
    Func=(PPROC)Obj->vTabla[i].Func;
    IdObj=((POBJ)Obj->vTabla[i].Obj)->IdObj;
  } else
    Func=(PPROC)fClase[Obj->IdClase].Met[Ind].Func;
  
  /*Tipo=Func (IdObj,para[0],para[1],para[2],para[3],para[4],para[5],para[6],para[7],para[8],para[9]);*/
  return (Tipo);
}


