/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998-2001  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
 Entorno de Desarrollo Modular y Abierto
 (c) David Martnez Oliveira
 Versin Beta 0.3r1
 2 de Julio de 1997

 Primitivas de Objeto de Nivel 3

 REVISIONES:-------------------------------------------------------------
 10 de Julio de 1997
 Aadimos la funcin GetRef3 para acceso directo al bloque de datos
 de los objetos. Se ha testeado con enteros satisfactoriamente. Falta testear
 con otros tipos.
 --------------------------------
 4 de Agosto de 1997

 Vamos a aadir el soporte para mtodos polimrficos mediante signaturas
 y a aadir modificaciones para la integracin de SIU.
 ----------------------------
 7 de AGosto de 1997

 Estamos modificando la funcin de las signaturas para trabajar con mltiples
 parmetros.
 Revisin del interface de las primitivas de nivel 3
-------------------------------
 8 de Agosto de 1997
 Movemos las funciones de parssing a otro mdulo
 Modificacin para mapeo de cdigo por proceso. Leemos el puntero a la funcin
 de pClase en lugar de la estructura global    
 -----------------------------------------
 21 de Agosto de 1997
 Utilizamos ECoutErr para mostrar los mensajes de ERROR
 COrregimos el mensaje en la primitiva de jecucin de objetos
 --------------------------------------
 22 de Agosto de 1997
 Modificacin en las funciones de escritura/lectura de propiedades
 para soportar objetos virtuales
 ----------------------------------------
 31 de Agosto de 1997
 Intentamos la modificacin para integracin de SIU
 * --------------------------
 * 21/11/1997
 *   Modificacin para el soporte de sobrecarga de mtodos virtuales desde
 * la aplicacin.
 * 
 *    SI el objeto asociado al metodo sobrecargado es NULL, consideramos
 * que ha sido sobrecargado por una aplicacin y no obtenemos el identificador
 * del objeto del puntero, sino que se iguala a -1
 * ----------------------------
 * 10/12/1997
 * 
 *  Intentamos aadir funciones primitivas de soporte para proxys, que
 * reciban los parametros empaquetados en un bloque de memoria.
 * ---------------------------
 * 26/01/1998
 * 
 *   Intentamos aadir el interface de un nivel para la herencia
 * ------------------------------------------------------------
 * Febraury, 7th, 2001
 * Code cleanup and comment translation
 * ---------------------------------------------------------------------
 * November, 17th, 2001
 * Compile warnnings removal
*/

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "portable.h"
#include "vglobal.h"
#include "pri1.h"
#include "pri3.h"
#include "misc.h"
#include "getobj.h"

ESint32 EDMAPROC Look4Prop (POBJ *pObj1,EPChar PropName);
ESint32 EDMAPROC Look4Met (POBJ *pObj1,EPChar MetName);

/*
** Level 3 object primitives
*/

EPVoid	EDMAPROC	WProp3 (OBJID IdObj,EPChar Id,...)
{
  EUint32	 i,l;
  POBJ		 pObj,ObjIni,ObjAux;
  EUint32	 Tipo;
  EChar		 LocalId[50];
  EChar		 Error[80];
  VIR_MET_PARAMS VMParams;
  VIR_DATA	 *VirData;
  PPROC          Func;   
  va_list	 p;
  
  va_start(p,Id);
  pObj=&gObj[IdObj];
  
  ObjIni=pObj;
  if (IdObj>GVar->nMaxObj)
    return (EPVoid)-1;
  if (pObj->Flag==0)
    return (EPVoid)-1;
  
  if (pObj->Flag==VIRTUAL_OBJECT)
    VirData=pObj->VirData.vProp;
  else
    VirData=0;
  
  ObjAux=pObj;
  pObj=GetSubObj1 (pObj,Id,LocalId,&VirData,V_PROP
		   ,"EDMA Write Property Primitive ERROR");
  if(VirData!=0)
    if (VirData->Func[WRITE_PROP]==NULL) {
      VirData=0;
      pObj=GetSubObj (pObj,Id,LocalId,"EDMA Write Property Primitive ERROR");
    }
  /*Modification for SIU execution within inheritance trees*/
  if (ObjAux->IdSIU!=-1) {
    pObj=ObjAux;
    strcpy(LocalId,Id);
  }
  /* Modification ends*/
  if (pObj==NULL) {
    ECoutErr("Path %s isn't corret for object %d",Id,IdObj);
    return 0;
  }
  if (VirData==0) {
    i=Look4Prop(&pObj,LocalId);
    Tipo=pObj->IdClase;
    if (i==-1) {
      /* Modification for SIU Support */
      if (pObj->IdSIU!=-1) {
	Met3(IdObj,"WProp3",pObj->IdSIU,LocalId,p);
	return 0;
      }
      /* Modification ends */
      ECoutErr ("Property %s Not Defined in Class %s"
		,Id,gClase[Tipo].ClassName);
    } else
      EDMAWProp1 (pObj->IdObj,i,p);
  } else {
    /*We build parameters for virtual method in virtual object call*/
    {
      Func=VirData->Func[WRITE_PROP];
      VMParams.a=p;
      VMParams.Id=LocalId;
      VMParams.IdPrim=WRITE_PROP;
      VMParams.IdObj=pObj->IdObj;
      VMParams.Ind=i;
      return (EPVoid)Func(pObj->IdObj,&VMParams);
    }
  }
}

EPVoid	EDMAPROC	RProp3 (OBJID IdObj,EPChar Id,...)
{
  EUint32	i,l,fin;
  POBJ		pObj,ObjIni,ObjAux;
  EUint32	Tipo;
  EChar		LocalId[50];
  EChar		Error[80];
  VIR_MET_PARAMS	VMParams;
  VIR_DATA	*VirData;
  PPROC         Func;   
  va_list	p;
  
  fin=SetFinal(IdObj,1);
  va_start(p,Id);
  pObj=&gObj[IdObj];
  
  ObjIni=pObj;
  if (IdObj>GVar->nMaxObj)
    return (EPVoid)-1;
  if (pObj->Flag==0)
    return (EPVoid)-1;
  
  if (pObj->Flag==VIRTUAL_OBJECT)
    VirData=pObj->VirData.vProp;
  else
    VirData=0;
  
  ObjAux=pObj;
  pObj=GetSubObj1 (pObj,Id,LocalId,&VirData,V_PROP
		   ,"EDMA Write Property Primitive ERROR");
  if(VirData!=0)
    if (VirData->Func[READ_PROP]==NULL) {
      VirData=0;
      pObj=&gObj[IdObj];
      pObj=GetSubObj (pObj,Id,LocalId
		      ,"EDMA Write Property Primitive ERROR");
    }
  /*Modification for SIU execution within inheritance Trees*/
  if (ObjAux->IdSIU!=-1) {
    pObj=ObjAux;
    strcpy(LocalId,Id);
  }   
  if (pObj==NULL) {
    ECoutErr("Path %s isn't corret for object %d",Id,IdObj);
    SetFinal(IdObj,fin);
    return 0;
  }
  if (VirData==0) {
    i=Look4Prop(&pObj,LocalId);
    Tipo=pObj->IdClase;
    if (i==-1) {
      /*Modification for SIU*/
      if (pObj->IdSIU!=-1) {
	Met3(IdObj,"RProp3",pObj->IdSIU,LocalId,*(EPVoid*)p);
	SetFinal(IdObj,fin);
	return 0;
      }
      /*Ends SIU modification*/
      
      ECoutErr ("Property %s Not Defined in Class %s"
		,Id,gClase[Tipo].ClassName);
    } else {
      SetFinal(IdObj,fin);
      return EDMARProp1 (pObj->IdObj,i,p);
    }
  } else {
    /*We build parameters for virtual method call on virtual object*/
    {
      Func=VirData->Func[READ_PROP];
      VMParams.a=p;
      VMParams.Id=LocalId;
      VMParams.IdPrim=READ_PROP;
      VMParams.IdObj=pObj->IdObj;
      VMParams.Ind=i;
      SetFinal(IdObj,fin);
      return (EPVoid)Func(pObj->IdObj,&VMParams);
    }
  }
}

/*
*** 4 de Agosto de 1997
***		Soporte para signaturas y polimorfismo
***		Soporte para nmero de parmetros variable:
Mientras no tengamos ensamblador los mtodos recibirn
un parmetros "ghost" que es el puntero a los parmetros

*** 	Modificaciones a GetSubObj para integracin SIU
***		Met3S permite ejecutar mtodos firmados
*/

EPVoid	EDMAPROC	Met3S (OBJID IdObj,EPChar Id,EPChar Sig,...)
{
  OBJID		sObj,iObj;
  EUint32	i,l;
  EUint32	n,j,k,Ind;
  POBJ		pObj,ObjIni,ObjAux;
  EUint32	Tipo;
  EChar		LocalId[50];
  EChar		Error[80];
  EPChar	Id1;
  VIR_MET_PARAMS	VMParams;
  VIR_DATA	*VirData;
  PPROC         Func;   
  va_list	p;
  EByte		p1[32];
  EChar		MiSig[50];
  EChar         SAux[2];   
  int		(EDMAPROC *aFunc)(OBJID,...);
  EPVoid	Last;
  
  /* We get a pointer to the function paramters */
  va_start(p,Sig);
  pObj=&gObj[IdObj];
  
  ObjIni=pObj;
  if (IdObj>GVar->nMaxObj)
    return (EPVoid)-1;
  if (pObj->Flag==0)
    return (EPVoid)-1;
  
  if (pObj->Flag==VIRTUAL_OBJECT)
    VirData=pObj->VirData.vMet;
  else
    VirData=0;
  /* We build the signature for object's type... 
     not implemented at the moment*/
  for (i=0;i<50;i++)
    MiSig[i]=0;
  j=strlen(Sig);
  n=0;	/* We count how many parameter we have*/
  SAux[1]=0;   
  for (i=0;i<j;i++)
    if ((Sig[i]!='O')&& (Sig[i]!='L'))	{ /* if it's a simple type*/ 
      SAux[0]=*(Sig+i);
      strcat (MiSig,SAux);
      n++;
    } else	/*else*/
      if (Sig[i]=='O')	{ /*if we must to expand signature*/
	sObj=(OBJID)(*((EPUint32)p+n));
	strcat (MiSig,gClase[gObj[sObj].IdClase].ClassName);
	n++;
      } else {	/*else it's a class identifier*/
	l=strchr(Sig+i,';')-(Sig+i)-1;
	k=strlen(MiSig);
	strncpy(MiSig+k,Sig+i+1,l);
	i+=(l+1);
	n++;
      }
  
  ObjAux=pObj;
  pObj=GetSubObj1 (pObj,Id,LocalId,&VirData,V_MET
		   ,"EDMA Method Run Primitive ERROR");
  if (ObjAux->IdSIU!=-1) {
    strcpy(MiSig,Sig);
    pObj=ObjAux;
    strcpy(LocalId,Id);
  }
  if ((pObj==NULL)) {
    ECoutErr("Path %s isn't corret for object %d",Id,IdObj);
    return 0;
  }
  
  if (VirData==0) {
    Tipo=pObj->IdClase;
    for (i=0;i<gClase[Tipo].nMet;i++) {
      /* if we've found the identifier...*/
      if (strcmp (pClase[Tipo].Met[i].IdMet,LocalId)==0)
	/* and matches the signature */
	if (strcmp(pClase[Tipo].Met[i].Sign,MiSig)==0)
	  break;
    }
    Ind=i;
    if (gClase[Tipo].nMet==i) {
      /* Modification for SIU*/
      if (pObj->IdSIU!=-1) {
	return Met3(IdObj,"Met3S",pObj->IdSIU,LocalId,MiSig,p);
      }
      /* Modification ends*/
      ECoutErr ("Method %s Not Defined in Class %s"
		,Id,gClase[Tipo].ClassName);
    } else {
      if ((pClase[Tipo].Met[Ind].Virtual)) {
	for (i=0;i<gClase[Tipo].nMetVir;i++)
	  if (pObj->vTabla[i].Ind==Ind)
	    break;
	if (pObj->vTabla[i].Flag==1) {
	  /* We allow execution wirh multiple override */
	  iObj=((POBJ)pObj->vTabla[i].Obj)->IdObj;
	  return Met3(iObj,(EPChar)pObj->vTabla[i].Id,*(EPUint32)p
		      ,*((EPUint32)p+1),*((EPUint32)p+2)
		      ,*((EPUint32)p+3),*((EPUint32)p+4)
		      ,*((EPUint32)p+5),*((EPUint32)p+6)
		      ,*((EPUint32)p+7),*((EPUint32)p+8)
		      ,*((EPUint32)p+9));
	  
	}
	Func=pObj->vTabla[i].Func;
	pObj=((POBJ)pObj->vTabla[i].Obj);
	if (pObj==NULL)
	  iObj=-1;
	else
	  iObj=pObj->IdObj;
      } else {
	Func=(PPROC)fClase[Tipo].Met[Ind].Func;
	iObj=pObj->IdObj;
      }
      Func (iObj,*(EPUint32)p,*((EPUint32)p+1),*((EPUint32)p+2)
	    ,*((EPUint32)p+3),*((EPUint32)p+4),*((EPUint32)p+5)
	    ,*((EPUint32)p+6),*((EPUint32)p+7),*((EPUint32)p+8)
	    ,*((EPUint32)p+9));
    }
  } else {
    /*We build paramters for virtual method if the host object is virtual*/
    {
      Func=VirData->Func[0];
      VMParams.a=p;
      VMParams.Id=LocalId;
      VMParams.IdPrim=RUN_MET;
      VMParams.IdObj=pObj->IdObj;
      VMParams.Ind=i;
      
      return (EPVoid)Func(pObj->IdObj,&VMParams);
    }
  }
}

EPVoid	EDMAPROC	Met3 (OBJID IdObj,EPChar Id,...)
{
  OBJID         iObj;   
  EUint32	i,j;
  POBJ		pObj;
  EUint32	Tipo,Ind;
  EChar		LocalId[50];
  EChar		Error[80];
  VIR_MET_PARAMS	VMParams;
  VIR_DATA	*VirData;
  PPROC         Func;   
  va_list	p;
  
  va_start(p,Id);
  pObj=&gObj[IdObj];

  if (IdObj>GVar->nMaxObj)
    return (EPVoid)-1;
  if (pObj->Flag==0)
    return (EPVoid)-1;
  
  if (pObj->Flag==VIRTUAL_OBJECT)
    VirData=pObj->VirData.vMet;
  else
    VirData=0;
  
  pObj=GetSubObj1 (pObj,Id,LocalId,&VirData,V_MET
		   ,"EDMA Method Run Primitive ERROR");
  if (pObj==NULL) {
    ECoutErr("Path %s isn't corret for object %d",Id,IdObj);
    return 0;
  }
  if (VirData==0) {
    i=Look4Met(&pObj,LocalId);
    Tipo=pObj->IdClase;
    /*ECout1 ("[Met3] Located method %s [%d] in object %d [%s]",LocalId,i,
	    pObj->IdObj, gClase[Tipo].ClassName);*/

    if (i==-1) {
      ECoutErr ("Method %s Not Defined in Class %s"
		,Id,gClase[Tipo].ClassName);
    } else {
      Ind=i;
      if ((pClase[Tipo].Met[Ind].Virtual)) {
	/* We look for the virtual method we want toi execute */
	for (i=0;i<gClase[Tipo].nMetVir;i++)
	  if (pObj->vTabla[i].Ind==Ind)
	    break;
	/*ECout1 ("[Met3] Virtual Method found: %d of %d",i,gClase[Tipo].nMetVir);*/
	/* if it's overriden by an object*/
	if (pObj->vTabla[i].Flag==1) {
	  /*ECout1 ("[Met3] This method is overriden");*/
	  /* We allow multiple override execution*/
	  iObj=((POBJ)pObj->vTabla[i].Obj)->IdObj;
	  return Met3(iObj,(EPChar)pObj->vTabla[i].Id,*(EPUint32)p
		      ,*((EPUint32)p+1),*((EPUint32)p+2)
		      ,*((EPUint32)p+3),*((EPUint32)p+4)
		      ,*((EPUint32)p+5),*((EPUint32)p+6)
		      ,*((EPUint32)p+7),*((EPUint32)p+8)
		      ,*((EPUint32)p+9));
	  
	}
	Func=pObj->vTabla[i].Func;
	pObj=((POBJ)pObj->vTabla[i].Obj);
	if (pObj==NULL)
	  iObj=-1;
	else
	  iObj=pObj->IdObj;
      } else {
	/*ECout1 ("Method not overriden... simple run it...");*/
	Func=(PPROC)fClase[Tipo].Met[Ind].Func;
	iObj=pObj->IdObj;
      }
      /*ECout1 ("[Met3] Running Method at : %p",Func);*/
      return (EPVoid)Func (iObj,*(EPUint32)p,*((EPUint32)p+1),*((EPUint32)p+2)
		   ,*((EPUint32)p+3),*((EPUint32)p+4),*((EPUint32)p+5)
		   ,*((EPUint32)p+6),*((EPUint32)p+7),*((EPUint32)p+8)
		   ,*((EPUint32)p+9));
    }
  } else {
    /*We build paramters for vitual method if the host object is virtual*/
    {
      Func=VirData->Func[0];
      VMParams.a=p;
      VMParams.Id=LocalId;
      VMParams.IdPrim=RUN_MET;
      VMParams.IdObj=pObj->IdObj;
      VMParams.Ind=i;
      
      return (EPVoid)Func(pObj->IdObj,(VIR_MET_PARAMS*)&VMParams);
    }
  }
  return 0;
}

/*
**********************************************************************
** GetVirtualData
**********************************************************************
**	ENTRADA:
**		pObj	-> Puntero a SubObjeto Virtual
**		Id	-> Identificador de dato virtual a localizar
**		ini	-> Puntero a dato virtual inicial a localizar
**		Atajo	-> Indica se se encontr un atajo
**********************************************************************
**	SALIDA:
**		ini	-> Contiene el elemento anterior al localizado
**		return	-> Dato Virtual localizado
**				0 si no lo localiz
***********************************************************************
*/
/*
PVIR_DATA	EDMAPROC	GetVirtualData (POBJ pObj,EPChar Id,PVIR_DATA *ini,EByte *Atajo)
{
PVIR_DATA		temp,temp1;

*Atajo=0;
temp=*ini;
while (*ini!=0)
	{
		if (strcmp((*ini)->LocalId,Id)==0)
			{
      	*Atajo=1;
				break;
      }
		if (strcmp((EPChar)(&(*ini)->Id),Id)==0)
     	break;
		else
			{
    		temp=*ini;
				*ini=(*ini)->Next;
			}
	}
temp1=*ini;
*ini=temp;
return temp1;
}
*/
/*
** Prueba de mapeo en lenguaje C
*/

/*
 * Direct object data mapping for class implementation improvement
 */
EPVoid	EDMAPROC	GetRef3 (OBJID IdObj)
{
  if (gObj[IdObj].Flag==0)
    return (EPVoid)-1;
  
  return (EPVoid)gObj[IdObj].Datos;
}

ESint32 EDMAPROC Look4Prop (POBJ *pObj1,EPChar PropName)
{
  EUint32     i,j;
  CLASSID     Tipo;
  ESint32     Flag;
  POBJ        pObj,pObj2;
  
  pObj=*pObj1;
  /* First we look for at level 0 */
  Tipo=pObj->IdClase;
  for (i=0;i<gClase[Tipo].nProp;i++)
    if (strcmp (pClase[Tipo].Prop[i].IdProp,PropName)==0) 
      break;
  if (i==gClase[Tipo].nProp) { /* if we don't find it in the first level*/
    /* we look for throught superclass table*/
    for (j=0;j<pObj->nTabla;j++) {
      pObj2=pObj->Tabla[j].Obj;
      Flag=Look4Prop(&pObj2,PropName);
      if (Flag!=-1) {
	*pObj1=pObj2;
	return Flag;
      }
    }
    return -1;
  } else  {
    return i;
  }
}

ESint32 EDMAPROC Look4Met (POBJ *pObj1,EPChar MetName)
{
  EUint32     i,j;
  CLASSID     Tipo;
  ESint32     Flag;
  POBJ        pObj,pObj2;
  
  
  pObj=*pObj1;
  /* First we look for at level 0*/
  Tipo=pObj->IdClase;
  /*ECout1("[Look4Met] in Class %s",gClase[Tipo].ClassName);*/
  for (i=0;i<gClase[Tipo].nMet;i++) {
    /*ECout1 ("[Look4Met] Testing %s of %d",pClase[Tipo].Met[i].IdMet,gClase[Tipo].nMet);*/
    if (strcmp (pClase[Tipo].Met[i].IdMet,MetName)==0) 
      break;
  }
  if (i==gClase[Tipo].nMet) { /* if we don't find it in the first level*/
    /* we look for through superclass table*/
    for (j=0;j<pObj->nTabla;j++) {
      pObj2=pObj->Tabla[j].Obj;
      Flag=Look4Met(&pObj2,MetName);
      if (Flag!=-1) {
	*pObj1=pObj2;
	return Flag;
      }
    }
    return -1;
  } else  {
    return i;
  }
}
