/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998-2001  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
 * Entorno de Desarrollo Modular y Abierto
 * Version 0.3r1
 * (c) David Martnez Oliveira
 * 
 * Extensin de primitivas de nivel 3
 * 
 * Revisiones:
 * 10/12/1997
 *   Creacin del fichero
 *----------------------------------
 * Febraury, 7th-19th, 2001
 * Code cleanup and comment tranlation
 * -----------------------------------------------
 * November, 18th, 2001
 * Compile warnnings removal
*/

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "portable.h"
#include "vglobal.h"
#include "pri1.h"
#include "pri3.h"
#include "misc.h"
#include "getobj.h"

EPVoid	EDMAPROC	EDMAWProp3 (OBJID IdObj,EPChar Id,EPVoid p)
{
  EUint32	i,l;
  POBJ		pObj,ObjIni;
  EUint32	Tipo;
  EChar		LocalId[50];
  EChar		Error[80];
  VIR_MET_PARAMS	VMParams;
  VIR_DATA	*VirData;
  PPROC         Func;   

  pObj=&gObj[IdObj];
  
  ObjIni=pObj;
  if (IdObj>GVar->nMaxObj)
    return (EPVoid)-1;
  if (pObj->Flag==0)
    return (EPVoid)-1;
  
  if (pObj->Flag==VIRTUAL_OBJECT)
    VirData=pObj->VirData.vProp;
  else
    VirData=0;
  
  pObj=GetSubObj1 (pObj,Id,LocalId,&VirData,V_PROP
		   ,"EDMA Write Property Primitive ERROR");
  
  if(VirData!=0)
    if (VirData->Func[WRITE_PROP]==NULL) {
      VirData=0;
      pObj=GetSubObj (pObj,Id,LocalId
		      ,"EDMA Write Property Primitive ERROR");
    }
  if (pObj==NULL) {
    ECoutErr("Path %s isn't corret for object %d",Id,IdObj);
    return 0;
  }
  if (VirData==0) {
    Tipo=pObj->IdClase;
    for (i=0;i<gClase[Tipo].nProp;i++)
      if (strcmp (pClase[Tipo].Prop[i].IdProp,LocalId)==0) break;
    
    if (gClase[Tipo].nProp==i) {
      /* Modification for SIU*/
      if (pObj->IdSIU!=-1) {
	Met3(IdObj,"WProp3",pObj->IdSIU,LocalId,p);
	return 0;
      }
      /*Modification ends*/
      ECoutErr ("Property %s Not Defined in Class %s"
		,Id,gClase[Tipo].ClassName);
    }
    else
      EDMAWProp1 (pObj->IdObj,i,p);
  } else {
    /* We build paramter struct for virtual method if host object is virtual*/
    {
      Func=VirData->Func[WRITE_PROP];
      VMParams.a=p;
      VMParams.Id=LocalId;
      VMParams.IdPrim=WRITE_PROP;
      VMParams.IdObj=pObj->IdObj;
      VMParams.Ind=i;
      return (EPVoid)Func(pObj->IdObj,&VMParams);
    }
  }
}

EPVoid	EDMAPROC	EDMARProp3 (OBJID IdObj,EPChar Id,EPVoid p)
{
  EUint32	i,l,fin;
  POBJ		pObj,ObjIni;
  EUint32	Tipo;
  EChar		LocalId[50];
  EChar		Error[80];
  VIR_MET_PARAMS	VMParams;
  VIR_DATA	*VirData;
  PPROC         Func;   

  fin=SetFinal(IdObj,1);
  pObj=&gObj[IdObj];

  ObjIni=pObj;
  if (IdObj>GVar->nMaxObj)
    return (EPVoid)-1;
  if (pObj->Flag==0)
    return (EPVoid)-1;
  
  if (pObj->Flag==VIRTUAL_OBJECT)
    VirData=pObj->VirData.vProp;
  else
    VirData=0;
  
  pObj=GetSubObj1 (pObj,Id,LocalId,&VirData,V_PROP
		   ,"EDMA Write Property Primitive ERROR");
  if(VirData!=0)
    if (VirData->Func[READ_PROP]==NULL) {
      VirData=0;
      pObj=&gObj[IdObj];
      pObj=GetSubObj (pObj,Id,LocalId
		      ,"EDMA Write Property Primitive ERROR");
    }
  if (pObj==NULL) {
    ECoutErr("Path %s isn't corret for object %d",Id,IdObj);
    SetFinal(IdObj,fin);
    return 0;
  }
  if (VirData==0) {
    Tipo=pObj->IdClase;
    for (i=0;i<gClase[Tipo].nProp;i++)
      if (strcmp (pClase[Tipo].Prop[i].IdProp,LocalId)==0) break;
    
    if (gClase[Tipo].nProp==i) {
      /* MOdification for SIU Subsystem */
      if (pObj->IdSIU!=-1) {
	Met3(IdObj,"RProp3",pObj->IdSIU,LocalId,*(EPVoid*)p);
	SetFinal(IdObj,fin);
	return 0;
      }
      /* Ends SIU modification*/
      ECoutErr ("Property %s Not Defined in Class %s"
		,Id,gClase[Tipo].ClassName);
    } else {
      SetFinal(IdObj,fin);
      return EDMARProp1 (pObj->IdObj,i,p);
    }
  } else {
    /* We build paramters for virtual method invocation over virtual object*/
    {
      Func=VirData->Func[READ_PROP];
      VMParams.a=p;
      VMParams.Id=LocalId;
      VMParams.IdPrim=READ_PROP;
      VMParams.IdObj=pObj->IdObj;
      VMParams.Ind=i;
      SetFinal(IdObj,fin);
      return (EPVoid)Func(pObj->IdObj,&VMParams);
    }
  }
}

EPVoid	EDMAPROC	EDMAMet3S (OBJID IdObj,EPChar Id,EPChar Sig,EPVoid pars)
{
  OBJID		sObj,iObj;
  EUint32	i,l;
  EUint32	n,j,k,Ind;
  POBJ		pObj,ObjIni;
  EUint32	Tipo;
  EChar		LocalId[50];
  EChar		Error[80];
  EPChar	Id1;
  VIR_MET_PARAMS	VMParams;
  VIR_DATA	*VirData;
  PPROC         Func;   
  EPVoid        p;   
  EByte		p1[32];
  EChar		MiSig[50];
  EChar         SAux[2];   
  int		(EDMAPROC *aFunc)(OBJID,...);
  EPVoid	Last;

  p=&pars;
  p-=4;
  
  pObj=&gObj[IdObj];
  ObjIni=pObj;
  if (IdObj>GVar->nMaxObj)
    return (EPVoid)-1;
  if (pObj->Flag==0)
    return (EPVoid)-1;
  
  if (pObj->Flag==VIRTUAL_OBJECT)
    VirData=pObj->VirData.vMet;
  else
    VirData=0;
  /* We build signature for object type. Still not implemented */
  for (i=0;i<50;i++)
    MiSig[i]=0;
  j=strlen(Sig);
  n=0;	/* Counter for current parameter*/
  SAux[1]=0;   
  for (i=0;i<j;i++)
    if ((Sig[i]!='O')&& (Sig[i]!='L'))	{ /* If it a single type*/
      SAux[0]=*(Sig+i);
      strcat (MiSig,SAux);
      n++;
    } else	/* else */
      if (Sig[i]=='O')	{ /* if we must to expand signature */
	sObj=(OBJID)(*((EPUint32)p+n));
	strcat (MiSig,gClase[gObj[sObj].IdClase].ClassName);
	n++;
      } else {	/* else it's a class identifier */
	l=strchr(Sig+i,';')-(Sig+i)-1;
	k=strlen(MiSig);
	strncpy(MiSig+k,Sig+i+1,l);
	i+=(l+1);
	n++;
      }
  ECout1("(Met3S) Expanded signature : %s",MiSig);
  
  pObj=GetSubObj1 (pObj,Id,LocalId,&VirData,V_MET
		   ,"EDMA Method Run Primitive ERROR");
  if (pObj->IdSIU!=-1)
    strcpy(MiSig,Sig);
  if (pObj==NULL) {
    ECoutErr("Path %s isn't corret for object %d",Id,IdObj);
    return 0;
  }
  
  if (VirData==0) {
    Tipo=pObj->IdClase;
    for (i=0;i<gClase[Tipo].nMet;i++) {
      /* if we've found an identifier ...*/
      if (strcmp (pClase[Tipo].Met[i].IdMet,LocalId)==0) 
	/* ... and signature matches */
	if (strcmp(pClase[Tipo].Met[i].Sign,MiSig)==0)
	  break;
    }
    Ind=i;
    if (gClase[Tipo].nMet==i) {
      /* Modification for SIU Subsystem */
      if (pObj->IdSIU!=-1) {
	return Met3(IdObj,"Met3S",pObj->IdSIU,LocalId,MiSig,p);
      }
      /* Modification ends */
      ECoutErr ("Method %s Not Defined in Class %s",Id,gClase[Tipo].ClassName);
    } else {
      if ((pClase[Tipo].Met[Ind].Virtual)) {
	for (i=0;i<gClase[Tipo].nMetVir;i++)
	  if (pObj->vTabla[i].Ind==Ind)
	    break;
	if (pObj->vTabla[i].Flag==1) {
	  /* We allow execution with multiple override */
	  iObj=((POBJ)pObj->vTabla[i].Obj)->IdObj;
	  return Met3(iObj,(EPChar)pObj->vTabla[i].Id,*(EPUint32)p
		      ,*((EPUint32)p+1),*((EPUint32)p+2)
		      ,*((EPUint32)p+3),*((EPUint32)p+4)
		      ,*((EPUint32)p+5),*((EPUint32)p+6)
		      ,*((EPUint32)p+7),*((EPUint32)p+8)
		      ,*((EPUint32)p+9));
	  
	}
	Func=pObj->vTabla[i].Func;
	pObj=((POBJ)pObj->vTabla[i].Obj);
	if (pObj==NULL)
	  iObj=-1;
	else
	  iObj=pObj->IdObj;
      } else {
	Func=(PPROC)fClase[Tipo].Met[Ind].Func;
	iObj=pObj->IdObj;
      }
      Func (iObj,*(EPUint32)p,*((EPUint32)p+1),*((EPUint32)p+2)
	    ,*((EPUint32)p+3),*((EPUint32)p+4),*((EPUint32)p+5)
	    ,*((EPUint32)p+6),*((EPUint32)p+7),*((EPUint32)p+8)
	    ,*((EPUint32)p+9));
    }
  } else {
    /* We build paramters for virtual method invocation over virtual object**/
    {
      Func=VirData->Func[0];
      VMParams.a=p;
      VMParams.Id=LocalId;
      VMParams.IdPrim=RUN_MET;
      VMParams.IdObj=pObj->IdObj;
      VMParams.Ind=i;
      
      return (EPVoid)Func(pObj->IdObj,&VMParams);
    }
  }
}

EPVoid	EDMAPROC	EDMAMet3 (OBJID IdObj,EPChar Id,EPVoid p)
{
  OBJID         iObj;   
  EUint32	i,j;
  POBJ		pObj;
  EUint32	Tipo,Ind;
  EChar		LocalId[50];
  EChar		Error[80];
  VIR_MET_PARAMS	VMParams;
  VIR_DATA	*VirData;
  PPROC Func;   
  
  pObj=&gObj[IdObj];
  if (IdObj>GVar->nMaxObj)
    return (EPVoid)-1;
  if (pObj->Flag==0)
    return (EPVoid)-1;
  
  if (pObj->Flag==VIRTUAL_OBJECT)
    VirData=pObj->VirData.vMet;
  else
    VirData=0;
  
  pObj=GetSubObj1 (pObj,Id,LocalId,&VirData,V_MET
		   ,"EDMA Method Run Primitive ERROR");
  if (pObj==NULL) {
    ECoutErr("Path %s isn't corret for object %d",Id,IdObj);
    return 0;
  }
  if (VirData==0) {
    Tipo=pObj->IdClase;
    for (i=0;i<gClase[Tipo].nMet;i++)
      if (strcmp (pClase[Tipo].Met[i].IdMet,LocalId)==0) break;
    if (gClase[Tipo].nMet==i) {
      ECoutErr ("Method %s Not Defined in Class %s"
		,Id,gClase[Tipo].ClassName);
    } else {
      Ind=i;
      if ((pClase[Tipo].Met[Ind].Virtual)) {
	/* We find method to execute in the virtual object's method table */
	for (i=0;i<gClase[Tipo].nMetVir;i++)
	  if (pObj->vTabla[i].Ind==Ind)
	    break;
	/* If it's overriden by an object */
	if (pObj->vTabla[i].Flag==1) {
	  /* We allow multiple override*/
	  iObj=((POBJ)pObj->vTabla[i].Obj)->IdObj;
	  return Met3(iObj,(EPChar)pObj->vTabla[i].Id,*(EPUint32)p
		      ,*((EPUint32)p+1),*((EPUint32)p+2)
		      ,*((EPUint32)p+3),*((EPUint32)p+4)
		      ,*((EPUint32)p+5),*((EPUint32)p+6)
		      ,*((EPUint32)p+7),*((EPUint32)p+8)
		      ,*((EPUint32)p+9));
	}
	Func=pObj->vTabla[i].Func;
	pObj=((POBJ)pObj->vTabla[i].Obj);
	if (pObj==NULL)
	  iObj=-1;
	else
	  iObj=pObj->IdObj;
      } else {
	Func=(PPROC)fClase[Tipo].Met[Ind].Func;
	iObj=pObj->IdObj;
      }
      
      return (EPVoid)Func (iObj,*(EPUint32)p,*((EPUint32)p+1),*((EPUint32)p+2)
		   ,*((EPUint32)p+3),*((EPUint32)p+4),*((EPUint32)p+5)
		   ,*((EPUint32)p+6),*((EPUint32)p+7),*((EPUint32)p+8)
		   ,*((EPUint32)p+9));
    }
  } else {
    /* We build parameters for virtual metrhod throught virtual object*/
    {
      Func=VirData->Func[0];
      VMParams.a=p;
      VMParams.Id=LocalId;
      VMParams.IdPrim=RUN_MET;
      VMParams.IdObj=pObj->IdObj;
      VMParams.Ind=i;
      return (EPVoid)Func(pObj->IdObj,(VIR_MET_PARAMS*)&VMParams);
    }
  }
  return 0;
}
