/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998-2001  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
**********************************************************

 Entorno de Desarrollo Modular y Abierto
 Versin BETA 0.3r1
 (c) David Martnez Oliveira
 10 de Mayo de 1997

 Definicin de tipos para propiedades, mtodos y notificaciones
 REVISIONES -----------------------------------------------
 17/11/1997
 * Modificaciones para versin 0.3r1
 *   Aadimos campo adicional a las propiedades para que el usuario pueda
 * ampliarlas.
 ***********************************************************
 * Febraury, 19th, 2001
 * Code cleanup and comment translation
 * --------------------------------------------------------------
 * April, 15th, 2001
 * Adding support for abstract and static methods
 * First we'll implement the static method support. For abstract methods
 * we only add a flag to the method struct. The abstract method implementation
 * should be trivial...
*/

#ifndef PTYPES_H
#define PTYPES_H

#include "portable.h"

#ifdef WINAPI_32
typedef FARPROC PPROC;
#endif
#ifdef LINUX
typedef EUint32 (*PPROC)();
#endif

#ifdef __cplusplus
extern "C"{
#endif
/* CONSTANTS *********************************************/
#define E			0
#define L			1
#define E_L			2

/* Operations Identifiers */
#define	WRITE_PROP		0
#define READ_PROP		1
#define RUN_MET			2
#define GET_DATA		3


/* Virtual feature identifiers */
#define V_PROP			0
#define V_MET			1


/* Type Identifiers **********************************/

  typedef	char	IDSIM[32];	/*Symbolic Identifier */
 
  /* Property data struct */ 
  typedef struct
  {
    IDSIM	IdProp;		/* Property Identifier */
    EUint32	Tipo;		/* Datatype */
    EByte	ioTipo;		/* Access (read,write)*/
    EUint16	Off;		/* Offset in object data block */
    EUint32	nElem;		/* Element number if the property is an array*/
    HMEM	UserInfo;	/* Extra information*/
  } PROP,*PPROP;
  
  /* Method data struct*/
  typedef struct
  {
    IDSIM	IdMet;		/* Method Identifier */
    EChar	Sign[50];	/* Method Signature. 50 bytes max lenght for the moment*/
    EByte	Virtual;	/* Virtual Method Indicator*/
    HMEM	UserInfo;	/* Extra Information */
    EByte       Static;         /* Static Method Indicator*/
    EByte       Abstract;       /* Abstract Method Indicator*/
  } MET,*PMET;
  
  /* Notification Data struct. Currently not implement*/
  typedef struct
  {
    IDSIM	IdNot;		/* Identificador de propiedad*/
    EUint32	Tipo;		/* Lectura/Escritura ...*/
    EPChar 	Des;		/* Descripcin*/
    EUint32	IdClase;	/* Para nivel 3 (herencia polimorfismo, etc...)*/
    PPROC	Func;
    HMEM	UserInfo;	/* Extra Information*/
  } NOT,*PNOT;
  
  /* Parameters for virtual methods*/
  typedef struct
  {
    EPVoid	a;	/* Pointer to parameters */
    EPfChar	Id;	/* Call identifier */
    EUint16	IdPrim;	/* Primitive Identifier */
    ESint32	IdObj;	/* Object which receibes the primitive*/
    EUint32	Ind;	/* Property, Method index for using level 1 primitives*/
  } VIR_MET_PARAMS;
  
#ifdef __cplusplus
}
#endif

#endif
