/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998-2001  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
 Entorno de Desarrollo Modular y Abierto
 Versin Beta 0.3r1
 (c) David Martnez Oliveira


 Modulo para gestin de proxies SIU
 Revisiones: ---------------------------------------------------------
 31 de Agosto de 1997
 INtentamos aadir funciones de gestin de proxies SIU
 * ----------------------------------------------------------
 * Febraury, 19th, 2001
 * Code cleanup and comment translation
 */

#include <stdio.h>
#include "portable.h"
#include "multiidf.h"
#include "vglobal.h"
#include "classq.h"
#include "misc.h"
#include "inh.h"


ESint32 EDMAPROC GetProxy (EPChar Name)
{
  EUint32		i;
  
  for (i=0;i<GVar->nSIU;i++)
    {
      if (strcmp(GVar->SIUProxy[i].Id,Name)==0)
	break;
    }
  if (i==GVar->nSIU)
    return -1;
  else
    return i;
}

EUint32 EDMAPROC AddProxy (EPChar Name,EPChar ClassName)
{
  ESint32	IdParser;
  CLASSID	IdClass;
  EChar		error[80];

  /* We check if the proxy already exists */
  if (GetProxy(Name)!=-1)
    {
      sprintf (error,"SIU Proxy %s already exists",Name);
      ECout (error);
      return 0;
    }
  /* if not, we ad it */
  IdClass=GetClassId(ClassName);
  IdParser=GVar->nSIU;
  strcpy (GVar->SIUProxy[IdParser].Id,Name);
  GVar->SIUProxy[IdParser].IdClass=IdClass;
  GVar->nSIU++;
  return 0;
}

ESint32 EDMAPROC GetNProxies (void) {
  return GVar->nSIU;
}

CLASSID EDMAPROC GetProxyClass (ESint32 i) {
  if ((i<0) || (i>GVar->nSIU))
    return -1;
  return GVar->SIUProxy[i].IdClass;
}
