/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998-2001  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
 * REVISIONS: -----------------------------------------------------
 * April, 15th, 2001
 * File creation.
 * This module contains functions for accessing static methods. 
 * For the moment we add a simple implementations only support first
 * level methods, that is. We can't access static methods in a inheritance
 * chain directly using them.
 * We obly can access the methods in the class specified.
 * --------------------------------------------------------------------
 * October, 19th,2001
 * Removing warnnings
*/

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "portable.h"
#include "vglobal.h"
#include "pri1.h"
#include "spri3.h"
#include "misc.h"
#include "getobj.h"

ESint32 EDMAPROC Look4Met1 (CLASSID id,EPChar MetName);
/*
ESint32 EDMAPROC Look4Prop (POBJ *pObj1,EPChar PropName);
ESint32 EDMAPROC Look4Met (POBJ *pObj1,EPChar MetName);
*/

/*
 * Interface accessing using Class Name
 */

/*
** Level 3 object primitives
*/


EPVoid EDMAPROC         SMet3S (EPChar cn,EPChar Id,EPChar Sig,...)
{
  CLASSID      idc;
  va_list      p;

  idc=GetClassId(cn);
  va_start(p,Sig);

  return SMet3Sx (idc,Id,Sig,p);

}

EPVoid	EDMAPROC	SMet3Sx (CLASSID idc,EPChar Id,EPChar Sig,EPVoid p)
{
  OBJID		sObj,iObj;
  EUint32	i,l;
  EUint32	n,j,k,Ind;
  POBJ		pObj,ObjIni,ObjAux;
  EUint32	Tipo;
  EChar		LocalId[50];
  EChar		Error[80];
  EPChar	Id1;
  VIR_MET_PARAMS	VMParams;
  VIR_DATA	*VirData;
  PPROC         Func;   
  EByte		p1[32];
  EChar		MiSig[50];
  EChar         SAux[2];   
  int		(EDMAPROC *aFunc)(OBJID,...);
  EPVoid	Last;
  
  /* We build the signature for object's type... 
     not implemented at the moment*/
  for (i=0;i<50;i++)
    MiSig[i]=0;
  j=strlen(Sig);
  n=0;	/* We count how many parameter we have*/
  SAux[1]=0;   
  for (i=0;i<j;i++)
    if ((Sig[i]!='O')&& (Sig[i]!='L'))	/* if it's a simple type*/
      {
	SAux[0]=*(Sig+i);
	strcat (MiSig,SAux);
	n++;
      }
    else	/*else*/
      if (Sig[i]=='O')	/*if we must to expand signature*/
	{
	  sObj=(OBJID)(*((EPUint32)p+n));
	  strcat (MiSig,gClase[idc].ClassName);
	  n++;
	}
      else	/*else it's a class identifier*/
	{
	  l=strchr(Sig+i,';')-(Sig+i)-1;
	  k=strlen(MiSig);
	  strncpy(MiSig+k,Sig+i+1,l);
	  i+=(l+1);
	  n++;
	}
  /*
  for (i=0;i<gClase[Tipo].nMetVir;i++)
    if (pObj->vTabla[i].Ind==Ind)
      break;
  if (pObj->vTabla[i].Flag==1)
    {
      iObj=((POBJ)pObj->vTabla[i].Obj)->IdObj;
      return Met3(iObj,pObj->vTabla[i].Id,*(EPUint32)p
		  ,*((EPUint32)p+1),*((EPUint32)p+2)
		  ,*((EPUint32)p+3),*((EPUint32)p+4)
		  ,*((EPUint32)p+5),*((EPUint32)p+6)
		  ,*((EPUint32)p+7),*((EPUint32)p+8)
		  ,*((EPUint32)p+9));
      
    }
  Func=pObj->vTabla[i].Func;
  pObj=((POBJ)pObj->vTabla[i].Obj);
  if (pObj==NULL)
    iObj=-1;
  else
    iObj=pObj->IdObj;
}
else
{
  Func=fClase[Tipo].Met[Ind].Func;
  iObj=pObj->IdObj;
}
Func (iObj,*(EPUint32)p,*((EPUint32)p+1),*((EPUint32)p+2)
      ,*((EPUint32)p+3),*((EPUint32)p+4),*((EPUint32)p+5)
      ,*((EPUint32)p+6),*((EPUint32)p+7),*((EPUint32)p+8)
      ,*((EPUint32)p+9));
      }
*/

}

EPVoid EDMAPROC        SMet3 (EPChar cn,EPChar Id,...)
{
CLASSID       idc;
va_list       p;

idc=GetClassId(cn);
if (ProcMapTable[idc]!=CLASS_LOADED)
     LoadClassImp(idc);

va_start(p,Id);

return SMet3x (idc,Id,p);

}

EPVoid	EDMAPROC	SMet3x (CLASSID cid,EPChar Id,EPVoid p)
{
  EUint32	i,j;
  EChar		Error[80];
  PPROC         Func;   
  EChar		LocalId[50];
  
  i=Look4Met1(cid,Id);
  if (pClase[cid].Met[i].Static) {
    Func=(PPROC)fClase[cid].Met[i].Func;
    return (EPVoid) Func (i,*(EPUint32)p,*((EPUint32)p+1),*((EPUint32)p+2)
		 ,*((EPUint32)p+3),*((EPUint32)p+4),*((EPUint32)p+5)
		 ,*((EPUint32)p+6),*((EPUint32)p+7),*((EPUint32)p+8)
		 ,*((EPUint32)p+9));
  } else
    {
      ECoutErr ("[SMet3x] Method %s isn't static",Id);
    }
  return 0;
}

ESint32 EDMAPROC Look4Met1 (CLASSID Tipo,EPChar MetName)
{
  EUint32     i,j;
  ESint32     Flag;
  
  /* First we look for at level 0*/
  for (i=0;i<gClase[Tipo].nMet;i++) {
    if (strcmp (pClase[Tipo].Met[i].IdMet,MetName)==0) 
      break;
  }
  if (i==gClase[Tipo].nMet) /* if we don't find it in the first level*/
    {
      /* we look for through superclass table*/
      /*
      for (j=0;j<pObj->nTabla;j++)
	{
	  pObj2=pObj->Tabla[j].Obj;
	  Flag=Look4Met(&pObj2,MetName);
	  if (Flag!=-1)
	    {
	      *pObj1=pObj2;
	      return Flag;
	    }
	}
      */
      return -1;
    }
  else 
    {
      return i;
    }
}
