/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
*********************************************************
 Entorno de Desarrollo Modular y Abierto
 (c) David Martnez Oliveira
 Vigo 17 de Octubre de 1996

 Versin 0.3r1
 ---------------------------------------------------------

 Mdulo de gestin de sistemas operativos y hardware

*********************************************************
*-----------------------------------
* Febraury, 19th, 2001
* Code cleanup and comment translation
* --------------------------------------------------
* November, 10th, 2001
* Look fot sysdat32.cfg at SystemPath/etc
*
* TODO: Change this to work on other OSes
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "portable.h"
#include "const.h"
#include "error.h"
#include "vglobal.h"
#include "misc.h"

EByte	IniSysTable (EPChar EdmaPath)
{
  FILE		*f;
  EUint16		n,i;
  static EUint32		Maqid;
  char		nom[32];
  char		msg[80];
  EChar		SysFile[256];
  char		*p;
  
  strcpy (SysFile,EdmaPath);
  /* FIXME: Chage this depending on Operating system standars*/
  strcat (SysFile,"/etc/sysdat32.cfg");
  f=fopen (SysFile,"rt");
  if (f==NULL)
    {
      ECout("(ERROR)System File not found");
      return FALSE;
    }
  
  fscanf (f,"%s",&nom);
  n=atol(nom);
  n--;
  
  
  for (i=0;i<n;i++)
    {
      fscanf (f,"%s",&nom);
      fscanf (f,"%u",&Maqid);
      GVar->SysMaq[i].Id=Maqid;
      memcpy (GVar->SysMaq[i].Nombre,nom,strlen(nom));
      
    }
  
  GVar->nMaqNum=n;
  fscanf (f,"%d",&GVar->nSONum);
  
  for (i=0;i<GVar->nSONum;i++)
    {
      fscanf (f,"%s",GVar->SysSO[i].Nombre);
      fscanf (f,"%d",&GVar->SysSO[i].Id);
    }
  
  fclose (f);
  return TRUE;
}

EUint32	EDMAPROC GetSOId (EPChar	name)
{
  EUint32		i;
  
  for (i=0;i<GVar->nSONum;i++)
    if (strcmp(GVar->SysSO[i].Nombre,name)==0) break;
  
  if (i==GVar->nSONum)
    ECout("(ERROR)Operating System not found");
  
  
  return i;
}

EUint32	EDMAPROC GetMaqId (EPChar	name)
{
  EUint32		i;
  
  for (i=0;i<GVar->nMaqNum;i++)
    if (strcmp(GVar->SysMaq[i].Nombre,name)==0) break;
  if (i==GVar->nMaqNum)
    ECout("(ERROR)Machine not found");
  return i;
}



EUint32	EDMAPROC GetSOName (EUint32 id,EPChar	*name)
{
  EUint32		i;
  
  if (id>=GVar->nSONum)
    {
      ECout("(ERROR)Operating System not found");
      return 0;
    }
  *name=GVar->SysSO[id].Nombre;
  
  return i;
}

EUint32	EDMAPROC GetMaqName (EUint32 id,EPChar	*name)
{
  EUint32		i;
  
  
  if (id>=GVar->nMaqNum)
    {
      ECout("(ERROR)Machine not found");
      return 0;
    }
  *name=GVar->SysMaq[id].Nombre;
  return i;
}

EUint32 EDMAPROC nSO (void)
{
  return GVar->nSONum;
}
EUint32 EDMAPROC nMaq (void)
{
  return GVar->nMaqNum;
}
