/*
 * EDMA: Entorno de Desarrollo Modular y Abierto
 * Object Oriented and Componetware Framework
 * Copyright (C) 1998-2001  David Martnez Oliveira
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.

 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 
/*
 Entorno de Desarrollo Modular y Abierto
 Versin Beta 0.3r1
 (c) David Martnez Oliviera
	
 Tipos del sistema
 Define un bloque con las variables globales del sistema que sern
 compartidas por todas las instancias de la DLL
 29 de Abril de 1997
 -------------------------------------------------------
 24 de Julio de 1997
 Aadimos estructuras de datos para soporte de multiples IDFs y
 proxys SIU
 ------------------------
 8 de Agosto de 1997
 Aadimos estructuras de datos para almacenar informacin de mapeo de cdigo
 por proceso.
 ------------------------------
 2 de Octubre de 1997
 Aadimos primer soporte para EMI. En primer lugar solo la funcin GetClassId
 * --------------------------------------------------------------------
 * Febraury, 19th, 2001
 * Code cleanup and comment translation
 * ------------------------------------------------------------------------
 * November, 28th, 2001
 * Begins modification to add implicit anchor point info for inheritance
*/

#ifndef SYS_TYPES_H
#define SYS_TYPES_H

#include "portable.h"
#include "const.h"
#include "tclass.h"
#include "tobj.h"
#include "esp_typ.h"
#include "vserv.h"
#ifdef __cplusplus
extern "C"{
#endif

  typedef EChar         ID[32];

  /* IDF Parser data struct */
  typedef struct {
    EChar		Id[32];	 /* Symbolic Identifier */
    CLASSID		IdClass; /* Class Identifier who implements IDF parssing */
  } IDF_PARSER_ITEM;
  
  /* SIU Proxy data struct */
  typedef struct {
    EChar		Id[32];  /* Symbolic Identifier*/
    CLASSID		IdClass; /* Class Identifier who implements proxy */
  } SIU_PROXY_ITEM;
  
  /* EMI Extension data struct */
  typedef struct {
    EChar		Id[32];  /* Symbolic Identifier */
    CLASSID		IdClass; /* Class Identifier who implements emi extension */
  } EMI_ITEM;
  
  /* Global variables memory chunck*/
  typedef struct {
    HMEM	hMySelf;	/* Memory Handle for this block */
    ESint32	Running;	/* Is the block initialized? */
    EUint32	nClases;	/* Number of Class in system */
    EUint32	nObj;		/* Number of Objects in system */
    EUint32	nMaxObj;	/* Maximum object table entries allowed */
    EUint32	nMaxClases;	/* Maximum class table entries allowed */
    EUint32     nMaxIdf;	/* MAximum IDF_PARSERS in system */
    EUint32     nMaxSIU;	/* Maximum SIU PROXYs in system */
    EUint32     nIdf;		/* Number of IDF_PARSERS in system */
    EUint32     nSIU;		/* Number of SIU PROXYs in system */
    EUint32	nEMI;		/* Number of EMI PROXYs in system */
    SYS_SO	SysSO[SO_NUM];	/* Operating Systems System Register */
    SYS_MAQ	SysMaq[MAQ_NUM];/* Machine System Register */
    IDF_PARSER_ITEM	IDFParser[MAX_IDF_PARSERS];
    SIU_PROXY_ITEM	SIUProxy[MAX_SIU_PROXYS];
    EMI_ITEM	EMIComp[MAX_EMI_COMP];
    EUint32	nSONum;		/* Number of Entries defined en SysSO */
    EUint32	nMaqNum;	/* Number of Entries defined en SysMaq */
    EChar	SystemPath[255];
    VSERV	*vServ;		/* Console server id; */
    EUint32	AppIdGen;
    EUint32	DebugLevel;
    CLASSID	GetClassEMI;	/* Class for GetClass Extension */
  } SYS_GLOBAL_VAR;
  
  typedef struct {
    PPROC		*Func;
  } PROCMET;
  
  typedef struct {
    HMEM      hFMet;
    PROCMET   *Met;
  } FCLASE;

  typedef struct {
    HMEM	    hLib;
    SYS_CLASS1      SysClass;
    MET             *Met;
    PROP            *Prop;
    NOT             *Not;
    CLASSID         *SCList;    /* SuperClass list for this class*/
    ID              *SCIdList;  /* Default anchor points for each superclass*/
  } PCLASE;
  
#ifdef __cplusplus
}
#endif    
#endif

