/*
    APP Name Version V_MAJOR.V_MINOR
    Copyright (C) 1998-1999 David Martnez Oliveira
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>

#include <edma.h>

ESint32 EDMAPROC my_met1 (OBJID,EPChar,ESint32);
ESint32 EDMAPROC my_met2 (OBJID,EPChar);


main(int argc,char *argv[])
{
  OBJID    id;

  /* Initialize EDMA System */
	EDMAInit();
	
  /* Put your C code here */
  printf ("\n----------------------------------\n");
  if ((id=NewObj ("ABSTRACT2",NULL))==-1) {
    printf ("Can't create ABSTRACT2 object. Aborting");
		EDMAEnd();
		exit(1);
	}

  /* Try direct methods*/
  printf ("\n----------------------------------\n");
  Met3(id,"met1","Hello",2);
  Met3(id,"met2","Hello");
  Met3(id,"met3","Hello");
  printf ("----------------------------------\n");

  /* Override virtual methods*/
  OverMet(id,"met1",NULL,(PPROC)my_met1);
  OverMet(id,"met2",NULL,(PPROC)my_met2);

  Met3(id,"met1","Hello",2);
  Met3(id,"met2","Hello");
  Met3(id,"met3","Hello");
  printf ("----------------------------------\n");

  FreeObj (id);
  /* Now, we test, pure abstract clases*/
  if ((id=NewObj ("ABSTRACT1",NULL))==-1) {
    printf ("Can't create ABSTRACT1 object");
		EDMAEnd();
		exit(1);
	}
  printf ("----------------------------------\n");
  Met3(id,"met1","Hello",2);
  Met3(id,"met2","Hello");  

  /* Override virtual methods*/
  OverMet(id,"met1",NULL,(PPROC)my_met1);
  OverMet(id,"met2",NULL,(PPROC)my_met2);
  printf ("----------------------------------\n");
  Met3(id,"met1","Hello",2);
  Met3(id,"met2","Hello");
  FreeObj (id);
  printf ("----------------------------------\n");

  /* Now, we test a realization of this interface*/
  if ((id=NewObj ("REALIZATION",NULL))==-1) {
    printf ("Can't create ABSTRACT1 object");
		EDMAEnd();
		exit(1);
	}
  printf ("----------------------------------\n");
  Met3(id,"met1","Hello",2);
  Met3(id,"met2","Hello");  

  /* Override virtual methods*/
  OverMet(id,"met1",NULL,(PPROC)my_met1);
  OverMet(id,"met2",NULL,(PPROC)my_met2);
  printf ("----------------------------------\n");
  Met3(id,"met1","Hello",2);
  Met3(id,"met2","Hello");
  FreeObj (id);
  printf ("----------------------------------\n");

  /* Shutdown EDMA Suystem */
  EDMAEnd();
  return 0;
}

/* Overrider functions*/
ESint32 EDMAPROC my_met1 (OBJID IdObj,EPChar a,ESint32 b) {

  ECoutObj (IdObj,"New code for met1");
  ECoutObj (IdObj,"New Code: %s %d",a,b);
  
  return 0;
}

ESint32 EDMAPROC my_met2 (OBJID IdObj,EPChar a) {

  ECoutObj (IdObj,"New code for met2");
  ECoutObj (IdObj,"New Code: %s",a);
  
  return 0;
}
