/*
    dyn_test Version 0.0
    Copyright (C) 1998-1999 David Martnez Oliveira
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.    

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>

#include <edma.h>

main(int argc,char *argv[])
{
  ESint32          res;
  OBJID            id,id1;
  OBJID            id_sc,id_sc1;

  /* Initialize EDMA System*/
  EDMAInit();
  
  if ((id1 = NewObj ("STREAM1",NULL))==-1) {
    fprintf (stderr,"Can't create object GZFILE...aborting\n");
    EDMAEnd();
    exit(1);
  }
  //Met3 (id1,"NFILE1@IMP<open","kkk","wt");
  Met3 (id1,"NFILE1<open","kkk","wt");
  ObjReport(id1);
  printf ("-----------------------------------\n");
  printf ("Press any key to continue...\n");
  getchar();

  Met3 (id1,"GZFILE@IMP<open","kkk","wt");
  ObjReport(id1);
  printf ("-----------------------------------\n");
  printf ("Press any key to continue...\n");
  getchar();

  FreeObj(id1);
  


  /* Put your C code here */
  printf ("+ Creating NFILE1 object...\n");
  if ((id=NewObj ("NFILE1",NULL))==-1)  {
    printf ("Can't create SUBCLASE2 object");
    EDMAEnd();
    exit(1);
  }
  printf ("Object Report for NFILE object\n");
  ObjReport(id);
  printf ("--------------------------------\n");

  printf ("+ Upcasting object NFILE to STREAM...\n");
  id_sc1=UpCastObj(id,"STREAM1");
  printf ("Object Report for STREAM superobject\n");
  ObjReport(id_sc1);
  printf ("--------------------------------------\n");
  FreeObj (id);

  printf ("Press any key to continue...\n");
  getchar ();
	printf ("---- Creating GZFILE object...n");
  if ((id1 = NewObj ("GZFILE",NULL))==-1) {
    fprintf (stderr,"Can't create object GZFILE...aborting\n");
    EDMAEnd();
    exit(1);
  }
  printf ("Object GZFILE: %ld\n",id1);
  printf ("\n");
  ObjReport(id1);
  printf ("--------------------------------------\n");
  FreeObj(id1);

  if ((id1 = NewObj ("STREAM1",NULL))==-1) {
    fprintf (stderr,"Can't create object GZFILE...aborting\n");
    EDMAEnd();
    exit(1);
  }
  printf ("Press any key to continue...\n");
  getchar();

  ObjReport(id1);
  printf ("--------------------------------------\n");
  Met3 (id1,"open","(GZFILE)test.txt.gz","wt");
  //Met3 (id1,"open","(NFILE1)test.txt.gz","wt");
  printf ("Press any key to continue...\n");
  getchar();


  ObjReport(id1);
  printf ("--------------------------------------\n");
  Met3 (id1,"puts","Hello World!!!!!\n",80);
  Met3 (id1,"puts","Hello World!!!!!\n",80);
  Met3 (id1,"puts","Hello World!!!!!\n",80);
  Met3 (id1,"puts","Hello World!!!!!\n",80);
  Met3 (id1,"flush");
  Met3 (id1,"close");
  /* Now, we change implementation to a NFILE*/
  /*
  FreeObj(id1);
  if ((id1 = NewObj ("STREAM1",NULL))==-1) {
    fprintf (stderr,"Can't create object GZFILE...aborting\n");
    EDMAEnd();
    exit(1);
  }
  */
  Met3 (id1,"open","(NFILE1)test2.txt","wt");
  printf ("Press any key to continue...\n");
  getchar();
  ObjReport(id1);
  printf ("-----------------------------------------\n");
  Met3 (id1,"puts","Hello Wold!!!.... again\n",80);
  Met3 (id1,"close");
  FreeObj(id1);


  if ((id1 = NewObj ("STREAM1",NULL))==-1) {
    fprintf (stderr,"Can't create object GZFILE...aborting\n");
    EDMAEnd();
    exit(1);
  }
  Met3 (id1,"NFILE1<open","kkk","wt");
  ObjReport(id1);
  printf ("-----------------------------------\n");
  printf ("Press any key to continue...\n");
  getchar();
  FreeObj(id1);
  /* Shutdown EDMA Suystem */
  EDMAEnd();
  return 0;
}
