/*
    mixin_test Version 0.0
    Copyright (C) 1998-1999 David Martnez Oliveira
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.    

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>

#include <edma.h>

main(int argc,char *argv[])
{
  ESint32          res,len;
  OBJID            id,id1;
  OBJID            id_sc,id_sc1;
  EChar            s[50];

  /* Initialize EDMA System*/
  EDMAInit();

  /* You can try this program with NFILE_CRYPT2 class*/
  if ((id1 = NewObj ("NFILE_CRYPT1",NULL))==-1) {
    fprintf (stderr,"Can't create object GZFILE...aborting\n");
    EDMAEnd();
    exit(1);
  }

  /* Show information about object to be sure all was all right*/
  ObjReport(id1);
  printf ("-----------------------------------\n");
  printf ("Press any key to continue...\n");
  getchar();

  id=UpCastObj(id1,"NFILE1");
  ObjReport(id);
  id=UpCastObj(id1,"TRASP_CODEC");
  ObjReport(id);
  id=UpCastObj(id1,"CRYPT_BASE");
  ObjReport(id);
  printf ("-----------------------------------\n");
  printf ("Press any key to continue...\n");
  getchar();

  /* Set the password for this obejct and write a text on it*/
  Met3 (id1,"SetPassword","thepassword");
  Met3 (id1,"open","kkk","wt");
  len=50;
  Met3 (id1,"puts","Hello World!!!!",&len);
  Met3 (id1,"close");
  /* Reopen the file and read the crypted data*/
  Met3 (id1,"open","kkk","rt");
  len=80;
  Met3 (id1,"gets",&s,&len);
  printf ("[INFO] Read %d bytes: %s\n",len,s);

  printf ("Trying again with the wrong password\n\n");
  Met3 (id1,"SetPassword","thewrongone");
  Met3 (id1,"rewind");
  Met3 (id1,"gets",&s,&len);
  printf ("[INFO] Read %d bytes: %s\n",len,s);

  FreeObj(id1);

  /* Shutdown EDMA Suystem */
  EDMAEnd();
  return 0;
}
