/*
  INES (INstall EDMA System) Uninstaller version 0.0.0
  Copyright (C) 1998-1999 David Martnez Oliveira
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.

 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>

#include <edma.h>

/* Constants */
#define VERSION "0.1.0"
#define COPYRIGHT "(c) David Martnez Oliveira"

typedef EChar my_string[80];

int main(int argc,char *argv[])
{
  int       i,n,id,n_depend;
  my_string aux;
  my_string aux1;
  my_string module_name;
  EChar     idf_name[1024],the_path[1024];
  EChar     module_fname[1024];

  printf ("\nINES (INstall EDMA System) Class Unregister");
  printf ("\nVersion %s",VERSION);
  printf ("\n%s\n",COPYRIGHT);

  if (argc!=2) {
    printf ("\nWrong parameter number");
    printf ("\nUsage: ines_uninstaller EDMA_CLASS_NAME");
    printf ("\n\n");
    exit(1);
  }
  
  /* Initialize EDMA System */
  EDMAInit();
  printf ("\n---------------------------------------------------");
  printf ("\nEDMA System up");
  printf ("\nINES (INstaller EDMA System) Uninstaller ready");
  printf ("\n---------------------------------------------------");
  printf ("\n + Looking for Class %s...",argv[1]);
  
  id=GetClassId(argv[1]);
  if (id==-1) {
    printf ("\n - Can't locate class. Aborting");
    EDMAEnd();
    exit(1);
  }
  printf (" Class located with id %d",id);
  i=GetClaseModule(id,module_name);
  if (i==-1) {
    printf ("\n - Error looking for Module Name");
    EDMAEnd();
    exit(1);
  }
  /* Get IDF file location */
  GetSystemPath(the_path);
  
  strcpy (idf_name,the_path);
  strcat (idf_name,"share/edma/idf/");
  strcat (idf_name,argv[1]);
  strcat (idf_name,".idf");
  printf ("\n + IDF file should be in : %s",idf_name);
  n=GetRegClases();
  printf ("\n + Looking for Module Dependences : (%s)",module_name);
  printf ("\n   Looking in %d classes",n);
  n_depend=0;
  for (i=0;i<n;i++) {
    GetClaseModule(i,aux);
    GetClaseName(i,aux1);
    if (strcmp (aux,module_name)==0) {
      printf ("\n   * Class %s depends on module %s",aux1,module_name);
      n_depend++;
    }
  }
  
  if (n_depend==1) { /* Only one class in the module */
    printf ("\n + No dependences... Uninstall is safe");
    printf ("\n   + Testing file existence ...");
    if ((ESint32)SMet3("FILESYSTEM","TestFile",idf_name)!=1) {
      printf ("\n     - Can't find IDF file... Aborting");
      EDMAEnd();
      exit(1);
    }
    /* Build absolute library name*/
    sprintf (module_fname,"%slib/%s",the_path,module_name);
    if ((ESint32)SMet3("FILESYSTEM","TestFile",module_fname)!=1) {
      printf ("\n     - Can't find Implementation file... Aborting");
      EDMAEnd();
      exit(1);
    }
    printf (" OK");
    printf ("\n   + Freeing Class from EDMA register ...");
    
    i=0;
    i=DelStockClass(argv[1]);
    if (i==-1) {
      printf ("\n   - Can't Delete Class");
      EDMAEnd();
      exit(1);
    }
    printf ("\n   + Class deleted from shared memory");
    
    printf ("\n + Class %s Succesfuly unregistered",argv[1]);
    printf ("\n*** To completly wipe out the class from your system:");
    printf ("\n*** Delete IDF file : %s",idf_name);
    printf ("\n*** Remove shared library %s and related links",module_name);
    printf ("\n***   Shared lib: %s",module_fname);
  }
  else {
    printf ("\n * There are %d dependences on this class/module",n_depend);
  }
  
  printf ("\n----------------------------------------------------");
  EDMAEnd();
  return 0;
}











