/*
    APP Name Version V_MAJOR.V_MINOR
    Copyright (C) 1998-1999 David Martnez Oliveira
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <edma.h>

int main(int argc,char *argv[])
{
  OBJID        id;
  OBJID        id1;
  EChar        ModuleName[1024],*aux;
  EChar        HelperClass[1024];

  /* Initialize EDMA System*/
  EDMAInit();

	/* Put your C code here */
  printf ("\n------------------------------------------------\n");
  printf ("EDMA File Generator Helper\n");
  printf ("(c) David Martnez Oliveira, May,2001\n");
  printf ("Version 0.0\n\n");

  if (argc!=3) {
    printf ("Parameter Number Incorrect. Usage:\n");
    printf ("\t./edma-fg-helper HELPER_CLASS output_file\n\n");
    EDMAEnd();
    exit(1);
  }

  strcpy (HelperClass,argv[1]);
  /* Quick hack for common files*/
  if (strcmp (HelperClass,"app_src")==0)
      strcpy (HelperClass,"EDMA_APP_SKEL_BUILDER");
  if (strcmp (HelperClass,"app_mk")==0)
    strcpy (HelperClass,"EDMA_MAKE_SKEL_BUILDER");

  printf ("+ Using Helper Class : %s\n",HelperClass);

  if ((id=NewObj (HelperClass,NULL))==-1) {
    EDMAEnd();
    exit(1);
  }
  
  if ((id1=NewObj ("CLASS_METADATA",NULL))==-1) {
    EDMAEnd();
    exit(1);
  }


  strcpy (ModuleName,argv[2]);
  aux=strchr(ModuleName,'.');
  *aux=0;
  WProp3 (id1,"ClassName",ModuleName);
  printf ("\n+ Generating File....");
  Met3(id,"build",id1,argv[2]);

  printf ("\n+ All Done!!");
  FreeObj(id);
  printf ("\n------------------------------------------------");
	/* Shutdown EDMA Suystem */
  EDMAEnd();
  return 0;
}
